commit d9a5d38e5cd1c5d50c77d6bcff707d040c43e4de
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:   Fri Aug 15 13:32:29 2025 -0400

    bump version to 2.17.2

M	CMakeLists.txt
M	MODULE.bazel
M	NEWS
M	configure.ac
M	src/gperftools/tcmalloc.h

commit 1b4eb9fb1180b2e20254b764e9da03a0bd0f47e7
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Aug 15 13:33:26 2025 -0400

    add BUILD.bazel to automake's EXTRA_DIST

M	Makefile.am

commit 86f938ab093a949d5a683905d706cb26a1a9c849
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Aug 14 18:26:09 2025 -0400

    proc_maps_iterator: unbreak reading /proc/self/maps

    I recently added wrong code that attempted to detect and handle too
    long lines. But this code was never actually tested.

    On NetBSD PATH_MAX is relatively short, just 1k bytes and we're
    actually able to hit that (wrong) check. So we failed
    proc_maps_iterator_test there.

    This commit extracts ForEachLine logic into separate header, adds
    tests, exercises all cases and actually fixes the "line is too long"
    case.

M	.gitignore
M	CMakeLists.txt
M	Makefile.am
A	src/base/for_each_line.h
M	src/base/proc_maps_iterator.cc
A	src/tests/for_each_line_test.cc

commit 377e15e62598eb36c7068cb7f5476c4ab582de2d
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Aug 15 13:03:44 2025 -0400

    bazel: rename BUILD -> BUILD.bazel

    Some filesystems are case-insensitive and people commonly prefer
    build/ as a directory for out-of-tree builds (e.g. with cmake).

R100	BUILD	BUILD.bazel

commit a726aebea95f473e0e8008922c78acd424af9dbb
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Aug 15 12:55:14 2025 -0400

    proc_maps_iterator_test: put variable to .data, not .bss

    On FreeBSDs we used PHDRs to synthesize mappings, but PHDRs don't
    cover .bss. I am not sure how the test passed previously, but I see it
    fail at least now on FreeBSD 13. Putting variable into .data section,
    by initializing it, should make test more robust.

M	src/tests/proc_maps_iterator_test.cc

commit c80a9a6b7d678e11be5df5113aa73f687ea381a9
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Aug 14 15:48:10 2025 -0400

    tcmalloc_unittest: un-flake the large allocs release test

    FreeBSD mmap sys-allocator is behaving "randomly" enough that old
    logic wasn't triggering the right sequences of addresses.

    So I had to rework the test a bit to actually ensure that we're
    allocating used/free addressess one exactly after the other.

    I also previously added stupid duplicate release rate reset, which was
    already there, but I was somehow blind enough not to spot it just 1
    line below! So this is removed.

    And this entire test is now separate function with hopefully helpful
    comments about what we're trying to achieve.

    Updates github #1604 and #1574

M	src/tests/page_heap_test.cc
M	src/tests/tcmalloc_unittest.cc

commit 94fb7079614bcefff23be52b4988c2381a9c31bc
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Aug 13 15:37:07 2025 -0400

    bump version to 2.17.1

M	CMakeLists.txt
M	MODULE.bazel
M	NEWS
M	configure.ac
M	src/gperftools/tcmalloc.h

commit 2d277134c4b5c56d1c2912330aa44160af52aadf
Author: graysky <therealgraysky AT proton DOT me>
Date:	Thu Aug 7 02:35:01 2025 -0400

    stacktrace_libgcc-inl.h: fix build for some ARM toolchains

    On OpenWrt when bulding for arm_cortex-a15_neon-vpfv4 or
    arm_cortex-a9_vfpv3-d16, the build errors out due to an undefined
    symbol
    _URC_NORMAL_STOP. This usually happens when the required header
    (typically <unwind.h>) is not included, or the toolchain's unwind
    implementation does not provide this definition.

    Error:
    src/stacktrace_libgcc-inl.h: In function '_Unwind_Reason_Code
    libgcc_backtrace_helper(_Unwind_Context*, void*)':
    src/stacktrace_libgcc-inl.h:69:12: error: '_URC_NORMAL_STOP' was
    not declared in this scope
       69 |	return _URC_NORMAL_STOP;
	  |

    A work-around is to use URC_END_OF_STACK.

    Signed-off-by: graysky <therealgraysky AT proton DOT me>

M	src/stacktrace_libgcc-inl.h

commit 742e4e29c497a2780a4e7d02516b8c5e80978abd
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Aug 4 20:25:44 2025 +0100

    bump version to 2.17

M	CMakeLists.txt
M	MODULE.bazel
M	NEWS
M	configure.ac
M	src/gperftools/tcmalloc.h

commit 32f11cb4b777880f7ecff3edcb5bc04fd6f1dff1
Author: Jackie Cui <cui_jc@163.com>
Date:	Sat Jul 26 17:41:42 2025 +0800

    preferring normal spans to returned spans in PageHeap::AllocLarge

    Signed-off-by: Aliaksei Kandratsenka <alkondratenko@gmail.com>
    [alkondratenko@gmail.com: unflaked the test change]

M	src/page_heap.cc
M	src/tests/page_heap_test.cc
M	src/tests/tcmalloc_unittest.cc

commit 6b63d71bf5b7bf4023f2361c1a6a7346db466b1e
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Aug 3 20:00:02 2025 +0100

    tcmalloc_unittest: disable "normal" release in ReleaseToSystem test

    It could potentially flake the test.

M	src/tests/tcmalloc_unittest.cc

commit 940be25e1c5d12d776654670c38a994b2053da0c
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Aug 2 14:14:27 2025 -0400

    bazel:mark gtest dependency as development

M	MODULE.bazel

commit 338e906eaec5cd136f392fe81d533935aafb0777
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jul 21 20:48:21 2025 -0400

    proc_maps_iterator: refactor and fix

    There was really annoying clang warning (and IMHO bogus too) about
    unused StringToInteger specialization. We also got github issue #1600
    about slightly incorrect proc maps-like line formatting. Somehow I
    also left some TODOs and diagnostic codes. So this code needed some
    cleanup.

    I also noticed that Linux kernel actually uses unsigned numbers for
    inodes, so there is really no need to do parsing of int64_t-s.

M	src/base/proc_maps_iterator.cc
M	src/base/proc_maps_iterator.h

commit 25234ef72d914c1ad43cde7726cccbf8f39c9169
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jul 21 20:04:44 2025 -0400

    Revert "[proc_maps_iterator]: fix annoying clang warning"

    I don't really understand how, but some apple's clang thing fails on
    this code.

    This reverts commit a798cd37e26587f7bff72ecf1a4ea0bef1e3bae4.

M	src/base/proc_maps_iterator.cc

commit a798cd37e26587f7bff72ecf1a4ea0bef1e3bae4
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jul 21 19:02:13 2025 -0400

    [proc_maps_iterator]: fix annoying clang warning

    Looks like clang has some kind of heuristic detects unused template
    specialications defined in .cc file (not .h, because unused
    specializations are common). So lets avoid this warning by using
    C++-17 if-constexpr feature.

M	src/base/proc_maps_iterator.cc

commit 2b001ca54536a5272e12debc73ea5b901e65861c
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jul 21 18:45:49 2025 -0400

    ppc: drop unused stacktrace_powerpc-inl.h header

    When we merged 75b65f96b0bb44d70e0a461a03a3f8c928390283 which split
    original frame-poiner-ful PPC backtracer, we somehow failed to delete
    the original. All those years it was lying there unused.

D	src/stacktrace_powerpc-inl.h

commit a0c62293af4de2ecdeaa5e2d3ec4d8dd9da43dd6
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jul 21 18:41:03 2025 -0400

    ppc: implement a way to disable compilation of ppc backtracer

    Looks like at least on musl there are some issues with some ucontext
    defines. So lets at least make it possible to build stuff.

    See github issue #1602

M	src/stacktrace.cc

commit 15d5e70ca74c77b688871f8a79ea72a057547879
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Jun 5 12:32:00 2025 -0400

    osx:heap-profiler_unittest: workaround failure to hide _tc_newarray

    Recent pprof update fixed another issue in leading underscore handling
    on OSX, but that somehow broke built-in filtering out of tcmalloc
    symbols. So for now lets manually hide tc_newarray there while
    investigating proper fix upstream.

    pprof reference: https://github.com/google/pprof/pull/939

M	src/tests/heap-profiler_unittest.sh

commit 6e09b8446e69dcbb205274681298058372651f1a
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Apr 30 17:07:05 2025 -0400

    [stacktrace-libgcc] stop backtracing when reaching limit

    Sometimes we deal with very deeply recursive functions. In this case
    capturing backtraces via "libgcc" method was very slow as we
    "unwinded" every stack frame, much beyond what depth we're willing to
    actually capture. So lets fix it and stop when at the limit.

M	src/stacktrace_libgcc-inl.h

commit b2231683cc01ffbf090555f0e532c638b341e63c
Author: Salvatore Dipietro <dipiets@amazon.com>
Date:	Tue May 13 16:47:47 2025 -0700

    Adding 'sb' instruction to spin_delay() for ARM v8.5 onward

M	src/base/spinlock.cc

commit 83edb60836d87cf1b406e8846b9059c03031e8f5
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Feb 16 19:38:45 2025 -0500

    bump version to 2.17rc

M	CMakeLists.txt
M	MODULE.bazel
M	NEWS
M	configure.ac
M	src/gperftools/tcmalloc.h

commit 23268e84bc6e7c9af96e5cba7ef9a0b2e7f3a6e2
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Mar 6 16:57:00 2025 -0500

    tcmalloc_unittest: fix exit status propagation for sub-process tests

M	src/tests/tcmalloc_unittest.cc

commit 5591bfd83ce77d7da0c74860e0f4a7f8ee8519db
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Mar 5 21:13:20 2025 -0500

    ensure that heap-profiler_debug_unittest runs matching binary

M	src/tests/heap-profiler_unittest.sh

commit a81b2ebbc2cec046aed5d571cdc783c49b48843a
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Feb 17 11:49:39 2025 -0500

    put ATTRIBUTE_NOINLINE before function to unbreak MSVC

M	src/tcmalloc.cc

commit 9d40fae04162f993d8be6b8955074b7097f8dd32
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Feb 17 10:16:35 2025 -0500

    amputate all the ATTRIBUTE_SECTION stuff

    It was used to implement GetCallerStackTrace feature where it would
    skip frames up to and including first call to tcmalloc functions. But
    it was ~always ELF-specific and required gcc extensions. For some time
    we also supported OSX with this feature but, Apple broke it
    semi-recently.

    Having to be careful around ATTRIBUTE_SECTION stuff caused
    complexities and corner cases across code base (i.e. such as being
    careful with effects of various optimization/debugging switches). And
    so we'll now be able to remove those complications.

    This special ".text.google_malloc" section also could interfere
    with some
    optimizations. So not anymore.

    Now that we don't have heap checker anymore, we don't need this
    feature. We keep GetCallerStackTrace API for ABI compatibility, but it
    will now simply do regular backraces. pprof has always been able to
    filter out "tcmalloc" symbols by looking at tcmalloc:: namespace and
    few known tcmalloc symbols (tc_new etc). And for example our "heap
    profiler" and malloc sampling facilities never used this API
    anyways (and relied on pprof filtering out tcmalloc stack frames).

M	src/base/basictypes.h
M	src/base/logging.h
M	src/libc_override_osx.h
M	src/malloc_hook.cc
M	src/tcmalloc.cc

commit e5e040e20bebf65da03a299bbb7dcdccaaa720eb
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Feb 17 10:08:41 2025 -0500

    tcmalloc_unittest: unbreak waitpid headers on !Linux

M	src/tests/tcmalloc_unittest.cc

commit 492ede8654946be96f68a142d4e65220e10489c4
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Feb 17 09:54:35 2025 -0500

    stacktrace_unittest: ensure we always use right leaf_capture_fn

    We had silly mistake of subsequent test runs "inheriting" old value of
    leaf_capture_fn. And it caused failures on FreeBSD (issue #1581)
    because libunwind run that was supposed to test regular stack trace
    capturing was instead using CaptureLeafUContext function that is known
    to fail on that OS.

M	src/tests/stacktrace_unittest.cc

commit caedecb5169b28415cbf4f8334e943254e696f2c
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Feb 14 18:04:11 2025 -0500

    implement C23 free{_aligned}_sized functions

    As far as I can see, no libc-s ship those yet, however.

M	src/debugallocation.cc
M	src/gperftools/tcmalloc.h
M	src/libc_override_gcc_and_weak.h
M	src/libc_override_redefine.h
M	src/tcmalloc.cc
M	src/tests/tcmalloc_unittest.cc

commit f3c9bd56d85fc81b7309c1585b95e2a9aba9e4e0
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Feb 13 13:12:33 2025 -0500

    de-duplicate 2 forms for hidden visibility attribute

    Somehow, I managed to define both ATTRIBUTE_HIDDEN and
    ATTRIBUTE_VISIBILITY_HIDDEN and they're identical. Lets de-dup them at
    last.

M	src/base/basictypes.h
M	src/debugallocation.cc
M	src/emergency_malloc.cc
M	src/emergency_malloc.h
M	src/malloc_backtrace.cc
M	src/static_vars.h
M	src/system-alloc.h
M	src/tcmalloc.cc
M	src/tcmalloc_internal.h
M	src/testing_portal.h

commit 1b2fef16b795303f8c87594e8991711b37e4b885
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Feb 13 13:30:25 2025 -0500

    pacify "nullptr memcpy arg" condition in generic_writer.cc

M	src/base/generic_writer.cc

commit 1b9e9e0a2548a0e8d1d92d1ba269d3828a799dcc
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Feb 12 18:37:23 2025 -0500

    ci: add github-page workflow to publish asciidoc docs

A	.github/workflows/github-pages.yml

commit f87a119557890eaac6d5c959fb6d61cc229d5621
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Dec 31 18:57:09 2024 -0500

    entirely amputate perl pprof implementation

M	.gitignore
D	src/pprof

commit f235d15e0115d6ddf4cd29aad6e631215b768286
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Feb 11 19:23:59 2025 -0500

    update README and INSTALL docs

M	INSTALL
M	README

commit f5c1af1632b3b5117a3f51b94493caf3de445393
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Dec 31 18:54:47 2024 -0500

    update main README for recent-ish heap checker removal

M	README

commit 023376d651713f0e0a7aac5f8f86b42d0f5ef0de
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Dec 6 15:39:28 2024 -0500

    re-organize docs and convert htmls to asciidoc

M	.gitignore
M	Makefile.am
M	configure.ac
A	docs/cpuprofile-fileformat.adoc
D	docs/cpuprofile-fileformat.html
A	docs/cpuprofile.adoc
D	docs/cpuprofile.html
D	docs/designstyle.css
A	docs/dots/README
R100	docs/overview.dot	docs/dots/overview.dot
R100	docs/pageheap.dot	docs/dots/pageheap.dot
R100	docs/spanmap.dot	docs/dots/spanmap.dot
R100	docs/threadheap.dot	docs/dots/threadheap.dot
A	docs/heapprofile.adoc
D	docs/heapprofile.html
M	docs/index.html
D	docs/pprof.1
D	docs/pprof.see_also
A	docs/pprof_integration.adoc
D	docs/pprof_remote_servers.html
D	docs/t-test1.times.txt
D	docs/tcmalloc-opspercpusec.vs.threads.1024.bytes.png
D	docs/tcmalloc-opspercpusec.vs.threads.128.bytes.png
D	docs/tcmalloc-opspercpusec.vs.threads.131072.bytes.png
D	docs/tcmalloc-opspercpusec.vs.threads.16384.bytes.png
D	docs/tcmalloc-opspercpusec.vs.threads.2048.bytes.png
D	docs/tcmalloc-opspercpusec.vs.threads.256.bytes.png
D	docs/tcmalloc-opspercpusec.vs.threads.32768.bytes.png
D	docs/tcmalloc-opspercpusec.vs.threads.4096.bytes.png
D	docs/tcmalloc-opspercpusec.vs.threads.512.bytes.png
D	docs/tcmalloc-opspercpusec.vs.threads.64.bytes.png
D	docs/tcmalloc-opspercpusec.vs.threads.65536.bytes.png
D	docs/tcmalloc-opspercpusec.vs.threads.8192.bytes.png
D	docs/tcmalloc-opspersec.vs.size.1.threads.png
D	docs/tcmalloc-opspersec.vs.size.12.threads.png
D	docs/tcmalloc-opspersec.vs.size.16.threads.png
D	docs/tcmalloc-opspersec.vs.size.2.threads.png
D	docs/tcmalloc-opspersec.vs.size.20.threads.png
D	docs/tcmalloc-opspersec.vs.size.3.threads.png
D	docs/tcmalloc-opspersec.vs.size.4.threads.png
D	docs/tcmalloc-opspersec.vs.size.5.threads.png
D	docs/tcmalloc-opspersec.vs.size.8.threads.png
A	docs/tcmalloc.adoc
D	docs/tcmalloc.html

commit ddfa828b3f860ac3462781ae84786513a74aa79d
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Feb 11 15:01:53 2025 -0500

    ci: apt update before running apt install

    So that slightly out-of-date package versions don't fail to be
    installed.

M	.github/workflows/ci.yml

commit 2553bbb57c9d3fb48d3df9491ba97ddae2921cfd
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Feb 11 13:06:44 2025 -0500

    correctly depend on libunwind in our pkg-config files

    I.e. so that pkg-config --static thingy has chance of working.

M	Makefile.am
M	configure.ac

commit b577c2aa79c7f413529b148e047a09fa62eaae20
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Feb 6 10:44:29 2025 -0500

    generic-config: enable use of _Unwind_Backtrace in more configs

    I.e. clang's libunwind and such seems okay-ish.

M	generic-config/config.h

commit f86bf0b0e68a72aec8961a71cc23269fd0c0c697
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Feb 5 14:48:23 2025 -0500

    allow getting/setting sample parameter via {Get,Set}NumericProperty

M	src/tcmalloc.cc

commit 457ed6f6e68bfdcd6b440faefbe4fdbfa3c29a0a
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Feb 3 18:16:44 2025 -0500

    disable memory allocation API overrides under sanitizers

M	src/libc_override.h

commit 4f8769d300f0019736b50472886b09a3f6ae059e
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Feb 3 18:08:26 2025 -0500

    generic-config: fetch __GLIBC__ define from features.h header

    Turns out __GLIBC__ define isn't some sort of pre-defined thing, but
    is defined in features.h. So lets get it.

M	generic-config/config.h

commit 00056433394e526cd15b42b09c1c763e3bf66ec6
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Feb 3 18:21:19 2025 -0500

    stop detecting cfree at configure time

    There is simply no need anymore.

M	CMakeLists.txt
M	cmake/config.h.in
M	configure.ac
M	generic-config/config.h
M	src/tcmalloc_internal.h
M	vsprojects/include/config.h

commit 8978c60c8a2bb8c82b8fdc893818eccdaf0486a4
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Feb 3 17:19:24 2025 -0500

    don't test cfree

    cfree is ancient compat thing. It is missing in modern glibcs too. We
    still provide it (to keep ABI compat), but there is no need to
    exercise it in tests.

M	src/tests/tcmalloc_unittest.cc

commit 5b9a7b359ba340dd1d90323362ca942f5d81282b
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Feb 1 14:18:27 2025 -0500

    tcmalloc_unittest: unbreak sub-process spawning on windows

    Turns out spawnve (which is part of ucrt) has a bug. They have some
    sort of seemingly undocumented thing where current working
    directory (or maybe history of working directories) is preserved in
    special format inside environment block. And spawnve tries to copy it
    and fails to account for possibility of not having this
    stuff.

    https://github.com/huangqinjin/ucrt/blob/d6e817a4cc90f6f1fe54f8a0aa4af4fff0bb647d/exec/cenvarg.cpp#L136

    Apparently when bazel runs tests it clears environment so there is
    nothing to be found and so their naive loop does past-malloced-block
    access and crashes.

    We avoid the it by using somewhat more direct CreateProcessA API.

M	src/tests/tcmalloc_unittest.cc

commit d3743e698d46949c00e515bb8376b0eee13463b5
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Jan 31 17:56:55 2025 -0500

    bazel: make it 'work' on windows and osx

    Finally I figured out how to use @platforms thingy and so we're able
    to mark a bunch of non-windows targets as such. So that
    bazel test :all works on windows (by skipping incompatible targets).

    Building and testing on OSX was also fixed. For some reason bazel
    passes compiler flags to target very old OSX version that lacks even
    basic C++17 features. Thankfully, there is a semi-sensible way to fix
    it too.

A	.bazelrc
M	BUILD
M	MODULE.bazel
M	Makefile.am

commit f1450529893eaa43e9ac990b9e60304765f76b50
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Feb 1 13:57:19 2025 -0500

    tcmalloc_unittest: explicitly spawn+wait for sub-variant processes

    We had somewhat "simpler" approach of each variant running all tests,
    then exec-ing into next variant. But windows doesn't have exec. So we
    simulated by spawn+wait. But somehow under bazel it didn't
    work (perhaps hitting some sandbox limits). So lets unify everything
    and have top-level process do a loop of spawn+waits.

M	src/tests/tcmalloc_unittest.cc

commit 17b772bd9f3e954fedbf1ea354d5ee87f8443b1b
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Jan 31 16:35:04 2025 -0500

    ci: upload right cmake test logs

M	.github/workflows/ci.yml

commit 73e38d7a617182eadc2e74191e1258b85225c635
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Jan 24 12:43:12 2025 -0500

    add basic experiment bazel support

A	BUILD
A	MODULE.bazel
M	Makefile.am
M	src/base/basictypes.h

commit 477be4dd4ff447c93fa786dd52c7024f63297038
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Jan 26 10:05:34 2025 -0500

    introduce "generic" config.h header

    This contains roughly same defines as autotools-produced config.h, but
    it checks headers with GCC-specific tests and it checks some features
    by inspecting known platform defines (i.e. like __GLIBC__). So by
    definition it supports fewer platforms, but it is "good enough" for
    commonly used ones. It is to be used in our bazel support (and maybe
    more later).

M	Makefile.am
A	generic-config/config.h

commit aefaa35d7b190957b81b9d004d5cdccb2eeca68b
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Jan 31 10:30:49 2025 -0500

    ci: manage build directory separately from source checkout

    I don't quite understand what I am doing and why. But cmake builders
    all started failing couple days ago, failing to create something under
    build directory (which we assumed cmake would create under source
    checkout directory).

    I found that other guys do this runner.workspace thingy, which is
    apparently distinct from checkout. And I made it work somehow.

M	.github/workflows/ci.yml

commit fba0796aff2822fe224b4f7037377d166c8fabe0
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jan 27 21:10:31 2025 -0500

    made run_benchmark and malloc_bench work on windows

M	Makefile.am
M	benchmark/malloc_bench.cc
M	benchmark/run_benchmark.cc

commit 23da38622dc6302206579f1c42afa1145724aa4c
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jan 27 21:09:45 2025 -0500

    mass replace WIN32 -> _WIN32

    Apparently, "plain" WIN32 has been wrong for a while. _WIN32 is the
    right one.

M	cmake/config.h.in
M	configure.ac
M	src/memmap.h

commit c7d2d7045fb930aef704ec673251bc38042324d6
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Jan 24 18:26:52 2025 -0500

    simplify away writing of tcmalloc.h from tcmalloc.h.in

    We had some degree of mess caused by need to duplicate tcmalloc.h for
    windows and non-windows and caused by duplication of rewriting logic
    between cmake stuff and autotools stuff.

    We only need it to handle availability of mallinfo stuff, which we're
    able to mostly detect by looking at various libc defines.

    And we need it for the version defines. Which we were already
    partially hardcoding for each version bump anyways. So we simply add a
    test that version hardcoded in tcmalloc.h header is the same as in our
    autoconf bits.

M	.github/workflows/ci.yml
M	CMakeLists.txt
M	Makefile.am
D	cmake/tcmalloc.h.in
M	configure.ac
R088	vsprojects/include/gperftools/tcmalloc.h
src/gperftools/tcmalloc.h
D	src/gperftools/tcmalloc.h.in
M	src/tcmalloc.cc
M	src/tests/tcmalloc_unittest.cc

commit e9b3d4a5ae51d8322edb48e777d6067818b3148d
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Jan 25 15:20:12 2025 -0500

    Reapply "detect pprof at configure time and skip relevant tests"

    This reverts commit 49ee3cebdc8dd4eea1140df56c0f192e684f12cb.

M	Makefile.am
M	configure.ac

commit ae742a58cbaf692b046afaf1d5ef01fb47df326a
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Jan 25 15:20:10 2025 -0500

    Reapply "use system's pprof"

    This reverts commit b5fe0ed7bfaaa9544a56a8b5b31a5dbf4cb8e560.

M	CMakeLists.txt
M	Makefile.am
M	src/tests/heap-profiler_unittest.sh
M	src/tests/profiler_unittest.sh
M	src/tests/sampling_test.cc

commit 1dcf290ca3bfb998cea0e1fff472111ff307ce7b
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Jan 19 10:48:22 2025 -0500

    wip: request stable go version

M	.github/workflows/ci.yml

commit 75f0af7b79ffc3118fbee9cc91b9b6dee3956b1f
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Jan 19 10:44:50 2025 -0500

    wip: enable pprof on CI workers

M	.github/workflows/ci.yml

commit 0576523a6028626a7760dabf591c6713d6f69d73
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Jan 21 12:05:04 2025 -0500

    disable "broken" cmake install target by default

M	CMakeLists.txt

commit 5a6539130dc240091461222e56e9a6896942f82e
Author: Alex Faxa <alexanderfaxa@google.com>
Date:	Thu Jan 16 13:21:29 2025 +0000

    Add CMake install TARGETS support.

M	CMakeLists.txt

commit b5fe0ed7bfaaa9544a56a8b5b31a5dbf4cb8e560
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Jan 21 11:30:32 2025 -0500

    Revert "use system's pprof"

    This reverts commit 606059d9185a7f4c061f6889afa2a9d0ee4e99d3.

    Currenly "mainline" pprof fails at demangling on OSX, so lets revert
    temporarily.

M	CMakeLists.txt
M	Makefile.am
M	src/tests/heap-profiler_unittest.sh
M	src/tests/profiler_unittest.sh
M	src/tests/sampling_test.cc

commit 49ee3cebdc8dd4eea1140df56c0f192e684f12cb
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Jan 21 11:32:03 2025 -0500

    Revert "detect pprof at configure time and skip relevant tests"

    This reverts commit 3219749e766714af1e4e6d7bf284cee65cc777c1.

    Currenly "mainline" pprof fails at demangling on OSX, so lets revert
    temporarily.

M	Makefile.am
M	configure.ac

commit e43f3d258767b85f93b48ff927bb9f375856fdee
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Jan 18 13:27:41 2025 -0500

    [windows] handle patching functions that start with endbr{32,64}

    This unbreaks gperftools on mingw ucrt as shipped by debian sid.

M	src/windows/preamble_patcher_with_stub.cc

commit 3219749e766714af1e4e6d7bf284cee65cc777c1
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Nov 24 17:52:53 2024 -0500

    detect pprof at configure time and skip relevant tests

M	Makefile.am
M	configure.ac

commit 606059d9185a7f4c061f6889afa2a9d0ee4e99d3
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Nov 24 17:06:10 2024 -0500

    use system's pprof

M	CMakeLists.txt
M	Makefile.am
M	src/tests/heap-profiler_unittest.sh
M	src/tests/profiler_unittest.sh
M	src/tests/sampling_test.cc

commit 6eea08bc2a8dd9e419ba91fd6911a5049f3c6afd
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Nov 24 15:13:25 2024 -0500

    stop installing perl pprof

M	Makefile.am
M	configure.ac

commit caf3517aa21307e10169f19e34a5ec3f289661bb
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Nov 24 14:59:56 2024 -0500

    made shell script profiling tests compatible with go pprof

M	src/tests/heap-profiler_unittest.sh
M	src/tests/profiler_unittest.sh

commit 84063ad286ae338f3b77e5abc9dec296b13d7304
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Dec 31 00:21:35 2024 -0500

    [libbacktrace-integration] handle xcoff format for AIX

M	vendor/libbacktrace-integration/file-format.c

commit 733e4e0341d14ac0f730ce4b15084b6665642c77
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Dec 30 23:47:21 2024 -0500

    update README about removal of heap checker

M	README

commit 48cd242aadc544b2c8086247cf8ca8c4528e52a7
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Jan 12 17:05:28 2025 -0500

    don't patch libtool anymore

    The fix is now upstream and shipping with Debian Sid.

M	autogen.sh
D	m4/libtool.patch

commit ab499855dc9477834ca88cae585befb8fa15fe95
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Nov 24 13:57:57 2024 -0500

    bump vendor/libbacktrace to d48f84034ce3e53e5

    Which is latest as of Nov 24 2024

M	vendor/libbacktrace/README.md
M	vendor/libbacktrace/dwarf.c
M	vendor/libbacktrace/macho.c

commit c4120da88e9efdec7c9cd89c8642b07b8a7d6f5f
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Nov 23 13:36:47 2024 -0500

    modernize and fix SpanSet iterator handling

    In addition to just being more readable, we fix github issue #1573
    "Unable to build gperftools with _GLIBCXX_DEBUG flag".

M	src/page_heap.cc
M	src/span.h

commit e9fbbf94508cd71bb023802af1c3c3ec5b05fb2f
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Oct 15 20:58:26 2024 -0400

    update comment for fixed fork testing of ManyThreads

M	src/tests/tcmalloc_unittest.cc

commit 8f74e39c00f2a85b04b75378164490309397b310
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Oct 15 20:50:46 2024 -0400

    have fork torturing print total number of forks made

M	src/tests/tcmalloc_unittest.cc

commit 6f7f81b6993d26f1df2d970b258dc8e46becc7a7
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Oct 15 20:39:34 2024 -0400

    [tcmalloc_unittest] don't disable threaded test for fork torturing

    We now detect "SIGTRAP is blocked" case and handle it properly. This
    enables us to run pthread_create. So there is no more need to disable
    ManyThreads test.

    Note, we're not propagating single-stepping mode into child threads,
    so we're still only fork-testing main thread, but that should be
    plenty good for now. I.e. merely not crashing on pthread_create
    anymore when fork torturing is enabled.

M	src/tests/tcmalloc_unittest.cc

commit 2e6061d07a542c2afd59a8983597fbf2bafd5f08
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Oct 8 18:39:32 2024 -0400

    function_ref: enable construction from pair of function and data

M	src/base/function_ref.h

commit 3f04893eeec41ad2887799b7f79aa5b5a4e9b611
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Oct 8 18:33:37 2024 -0400

    unbreak tcmalloc::FunctionRefFirstDataArg

M	src/base/function_ref.h
M	src/tests/function_ref_test.cc

commit 8560276997c61ee44af9493feebf6946509f79a6
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Oct 15 17:47:45 2024 -0400

    have atfork handler also handle SlowTLS and SysAllocator locks

    Referenced github issue #1570 and github issue #1425

    This enables "minimal" allocator to pass fork torture testing.

M	src/static_vars.cc
M	src/system-alloc.cc
M	src/system-alloc.h
M	src/thread_cache_ptr.cc
M	src/thread_cache_ptr.h
M	src/windows/system-alloc.cc

commit dd043fefb971fef1e2af75ecde6ab34b0a84d8e8
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Oct 15 17:45:32 2024 -0400

    implement fork torture testing

    I.e. so that we can exercise malloc in forked child.

    Referenced github issue #1570 and github issue #1425

M	src/tests/tcmalloc_unittest.cc

commit 6e4984bc1bc23b837c677fe4135000c41881a76d
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Oct 5 17:53:00 2024 -0400

    [symbolize] generalize API and implementation

M	src/symbolize.cc
M	src/symbolize.h

commit 03d361bff804f8deff130d72524bbd635b701d31
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Oct 5 17:47:22 2024 -0400

    [debugallocation_test] simplify diagnosing backtrace dumping test

    I.e. by having TCM_DEBUG_BT_SYMBOLIZATION_TEST that disables death
    test and just runs "death" actions directly. So that someone can gdb
    symbolization part.

M	src/tests/debugallocation_test.cc

commit fe5127bac579319f5b1862f2555b0f71e5c030e2
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Oct 5 10:55:00 2024 -0400

    dont include useless .deps directories into make dist archives

    We do arguably a bit reckless thing with simply packaging entire
    vendor/ subdirectory and that gives us some crap. But for now this is
    what we'll do and we'll simply remove that "crap" as part of packaging
    step.

M	Makefile.am

commit 99da87d086c2d211180e9840aa4360f1e0465f98
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Oct 5 11:02:21 2024 -0400

    unbreak compilation on gcc-7

M	vendor/libbacktrace-integration/backtrace-alloc.cc

commit 1f7f60d5c28bee75b2792b8dfd8bd7343c7095bf
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Oct 5 10:40:24 2024 -0400

    [low_level_alloc_unittest] fix lack of override specifier

    As correctly warned by clang.

M	src/tests/low_level_alloc_unittest.cc

commit a836930deb2fbfcfbbd90f5ca2a55119cded77f2
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Oct 4 18:15:15 2024 -0400

    [symbolize] call backtrace_syminfo when pcinfo fails

    This is how we need to deal with symbols without line numbers debug
    info. It unbreaks for example _start symbolization.

    We also refactor the code some and we run symbolization with
    emergency malloc mode enabled.

M	src/debugallocation.cc
M	src/libbacktrace_api.h
M	src/symbolize.cc
M	src/thread_cache_ptr.h

commit 9c8aeab54a3d1d6ec1ad90bfb586a8608729dd79
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Oct 4 19:03:27 2024 -0400

    [emergency_malloc] support GetAllocatedSize on emergency allocations

    This enables OSX to do usual malloc/free things in emergency malloc
    mode. We update unit tests accordingly (i.e. call free instead of
    tc_free when relevant).

M	src/base/low_level_alloc.cc
M	src/base/low_level_alloc.h
M	src/debugallocation.cc
M	src/emergency_malloc.cc
M	src/emergency_malloc.h
M	src/maybe_emergency_malloc.h
M	src/tcmalloc.cc
M	src/testing_portal.h
M	src/tests/tcmalloc_unittest.cc

commit d5055ef3a2093a655566e925c41ac3330bb2a64e
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Oct 2 17:05:39 2024 -0400

    new symbolize api and implementation

    This is part of effort to get rid of perl pprof dependency. We're
    replacing forking to pprof --symbols with carefully crafted
    libbacktrace integration which has enough support for symbolizing
    backtraces.

M	.gitignore
M	CMakeLists.txt
M	Makefile.am
M	cmake/config.h.in
M	configure.ac
M	src/base/low_level_alloc.h
M	src/debugallocation.cc
A	src/libbacktrace_api.h
M	src/symbolize.cc
M	src/symbolize.h
M	src/tests/debugallocation_test.cc
M	vendor/README.vendor
A	vendor/libbacktrace-integration/backtrace-alloc.cc
A	vendor/libbacktrace-integration/backtrace-supported.h
A	vendor/libbacktrace-integration/config.h
A	vendor/libbacktrace-integration/file-format.c
M	vsprojects/include/config.h

commit 96885311f3d9f756ecf3ac7d86767c22666b79b9
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Oct 2 19:24:41 2024 -0400

    add vendor/libbacktrace

M	vendor/README.vendor
A	vendor/libbacktrace/.gitignore
A	vendor/libbacktrace/Isaac.Newton-Opticks.txt
A	vendor/libbacktrace/LICENSE
A	vendor/libbacktrace/Makefile.am
A	vendor/libbacktrace/Makefile.in
A	vendor/libbacktrace/README.md
A	vendor/libbacktrace/aclocal.m4
A	vendor/libbacktrace/alloc.c
A	vendor/libbacktrace/allocfail.c
A	vendor/libbacktrace/allocfail.sh
A	vendor/libbacktrace/atomic.c
A	vendor/libbacktrace/backtrace-supported.h.in
A	vendor/libbacktrace/backtrace.c
A	vendor/libbacktrace/backtrace.h
A	vendor/libbacktrace/btest.c
A	vendor/libbacktrace/compile
A	vendor/libbacktrace/config.guess
A	vendor/libbacktrace/config.h.in
A	vendor/libbacktrace/config.sub
A	vendor/libbacktrace/config/enable.m4
A	vendor/libbacktrace/config/lead-dot.m4
A	vendor/libbacktrace/config/libtool.m4
A	vendor/libbacktrace/config/ltoptions.m4
A	vendor/libbacktrace/config/ltsugar.m4
A	vendor/libbacktrace/config/ltversion.m4
A	vendor/libbacktrace/config/lt~obsolete.m4
A	vendor/libbacktrace/config/multi.m4
A	vendor/libbacktrace/config/override.m4
A	vendor/libbacktrace/config/unwind_ipinfo.m4
A	vendor/libbacktrace/config/warnings.m4
A	vendor/libbacktrace/configure
A	vendor/libbacktrace/configure.ac
A	vendor/libbacktrace/dwarf.c
A	vendor/libbacktrace/edtest.c
A	vendor/libbacktrace/edtest2.c
A	vendor/libbacktrace/elf.c
A	vendor/libbacktrace/fileline.c
A	vendor/libbacktrace/filenames.h
A	vendor/libbacktrace/filetype.awk
A	vendor/libbacktrace/install-debuginfo-for-buildid.sh.in
A	vendor/libbacktrace/install-sh
A	vendor/libbacktrace/instrumented_alloc.c
A	vendor/libbacktrace/internal.h
A	vendor/libbacktrace/ltmain.sh
A	vendor/libbacktrace/macho.c
A	vendor/libbacktrace/missing
A	vendor/libbacktrace/mmap.c
A	vendor/libbacktrace/mmapio.c
A	vendor/libbacktrace/move-if-change
A	vendor/libbacktrace/mtest.c
A	vendor/libbacktrace/nounwind.c
A	vendor/libbacktrace/pecoff.c
A	vendor/libbacktrace/posix.c
A	vendor/libbacktrace/print.c
A	vendor/libbacktrace/read.c
A	vendor/libbacktrace/simple.c
A	vendor/libbacktrace/sort.c
A	vendor/libbacktrace/state.c
A	vendor/libbacktrace/stest.c
A	vendor/libbacktrace/test-driver
A	vendor/libbacktrace/test_format.c
A	vendor/libbacktrace/testlib.c
A	vendor/libbacktrace/testlib.h
A	vendor/libbacktrace/ttest.c
A	vendor/libbacktrace/unittest.c
A	vendor/libbacktrace/unknown.c
A	vendor/libbacktrace/xcoff.c
A	vendor/libbacktrace/xztest.c
A	vendor/libbacktrace/zstdtest.c
A	vendor/libbacktrace/ztest.c

commit 94da1c10f9e8120895f61d4d51d2f520557f0109
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Oct 3 21:04:06 2024 -0400

    cleanup unused symbolize.cc from msvc project files

M	vsprojects/libtcmalloc_minimal/libtcmalloc_minimal.vcxproj
M	vsprojects/libtcmalloc_minimal/libtcmalloc_minimal.vcxproj.filters
M	vsprojects/page_heap_test/page_heap_test.vcxproj
M	vsprojects/page_heap_test/page_heap_test.vcxproj.filters

commit acb9f664608b02f0b0c289118b887e987e748cc1
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Oct 3 20:33:03 2024 -0400

    place LowLevelAlloc into tcmalloc namespace

M	src/base/low_level_alloc.cc
M	src/base/low_level_alloc.h
M	src/heap-profiler.cc
M	src/tests/low_level_alloc_unittest.cc

commit 40957460b560b19b1edb7ecc28d9cd9ed029dfb7
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Oct 3 17:24:57 2024 -0400

    [low_level_alloc] allocate Arena with custom allocator when provided

    This refactors API so that meta_data_arena isn't needed or used
    anymore. We always used nullptr for this argument anyways.

    We also change code so that PagesAllocator API is able to choose
    rounding up of allocation requests. It now returns pointer to
    allocated memory and it's rounded up size.

    And most important part of this change is that Arena instance itself
    is now allocated with provided allocator (when provided). This reduces
    locking depencies.

    We make sure to cover new logic by test.

M	src/base/low_level_alloc.cc
M	src/base/low_level_alloc.h
M	src/emergency_malloc.cc
M	src/heap-profiler.cc
M	src/tests/low_level_alloc_unittest.cc

commit d0d4363a343aaad2ebae9a5284edce4df4cfc8bb
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Oct 3 17:06:22 2024 -0400

    structure low_level_alloc as own convenience archive

M	CMakeLists.txt
M	Makefile.am

commit 3c261d90905dc6e0cd71adc56a8df6d6520da936
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Oct 3 16:32:13 2024 -0400

    stop linking malloc_hooks to low_level_alloc

M	CMakeLists.txt
M	Makefile.am
M	src/base/low_level_alloc.cc
M	src/tests/low_level_alloc_unittest.cc

commit 2e1799aa78192df1a916be38f5fb0819857cce3e
Author: Andrey Semashev <Lastique@users.noreply.github.com>
Date:	Thu Oct 3 18:24:54 2024 +0300

    Fix gcc 10 compilation error

    Apparently, gcc 10 doesn't support trailing return types for lambdas
    with an attribute.

    ```
    src/tests/sampling_test.cc: In lambda function:
    src/tests/sampling_test.cc:70:56: error: expected '{' before '->'
    token
       70 |   auto local_noopt = [] (void* ptr) ATTRIBUTE_NOINLINE ->
       void* {
	  |							   ^~
    src/tests/sampling_test.cc: In function 'void* AllocateAllocate()':
    src/tests/sampling_test.cc:70:56: error: base operand of '->' has
    non-pointer type 'AllocateAllocate()::<lambda(void*)>'
    src/tests/sampling_test.cc:70:59: error: expected unqualified-id
    before 'void'
       70 |   auto local_noopt = [] (void* ptr) ATTRIBUTE_NOINLINE ->
       void* {
	  |							      ^~~~
    ```

    Remove the trailing return type as it is deduced from the `noopt`
    call anyway.

M	src/tests/sampling_test.cc

commit c7dcabf09a29ce2a4975da3b897501904a2a328e
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Oct 2 18:49:44 2024 -0400

    [proc_maps_iterator_test] handle unknown PT_XYZ defines

M	src/tests/proc_maps_iterator_test.cc

commit fdbf9833ab007f244f6da3a9611b98caa0dca2ec
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Sep 30 12:57:12 2024 -0400

    [proc_maps_iterator] add implementation on top of dl_iterate_phdr

    And unbreak on it FreeBSD.

    Turns out not only they don't mount procfs by default, their
    /proc/pid/map fails to supply mapping offsets. Without offsets all the
    hope is lost.

M	src/base/proc_maps_iterator.cc
M	src/heap-profiler.cc

commit d88234711987e0a015e9c9acfa011a3172958aec
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Oct 2 17:09:08 2024 -0400

    [proc_maps_iterator_test] print all elf program headers

    I.e. to match with what proc maps iterator did.

M	src/tests/proc_maps_iterator_test.cc

commit d20ae0c8d86818855541bac7f1aeba3aa545fda8
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Sep 30 20:24:55 2024 -0400

    move GetProgramInvocationName into sysinfo

M	src/base/sysinfo.cc
M	src/base/sysinfo.h
M	src/symbolize.cc

commit 6fee38e5e730d24deb41f1e258be20d7084371a1
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Sep 29 14:01:18 2024 -0400

    build symbolizer stuff only for debug allocator

    Since it is now the only place that uses it

M	CMakeLists.txt
M	Makefile.am

commit 0f8cb8416ec0f8021bdc00613b220b2773646d96
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Sep 30 12:23:52 2024 -0400

    [sampling_test] print errno when mkstemp fails

    I see rare occasional failures there, which look very odd. Typically
    both sampling and sampling_debug tests fail at about the same time. So
    hopefully we can diagnose them sometime.

M	src/tests/sampling_test.cc

commit 9d58d03fa45e474e04e271bb3d48dfeaa252b4d6
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Sep 30 12:23:28 2024 -0400

    set default cmake build type to RelWithDebInfo

    Which is the only sensible default. Should have been upstream default,
    really.

M	CMakeLists.txt

commit feb43df6aee35f71b05aac839563d5a58031ad09
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Sep 29 13:57:46 2024 -0400

    remove some unused includes

M	src/heap-profile-table.cc
M	vsprojects/libtcmalloc_minimal/libtcmalloc_minimal.vcxproj
M	vsprojects/libtcmalloc_minimal/libtcmalloc_minimal.vcxproj.filters

commit d87c1a5c77d66843df99e2efced0e66d6b6b2bbb
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Sep 29 13:51:38 2024 -0400

    amputate HeapProfileTable::Snapshot

    Those are remains of heap checker.

M	src/heap-profile-table.cc
M	src/heap-profile-table.h

commit 5035d10c854f4a0a11afb1bd5b2e197df6bc3348
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Sep 30 11:40:48 2024 -0400

    drop unused kStripFrames constant

M	src/heap-profile-table.cc

commit 1cfbc55fbf0ae178d4861568cbe95574aabbfba1
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Oct 2 16:14:14 2024 -0400

    [debugallocation_test] make death stack trace testing more rigorous

    I.e. make sure we actually have stack-trace at least up to actual
    allocation function, not just main().

M	src/tests/debugallocation_test.cc

commit 0aa7254ac9b9c8848147cb8f13f6477cd3581c21
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Oct 2 16:23:28 2024 -0400

    [debugallocation] grab entire stack trace of deletion

    We used GetCallerStackTrace thingy before, but it is not entirely
    reliable in it's detection of malloc stack frames (i.e. on OSX). So
    lets do full thing instead. Those stacktraces are to be printed to
    users anyways.

M	src/debugallocation.cc

commit 28c2853cbac4859c3ce01b55d9481ae7593d293c
Author: Andrey Semashev <Lastique@users.noreply.github.com>
Date:	Wed Oct 2 19:33:28 2024 +0300

    Avoid sampling_test failures

    Increase the upper bound of allocated memory amount to avoid test
    failures on Kubuntu 24.04.

    Fixes https://github.com/gperftools/gperftools/issues/1564.

M	src/tests/sampling_test.cc

commit a9a52320fc7200709920ccb0f8c8fbc744ceefc9
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Sep 27 21:57:41 2024 -0400

    drop a bunch of unnecessary "using std::XYX" declarations

M	src/central_freelist.cc
M	src/debugallocation.cc
M	src/heap-profile-table.cc
M	src/heap-profiler.cc
M	src/malloc_hook.cc
M	src/memfs_malloc.cc
M	src/profile-handler.cc
M	src/profiler.cc
M	src/symbolize.cc
M	src/symbolize.h
M	src/tcmalloc.cc
M	src/thread_cache.cc

commit b128b1557e9561e3eb24d829496b4e92babaf213
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Sep 27 22:20:08 2024 -0400

    unbreak profiler_unittest when linking statically

    When linking statically we may end up calling ProfilerGetCurrentState
    earlier than profiler is initialized. And we segfaulted on that early
    call. Lets make us handle this case gracefully.

M	src/profiledata.cc

commit f0bab33d2794b379a08be7a2607cd6177398f3cc
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Sep 27 17:46:48 2024 -0400

    do non-minimal cmake configuration for ci.yml

M	.github/workflows/ci.yml

commit 608e6d06255477a9b183e58b2a86a97ead8f921e
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Sep 27 17:34:36 2024 -0400

    unbreak cmake testing of heap-profiler

M	CMakeLists.txt

commit aaed4feb28d99bc05a9acc6ca7e66295f62a6b9a
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Sep 27 14:42:22 2024 -0400

    [heap-profiler] use regular stacktracing API

    Instead of MallocHook::GetCallerStackTrace.

    Thing is, GetCallerStackTrace isn't reliable beyond ELF systems, like
    OSX. And, yet, things just work without it for e.g. heap
    sampling. Why? Because pprof already knows how to exclude
    tcmalloc-internal stack frames (by looking at e.g. tcmalloc::
    namespace). So we do the same for heap profiler.

    This fixes heap profiling unit tests on OSX.

M	src/heap-profile-table.cc
M	src/heap-profile-table.h
M	src/heap-profiler.cc

commit c1e3eac0c67891e8538a13b6be07367851d572d6
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Sep 27 14:33:49 2024 -0400

    move Invoke*Hook stuff under tcmalloc namespace

    This will allow us to move heap profiling from
    MallocHook::GetCallerStackTrace into plain tcmalloc::GrabBacktrace
    thingy.

M	src/debugallocation.cc
M	src/gperftools/malloc_hook.h
M	src/malloc_hook-inl.h
M	src/malloc_hook.cc
M	src/tcmalloc.cc
M	src/windows/patch_functions.cc

commit d0724116cfce0b71c42bc793b2ba90e076447212
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Sep 27 14:30:01 2024 -0400

    drop a bunch of bogus private stuff from public malloc_hook.h

M	src/gperftools/malloc_hook.h
M	src/malloc_hook-inl.h
M	src/malloc_hook.cc

commit fc86294f9de455de3a11783af9cdd6b76d5949de
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Sep 26 19:19:02 2024 -0400

    add initial github actions CI

A	.github/workflows/ci.yml
A	.github/workflows/scripts/msvc-env.rb

commit f01510ccf2a085088808e673e03f4f2cdb0b5088
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Sep 27 00:02:50 2024 -0400

    make large_heap_fragmentation_unittest not as painful on windows

M	src/tests/large_heap_fragmentation_unittest.cc

commit 96e3eca05ec2a81d2fde5eb11ab4c9256be2d944
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Sep 26 14:58:40 2024 -0400

    amputate dead travis CI integration

D	.travis.yml

commit ff061b4de399b533feef71a4b83dc78e2051381f
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Sep 26 14:51:59 2024 -0400

    actualize AUTHORS

M	AUTHORS

commit 6a7419e39fb7c3a0c4769be0ca177e808df76ad3
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Sep 18 17:11:40 2024 -0400

    drop mmap_hook

M	.gitignore
M	CMakeLists.txt
M	Makefile.am
M	src/base/low_level_alloc.cc
M	src/emergency_malloc.cc
M	src/heap-profile-table.cc
M	src/heap-profiler.cc
M	src/malloc_hook.cc
A	src/memmap.h
D	src/mmap_hook.cc
D	src/mmap_hook.h
M	src/system-alloc.cc
D	src/tests/mmap_hook_test.cc
M
vsprojects/low_level_alloc_unittest/low_level_alloc_unittest.vcxproj
M
vsprojects/low_level_alloc_unittest/low_level_alloc_unittest.vcxproj.filters

commit 00d235325f6f21fc0e00f6e63145b377b5541681
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Sep 18 16:49:47 2024 -0400

    drop memory region map

M	CMakeLists.txt
M	Makefile.am
M	src/heap-profile-stats.h
D	src/memory_region_map.cc
D	src/memory_region_map.h

commit 07c30d12294a81c2a82fcc8da2df435139de5876
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Sep 18 16:43:13 2024 -0400

    amputate mmap heap profiling

    It wasn't entirely functional (i.e. see
    https://github.com/gperftools/gperftools/issues/1010 or
    https://github.com/gperftools/gperftools/issues/1458) and it's
    underlying mmap hooks facility introduces significant source
    portability complications. And since we've just dropped heap checker
    we can drop entire mmap hooks stuff too.

M	src/heap-profile-table.cc
M	src/heap-profile-table.h
M	src/heap-profiler.cc

commit b19a1999a4c909cfd269d39a4d882fb2833433d6
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Sep 17 19:52:35 2024 -0400

    amputate MallocHook_InitAtFirstAllocation_HeapLeakChecker logic

M	src/malloc_hook.cc
M	src/mmap_hook.cc
M	src/tests/mmap_hook_test.cc

commit 187b31e95209418a568f36da9a78f27022dbda40
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Sep 17 13:31:45 2024 -0400

    amputate heap checker

M	.gitignore
M	CMakeLists.txt
M	Makefile.am
M	configure.ac
D	docs/heap_checker.html
D	src/base/linuxthreads.cc
D	src/base/linuxthreads.h
M	src/gperftools/heap-checker.h
C050	src/testing_portal.h	src/heap-checker-stub.cc
D	src/heap-checker.cc
M	src/malloc_extension.cc
M	src/tcmalloc.cc
M	src/testing_portal.h
D	src/tests/heap-checker-death_unittest.sh
C051	src/testing_portal.h	src/tests/heap-checker-stub-test.cc
D	src/tests/heap-checker_unittest.cc
M	src/windows/port.h
M	vsprojects/page_heap_test/page_heap_test.vcxproj

commit 05692cc0579b06fb2d1bea3ede130bbf48b7c8c1
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Sep 17 13:02:38 2024 -0400

    drop unused windows/{addr2line,nm}-pdb

M	Makefile.am
M	README_windows.txt
M	gperftools.sln
M	src/pprof
M	src/windows/CMakeLists.txt
D	src/windows/addr2line-pdb.c
D	src/windows/nm-pdb.c
D	vsprojects/addr2line-pdb/addr2line-pdb.vcxproj
D	vsprojects/addr2line-pdb/addr2line-pdb.vcxproj.filters
D	vsprojects/nm-pdb/nm-pdb.vcxproj
D	vsprojects/nm-pdb/nm-pdb.vcxproj.filters

commit be755a8d3ca8ba36040b4839a16fd948b7fad47b
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Sep 17 12:29:07 2024 -0400

    mass-replace NULL -> nullptr

M	benchmark/binary_trees.cc
M	benchmark/run_benchmark.cc
M	cmake/tcmalloc.h.in
M	src/addressmap-inl.h
M	src/base/commandlineflags.h
M	src/base/elf_mem_image.cc
M	src/base/elf_mem_image.h
M	src/base/googleinit.h
M	src/base/linuxthreads.cc
M	src/base/logging.cc
M	src/base/logging.h
M	src/base/proc_maps_iterator.cc
M	src/base/spinlock_linux-inl.h
M	src/base/spinlock_posix-inl.h
M	src/base/sysinfo.cc
M	src/base/vdso_support.cc
M	src/base/vdso_support.h
M	src/central_freelist.cc
M	src/central_freelist.h
M	src/common.cc
M	src/common.h
M	src/debugallocation.cc
M	src/emergency_malloc.cc
M	src/gperftools/heap-checker.h
M	src/gperftools/malloc_extension.h
M	src/gperftools/malloc_hook.h
M	src/gperftools/profiler.h
M	src/gperftools/stacktrace.h
M	src/gperftools/tcmalloc.h.in
M	src/heap-checker.cc
M	src/heap-profile-stats.h
M	src/heap-profile-table.cc
M	src/heap-profile-table.h
M	src/heap-profiler.cc
M	src/libc_override_osx.h
M	src/linked_list.h
M	src/malloc_extension.cc
M	src/memfs_malloc.cc
M	src/memory_region_map.cc
M	src/memory_region_map.h
M	src/page_heap.cc
M	src/page_heap.h
M	src/page_heap_allocator.h
M	src/pagemap.h
M	src/profile-handler.cc
M	src/profiledata.cc
M	src/profiler.cc
M	src/span.cc
M	src/span.h
M	src/stack_trace_table.h
M	src/stacktrace_arm-inl.h
M	src/stacktrace_libgcc-inl.h
M	src/stacktrace_powerpc-darwin-inl.h
M	src/stacktrace_powerpc-inl.h
M	src/stacktrace_powerpc-linux-inl.h
M	src/static_vars.cc
M	src/symbolize.cc
M	src/symbolize.h
M	src/system-alloc.cc
M	src/system-alloc.h
M	src/tcmalloc.cc
M	src/tests/getpc_test.cc
M	src/tests/heap-checker_unittest.cc
M	src/tests/heap-profiler_unittest.cc
M	src/tests/malloc_extension_test.cc
M	src/tests/profile-handler_unittest.cc
M	src/tests/profiledata_unittest.cc
M	src/tests/profiler_unittest.cc
M	src/tests/realloc_unittest.cc
M	src/tests/tcmalloc_large_unittest.cc
M	src/tests/tcmalloc_unittest.cc
M	src/thread_cache.cc
M	src/thread_cache.h
M	src/windows/addr2line-pdb.c
M	src/windows/auto_testing_hook.h
M	src/windows/get_mangled_names.cc
M	src/windows/nm-pdb.c
M	src/windows/override_functions.cc
M	src/windows/patch_functions.cc
M	src/windows/port.cc
M	src/windows/port.h
M	src/windows/preamble_patcher.cc
M	src/windows/preamble_patcher.h
M	src/windows/preamble_patcher_test.cc
M	src/windows/preamble_patcher_with_stub.cc
M	src/windows/system-alloc.cc
M	vsprojects/include/gperftools/tcmalloc.h

commit 91b96b92a2bb8397c1ea81f284720cd7fbf837e3
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Sep 17 20:01:05 2024 -0400

    slightly saner malloc_hook_test implementation

M	src/tests/malloc_hook_test.cc

commit e1014dead2029b341d06027b4f2b5562d799d5b1
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Sep 25 18:25:20 2024 -0400

    bump version to 2.16

M	CMakeLists.txt
M	NEWS
M	configure.ac
M	vsprojects/include/gperftools/tcmalloc.h

commit b569be106c01e3814dafee57b619874c04cefda0
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Sep 25 17:32:46 2024 -0400

    [stacktrace_unittest] skip "from ucontext" case when not on glibc

    glibc carefully handles unwind info for signal trampoline stack frame,
    so even brittle "skip N frames" case works there. But e.g. on musl it
    doesn't.

    So lets skip this test on non-glibc systemsfor now, until we test
    things closer to how it is done by cpu profiler.

M	src/tests/stacktrace_unittest.cc

commit 6aecbbdb6b4545fb9d955be42491ed60b4ecf2c8
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Sep 25 17:11:02 2024 -0400

    unbreak heap checker unittest on systems without execinfo.h

    I.e. musl

M	src/tests/heap-checker_unittest.cc

commit 3cc9014c578463647fa3441b16ae99e6fd93d313
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Sep 23 13:45:45 2024 -0400

    make profiler_unittest less brittle

    So I noticed that profiler_unittest failed somewhat regularly on
    armhf. On inspection I found that it fails because the test compares
    "nested-most" tick counts between several profiles and we had most
    ticks inside inlined atomic ops functions and not test_main_thread.

    On the other hand, removing atomic ops from nested loop makes test way
    too fast for the modern quick x86 desktops.

    So lets make it try harder to be non-brittle. We do that by grabbing
    access to profiler's ticks count, which helps our inner loops to run
    long enough to get sufficient ticks count.

    We also do couple more minor updates.

    *) we have shell script use random temp directory name. Which allows
    us to exercise golang-stress and similar utils.

    *) we drop PERFTOOLS_UNITTEST and relevant code because this
    "variable" was always set to be true anyways.

M	src/profiledata.h
M	src/profiler.cc
M	src/tests/profiler_unittest.cc
M	src/tests/profiler_unittest.sh

commit dd751345df10a6f789356c2eb3e6f64eb6888ba5
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Sep 20 13:50:37 2024 -0400

    unbreak generic_fp frame skipping

    Sadly, we missed another issue there which is we returned negative
    frame counts whenever skip_count exceeded number of stack frames we
    had.

M	src/stacktrace_generic_fp-inl.h
M	src/tests/stacktrace_unittest.cc

commit e46b3e79aa129a4294ab571f173c7bedff0540b3
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Sep 19 18:52:27 2024 -0400

    make sampling_test more robust

    The test inspects "nested-most" frames in malloc sampling samples. And
    some compile options caused noopt to seen as call site of
    malloc. I.e. because noopt is immediately after malloc.

    To make things more robust we create local "copy" of noopt that is
    marked as noinline and so immediately next instruction after malloc is
    call to this local_noopt thingy, which makes test more robust since
    malloc stack trace will see that, as we expect, AllocateAllocate is
    what calls malloc.

M	src/tests/sampling_test.cc

commit 7803e80bb20437c43c2e95848b5298cf6ac083f6
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Sep 18 15:31:49 2024 -0400

    don't fail mmap_hook_test on mmap recursions

    Because some backtracing methods (which we invoke as part of calling
    mmap hooks) do use mmap themselves.

    Fixes github ticket #1558

M	src/tests/mmap_hook_test.cc

commit 74a7381cc966703a175d42b216b791a92612c9fb
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Sep 18 12:37:10 2024 -0400

    initialize tcmalloc's sample parameter at earliest opportunity

    I.e. so that correct value is available immediately, so that sampling
    is more precise.

    Update github ticket #1557.

M	src/sampler.cc
M	src/tests/sampler_test.cc

commit c2dc36d00dee260c7dd7bbc84614f62d12d5f832
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Sep 18 12:23:43 2024 -0400

    improve quality of sampling_test

    Part of this change is better diagnostic for when/if it fails. And
    most important part is compensating for the delay between sampling
    parameter is set for the test and when it is actually taken into
    account by thread cache Sampler logic.

    As a result about 1% of flaking probability has been fixed as we're
    getting mean estimate for the allocated size actually same (or about
    same) as allocated size.

    Update github ticket #1557.

M	CMakeLists.txt
M	src/tests/sampling_test.cc
M	vsprojects/sampler_test/sampler_test.vcxproj
M	vsprojects/sampler_test/sampler_test.vcxproj.filters

commit cefaaffeb4add313d5232c0aea363961035c2628
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Sep 17 20:37:23 2024 -0400

    fix compiler warning in malloc_hook_test

M	src/tests/malloc_hook_test.cc

commit 8899936b771fce275f5ab4907e42d65b5a1cae17
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Sep 16 20:41:11 2024 -0400

    fix warning in profile-handler unittest

    Clang kinda rightfully noticed that if FLAGS_test_profiler_enabled is
    false (and it never is false in practice), we'd be reading unitialized
    variables. Since this flag is never updated, we can simply drop those
    dead "false" paths.

M	src/tests/profile-handler_unittest.cc

commit 6b8962d797713cfc73c4791fd5f4a22d268ac53c
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Jun 14 22:57:17 2024 -0400

    bump version to 2.16rc

M	CMakeLists.txt
M	NEWS
M	configure.ac
M	vsprojects/include/gperftools/tcmalloc.h

commit 362938f1f743c971658d12e23176611550516497
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Sep 16 19:41:13 2024 -0400

    replace sprintf usage with snprintf

    Even though this specific usage is safe, it is, arguably, not great to
    be using sprintf in year 2024. snprintf is portable enough this
    days. Thanks goes to OSX headers that warn about sprintf loudly enough
    to be noticed.

M	src/malloc_extension.cc

commit 52735674708dfb5880111c15396b72894fcaa260
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Sep 16 19:03:58 2024 -0400

    [trivialre] fix past-end-of-string access in MatchSubstring

    Thanks goes to MSVC's string_view asserts that check this.

M	benchmark/trivialre.h
M	benchmark/trivialre_test.cc

commit 38abfd9038c4f193dd2b8ebbd0dca79cbcc9ab11
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Sep 16 18:38:35 2024 -0400

    make dist windows/CMakeLists.txt

M	Makefile.am

commit d5c94e0bd3ef876fb8d1ac40ebd6177e60b81144
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Sep 16 18:13:22 2024 -0400

    unbreak make dist for benchmark/trivialre.h

M	Makefile.am

commit e0844fa7991fc8564cb1f993ed3e1c75f55da987
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Sep 16 14:37:03 2024 -0400

    [low_level_alloc_unittest] cleanup unused variable usage

M	src/tests/low_level_alloc_unittest.cc

commit a4e2f950382c46cecc50e2ca1d735cb8b831de14
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Sep 16 13:11:23 2024 -0400

    [osx] unbreak EmergencyMallocNoHook test

    OSX's malloc zones stuff is essentially incompatible with emergency
    malloc. In order to handle it, our unit tests use tc_free directly in
    order to free memory allocated by emergency malloc. So lets keep doing
    it for our newer code that exercises calloc/free pair as well.

M	src/libc_override_osx.h
M	src/tests/tcmalloc_unittest.cc

commit 92fd07cc2fe8a9fcfff488063ee4d61140cc55df
Author: Aliaksei Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Sep 14 19:28:26 2024 -0400

    bump googletest version to latest

M	vendor/README.vendor
D	vendor/googletest/.github/workflows/gtest-ci.yml
M	vendor/googletest/BUILD.bazel
M	vendor/googletest/CMakeLists.txt
M	vendor/googletest/MODULE.bazel
M	vendor/googletest/README.md
M	vendor/googletest/WORKSPACE
M	vendor/googletest/ci/linux-presubmit.sh
M	vendor/googletest/ci/windows-presubmit.bat
M	vendor/googletest/docs/advanced.md
M	vendor/googletest/docs/gmock_cook_book.md
M	vendor/googletest/docs/gmock_for_dummies.md
M	vendor/googletest/docs/primer.md
M	vendor/googletest/docs/quickstart-bazel.md
M	vendor/googletest/docs/reference/mocking.md
M	vendor/googletest/docs/reference/testing.md
A	vendor/googletest/fake_fuchsia_sdk.bzl
M	vendor/googletest/googlemock/CMakeLists.txt
M	vendor/googletest/googlemock/include/gmock/gmock-actions.h
M	vendor/googletest/googlemock/include/gmock/gmock-matchers.h
M	vendor/googletest/googlemock/include/gmock/gmock-more-actions.h
M	vendor/googletest/googlemock/include/gmock/gmock-spec-builders.h
M
vendor/googletest/googlemock/include/gmock/internal/gmock-internal-utils.h
M	vendor/googletest/googlemock/include/gmock/internal/gmock-port.h
M	vendor/googletest/googlemock/src/gmock-cardinalities.cc
M	vendor/googletest/googlemock/src/gmock-internal-utils.cc
M	vendor/googletest/googlemock/src/gmock-matchers.cc
M	vendor/googletest/googlemock/test/gmock-actions_test.cc
M
vendor/googletest/googlemock/test/gmock-matchers-arithmetic_test.cc
M
vendor/googletest/googlemock/test/gmock-matchers-comparisons_test.cc
M
vendor/googletest/googlemock/test/gmock-matchers-containers_test.cc
M	vendor/googletest/googlemock/test/gmock-matchers-misc_test.cc
M	vendor/googletest/googlemock/test/gmock-more-actions_test.cc
M	vendor/googletest/googlemock/test/gmock-pp_test.cc
M	vendor/googletest/googlemock/test/gmock_link_test.h
M	vendor/googletest/googletest/README.md
M
vendor/googletest/googletest/include/gtest/gtest-assertion-result.h
M	vendor/googletest/googletest/include/gtest/gtest-death-test.h
M	vendor/googletest/googletest/include/gtest/gtest-param-test.h
M	vendor/googletest/googletest/include/gtest/gtest-typed-test.h
M	vendor/googletest/googletest/include/gtest/gtest.h
M
vendor/googletest/googletest/include/gtest/internal/gtest-death-test-internal.h
M
vendor/googletest/googletest/include/gtest/internal/gtest-filepath.h
M
vendor/googletest/googletest/include/gtest/internal/gtest-internal.h
M
vendor/googletest/googletest/include/gtest/internal/gtest-param-util.h
M
vendor/googletest/googletest/include/gtest/internal/gtest-port-arch.h
M	vendor/googletest/googletest/include/gtest/internal/gtest-port.h
M
vendor/googletest/googletest/include/gtest/internal/gtest-type-util.h
M	vendor/googletest/googletest/src/gtest-death-test.cc
M	vendor/googletest/googletest/src/gtest-internal-inl.h
M	vendor/googletest/googletest/src/gtest-port.cc
M	vendor/googletest/googletest/src/gtest.cc
M	vendor/googletest/googletest/test/googletest-color-test.py
M	vendor/googletest/googletest/test/googletest-death-test-test.cc
M
vendor/googletest/googletest/test/googletest-json-output-unittest.py
M	vendor/googletest/googletest/test/gtest_json_test_utils.py
M	vendor/googletest/googletest/test/gtest_unittest.cc
M	vendor/googletest/googletest_deps.bzl

commit ea35d14585746056e0f3542103a0f30619766cb2
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Sep 14 17:24:20 2024 -0400

    stop checking unused malloc_hook "subsection"

    Originally at Google they had to do 2 subsections for hookable
    functions because of some linking detais (in bazel infrastructure they
    still do different libraries as .so-s for tests). So "generic" hooks
    (such as mmap/sbrk) were in malloc_hook section and tcmalloc's
    were/are in google_malloc. Since those are different bazel/blaze
    libraries. And we kept this distinction simply because no-one bothered
    to undo it, despite us never needing it.

    We recently refactored mmap/sbrk hooking. And we don't use section
    stuff anymore for those hooks. And so there are no malloc_hook
    anymore. And so we were getting bogus and useless warnings about empty
    section. So lets avoid this.

M	src/gperftools/malloc_hook.h
M	src/malloc_hook.cc

commit fd09d89fcd9ded59c0a3142c703b8884c288eece
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Aug 18 15:28:56 2024 -0400

    [qnx] provide -lregex dependency for googletest

    For more context see:
    https://github.com/gperftools/gperftools/pull/1544

M	Makefile.am
M	configure.ac

commit a5d86777ceef8c0d76040f5540e446688a1dfa74
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Sep 13 13:59:41 2024 -0400

    [malloc_bench] add rnd_dependent_8cores benchmark

    This benchmark exercizes multi-threaded central free list operations,
    and this is where we're losing to a bunch of competing malloc
    (i.e. which
    shard heap).

M	benchmark/malloc_bench.cc

commit ea81e46ff146ad6d30330b0d7b650775ccd0d77d
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Sep 7 14:39:25 2024 -0400

    improve benchmarks facility

    We now support a set of command line flags similar to "abseil"
    benchmark thingy. I.e. to let people specify a subset of benchmarks or
    run them longer/shorter as needed.

    This commit also includes small, portable and very simple regexp
    facility. It isn't good enough for some production use, but it is
    plenty good for some testing uses or benchmark selection.

M	.gitignore
M	CMakeLists.txt
M	Makefile.am
M	benchmark/malloc_bench.cc
M	benchmark/run_benchmark.cc
M	benchmark/run_benchmark.h
A	benchmark/trivialre.h
A	benchmark/trivialre_test.cc
M	benchmark/unwind_bench.cc

commit 7fa0c2da537cee37609246feefb47c4fb5a551c5
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Sep 5 22:56:23 2024 -0400

    modernize malloc_bench

    Instead of relying on gperftools-specific tc_XYZ functions for sized
    deallocation and memalign we use standard C++ facilities. There are
    also other minor improvements like mallocing larger buffers rather
    than statically allocating them.

M	benchmark/malloc_bench.cc
M	benchmark/run_benchmark.cc

commit f46c141b4eaea3872c2bfc3974d1240ff16dd00b
Author: Olivier Langlois <olivier@trillion01.com>
Date:	Sun Sep 1 15:45:16 2024 -0400

    make ThreadCache constructor/destructor private

    1. This documents the intent that the way to create/destroy a
    ThreadCache
	object is through the static methods NewHeap()/DeleteCache()
    2. It makes using the class less error prone. The compiler will
    complain
       if some new code is accidentally creating objects directly
    3. This may allow some compilers to optimize code knowing that those
       functions are private

    Signed-off-by: Olivier Langlois <olivier@trillion01.com>

M	src/thread_cache.h

commit ae15d7a490eff0cd93fbbcfa89469f672e0ec7cd
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Aug 18 15:52:59 2024 -0400

    fix spurious rare failures in profile handler unittest

    It's method of verifying that cpu profiling ticks happens is
    inherently brittle. It sleeps certain time and then checks if ticks
    happened during that time. And sleeping is by wall clock time. But due
    to cpu scheduling being unpredictable, it is not impossible to see no
    ticks even waiting 200 ms. We improve the issue by having the code
    loop a bit until it seeks ticks happen.

M	src/tests/profile-handler_unittest.cc

commit 2e0b81852ed36ad872548e4664a8c3df5e0ce27b
Author: Xiang.Lin <myd.xia@gmail.com>
Date:	Thu Aug 8 14:53:00 2024 +0800

    [qnx] prefer fp unwinder

M	src/stacktrace.cc

commit 68ae9e624e800f9a09654e2d26bfbbeca7e2faf7
Author: Xiang.Lin <myd.xia@gmail.com>
Date:	Thu Aug 8 10:41:03 2024 +0800

    [qnx] fix empty proc maps info

    Qnx pmap file starts with a header line, skip it to make ForEachLine
    continue feeding next valid proc maps line.

    vaddr,size,flags,prot,maxprot,dev,ino,offset,rsv,guardsize,refcnt,mapcnt,path
    0x0000001c0ae92000,0x0000000000002000,0x00010071,0x05,0x0d,0x00000802,0x00000000c00000ab,
    \
      0x0000000000000000,0x0000000000000000,0x00000000,0x0000017e,0x0000017c,/bin/cat

M	src/base/proc_maps_iterator.cc

commit 285908e8c7cfa98659127a23532c060f8dcbd148
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Jun 21 15:52:57 2024 -0400

    actualize TCMallocGuard comment

    It was incorrectly refering to long gone behavior of updating
    environment variables to tell (ancient versions of) libstdc++ to use
    new/delete.

M	src/tcmalloc.cc

commit 469da8dac6c22cd4e2492a56babf09a895c60f27
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Jun 21 13:21:39 2024 -0400

    override_functions: add _{msize,recalloc}_base

    Apparently modern ucrt does have _msize_base and _recalloc_base
    defined in same .obj files as their corresponsing "non-base"
    functions. And they're seemingly used somewhere in their C or C++
    runtime. So lets provide them too in our override_functions.cc, so
    that overriding malloc routines in MSVC's static C runtime option
    works.

    Otherwise, whatever msize_base usage pulls msize.obj file that wants
    to define regular msize, and with msize already provided by
    override_function, we'd rightfully get linking error.

    Update github ticket
    https://github.com/gperftools/gperftools/issues/1430

M	src/windows/override_functions.cc

commit 825b6638cf76aecc5a540d3fa662d157760fc11e
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jun 12 19:43:04 2024 -0400

    don't try to unit-test generic_fp on known-broken platforms

    I.e. 32-bit legacy arm has broken frame pointers backtracing.

    This fixes https://github.com/gperftools/gperftools/issues/1512

M	src/stacktrace.cc

commit 7c736310f94bacdbe19cce8cc4944e71dcaa61f6
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jun 12 15:44:03 2024 -0400

    avoid testing known-to-fail cases of backtracing from ucontext

    See https://github.com/gperftools/gperftools/issues/1524

M	src/tests/stacktrace_unittest.cc

commit 5284f386ee86f333ba546e7befc18690aba10254
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jun 12 16:35:28 2024 -0400

    allow disabling actual versus given sized delete checking

    See https://bugs.freebsd.org/bugzilla/show_bug.cgi?id=279560#c10 and
    https://github.com/llvm/llvm-project/pull/90292

M	src/debugallocation.cc

commit 778df41889eb562bb5e7e64526824a2604d832f9
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Jun 11 18:54:45 2024 -0400

    unbreak calloc memsetting extra memory in emergency malloc mode

M	src/tcmalloc.cc
M	src/tests/tcmalloc_unittest.cc

commit cb2a58fb1ba2eea7f000f680be021ab45347b188
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jun 10 17:09:52 2024 -0400

    correctly find getpc.h header for GetPC configure test

    When building out-of-tree include of src/getpc.h fails, so we
    decide incorrectly that GetPC isn't functional.

    Fixes github issue #1525

M	configure.ac

commit 46c63ae3f606d4de015e00bff1fee79d9817dc12
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jun 10 17:21:10 2024 -0400

    .gitignore of recently added min_per_thread_cache_size_test

    It was added by it's wrong name, so lets fix it.

M	.gitignore

commit addf7514207db473a632e6dbff31cd0c4559b0f9
Author: Ishant Goyal <goyalishant001@gmail.com>
Date:	Sat May 18 05:09:54 2024 +0530

    Added support to configure lower bound on per-thread cache size

    [alkondratenko@gmail.com: removed spurious new line at thread_cache.h]
    Signed-off-by: Aliaksey Kandratsenka <alkondratenko@gmail.com>

M	.gitignore
M	CMakeLists.txt
M	Makefile.am
M	docs/tcmalloc.html
M	src/gperftools/malloc_extension.h
M	src/tcmalloc.cc
A	src/tests/min_per_thread_cache_size_test.cc
M	src/thread_cache.cc
M	src/thread_cache.h

commit 9fb05f3467bcc8ce5d3eff988645790bd05b65ea
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed May 29 19:22:09 2024 -0400

    Reapply "[osx] implement native c++ allocation operators on osx"

    This reverts commit a0880d78f3bb996790075b986c0fa3c81624aacf.

    We had to revert it, because some most recent OSX versions had broken
    exceptions for unwinding through functions with ATTRIBUTE_SECTION. But
    now that ATTRIBUTE_SECTION is dropped on OSX, we can recover it.

    Same as before, operator new/delete integration is much faster on
    OSX. Unlike malloc/free and similar APIs which are ~fundamentally
    broken performance-wise on OSX due to expensive arenas integration, we
    don't need to support this overhead for C++ primitives. So lets get
    this win at last.

M	src/libc_override_osx.h

commit 5472781f4ae2e4f32b667eabc15f70c267f429e8
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed May 29 19:05:52 2024 -0400

    drop broken and deprecated ATTRIBUTE_SECTION support for OSX

    This support is only strictly necessary for
    MallocHook_GetCallerStackTrace which is only needed for heap
    checker. And since heap checker is Linux-only, lets just amputate this
    code.

M	src/base/basictypes.h
M	src/malloc_hook.cc

commit 2b0b119b6d8b2156daea108c3241efa2238ca475
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed May 29 17:21:45 2024 -0400

    always use full 64 bits of address on Solaris

    Solaris has somewhat nice behavior of mmaps where high bits of address
    are set. It still uses only 48 bits of address on x86 (and,
    presumably, 64-bit arm), just with somewhat non-standard way. But this
    behavior causes some inconveniences to us. In particular, we had to
    disable mmap sys allocator and had failing emergency malloc tests (due
    to assertion in TryGetSizeClass in CheckCachedSizeClass). We could
    consider more comprehensive fix, but lets just do "honest" 64-bit
    addresses at least for now.

M	src/common.h
M	src/system-alloc.cc

commit 8be31af0fc68000934c3cf3abe554d4df10f9671
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed May 29 17:24:42 2024 -0400

    unbreak debugallocation_test on Solaris

    Allow debugallocation death test to accept RUN_ALL_TESTS in backtrace
    instead of main. For some reason solaris ends up either optimizing
    tail-calling of RUN_ALL_TESTS or something else happens in gtest
    platform integration, but failure backtraces don't have main
    there. But the intention of the test is simply to ensure that we got
    failure with backtrace. So lets accept RUN_ALL_TESTS as well.

M	src/tests/debugallocation_test.cc

commit c61f35f04cda1e4b175b45d8637379b69846860d
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Apr 6 16:44:52 2024 -0400

    simplify tcmalloc/sbrk/sbrk-hooks integration

    Instead of relying on __sbrk (on subset of Linux systems) or invoking
    sbrk syscall directly (on subset of FreeBSD systems), we have malloc
    invoke special tcmalloc_hooked_sbrk function. Which handles hooking
    and then invokes regular system's sbrk. Yes, we loose theoretical
    ability to hook into non-tcmalloc uses of sbrk, but we gain portable
    simplicity.

M	CMakeLists.txt
M	cmake/config.h.in
M	configure.ac
M	src/mmap_hook.cc
M	src/system-alloc.cc
M	src/tests/mmap_hook_test.cc
M	src/windows/port.cc
M	vsprojects/include/config.h

commit 29f394339bc54558d8a6b0afb8d263e831f6c295
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Apr 5 23:39:49 2024 -0400

    refactor and simplify capturing backtraces from mmap hooks

    The case of mmap and sbrk hooks is simple enough that we can do
    simpler "skip right number of frames" approach. Instead of relying on
    less portable and brittle attribute section trick.

M	CMakeLists.txt
M	Makefile.am
M	src/memory_region_map.cc
M	src/memory_region_map.h
M	src/mmap_hook.cc
M	src/mmap_hook.h
M	src/tests/mmap_hook_test.cc

commit 29b6eff4c7e79f099dc7ca70700daa081743c2cf
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Apr 6 15:05:57 2024 -0400

    replace heap-checker "bcad" stuff

    The comments in this file stated that it has to be linked in specific
    order to get initialized early enough. But our initialization is
    de-facto via initial malloc hook. And to deal with latest-possible
    destruction, we use more convenient destructor function
    attribute, and make things simpler.

M	CMakeLists.txt
M	Makefile.am
D	src/heap-checker-bcad.cc
M	src/heap-checker.cc

commit 33cda2c9b32dcbbb5bd7c1ae9a71a394db96fbf7
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon May 27 11:49:50 2024 -0400

    unbreak grab-backtrace frame skipping logic

    When building with -O0 -fno-inlines, +[] () {} (lambda) syntax for
    function pointers actually creates "wrapper function" so we see extra
    frame (due to disabled inlinings). Fix is to create explicit function
    and pass it, instead of lambda thingy.

M	src/malloc_backtrace.cc

commit 38b19664d378007263aca467bac9efac2ab0ad25
Author: Yikai Zhao <yikai@z1k.dev>
Date:	Fri May 24 19:33:00 2024 +0800

    generic_fp stacktrace: aarch64 frame pointer may be 8 byte aligned

M	src/stacktrace_generic_fp-inl.h

commit 7b9dc8e1fc0cd4d1bc731e046e755fe236117a56
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu May 23 15:08:02 2024 -0400

    unbreak skip_count adjustment in tcmalloc::GrabBacktrace

    I broke it with "simple" off by one error in big emergency malloc
    refactoring change.

    It is somewhat shocking that no test caught this, but we'll soon be
    adding such test.

M	src/malloc_backtrace.cc

commit d9263eea08a615ecbc17fc9eb23910240fbbdd17
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed May 22 14:29:12 2024 -0400

    unbreak pagemap unittest compilation on msvc

M	vsprojects/pagemap_unittest/pagemap_unittest.vcxproj

commit d9a99c290a9c0d8f62dddbb8d42715bde0682975
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Apr 26 16:50:04 2024 -0400

    expand emergency malloc integration to !kHaveGoodTLS systems

    References github issue #1503.

    This significantly reworks both early thread cache access and related
    emergency malloc mode checking integration. As a result, we're able to
    to rely on emergency malloc even on systems without "good"
    TLS (e.g. QNX which does emutls).

    One big change here is we're undoing early change to have single
    "global" thread cache early during process lifetime. It was nice and
    somewhat simpler approach. But because of inherent locking during
    early process lifetime, we couldn't be sure of certain lock ordering
    aspects w.r.t. backtracing/exception-stack-unwinding. So I choose to
    keep it safe. So the new idea is we use SlowTLS facility to find
    threads' caches when normal tls isn't ready yet. It avoids holding
    locks around potentially recursion-ful things (like
    ThreadCache::ModuleInit or growing heap). But we then have to be
    careful to "re-attach" those early thread cache instances to regular
    TLS. There will nearly always be just one of such thread caches. For
    initial thread. But we cannot entirely rule out more general case
    where someone creates threads before process initializers ran and
    main() is reached. Another notable thing is free-ing memory in this
    early mode will always using slow-path deletion directly into central
    free list.

    SlowTLS facility is "simply" a generalization of previous
    CreateBadTLSCache code. I.e. we have a small fixed-size cache that
    holds "exceptional" instances of thread-identitity to
    thread-cache+emergency-mode-flag mappings.

    We also take advantage of tcmalloc::kInvalidTLSKey we introduced
    earlier and remove potentially raceful memory ordering between reading
    tls_ready_ and tls_key_.

    For emergency malloc detection we previously used thread_local
    flag. Which we cannot use on !kHaveGoodTLS systems. So we instead
    _remove_ thread's cache from it's normal tls storage and place it
    "into" SlowTLS instead for the duration of WithStacktraceScope
    call (which is how emergency mode is enabled now).

M	CMakeLists.txt
M	Makefile.am
M	src/debugallocation.cc
M	src/emergency_malloc.cc
M	src/emergency_malloc.h
A	src/malloc_backtrace.cc
C068	src/maybe_emergency_malloc.h	src/malloc_backtrace.h
M	src/malloc_hook.cc
M	src/maybe_emergency_malloc.h
M	src/page_heap.cc
M	src/tcmalloc.cc
M	src/tests/tcmalloc_unittest.cc
M	src/thread_cache.h
M	src/thread_cache_ptr.cc
M	src/thread_cache_ptr.h
M	vsprojects/libtcmalloc_minimal/libtcmalloc_minimal.vcxproj
M	vsprojects/libtcmalloc_minimal/libtcmalloc_minimal.vcxproj.filters
M
vsprojects/low_level_alloc_unittest/low_level_alloc_unittest.vcxproj
M
vsprojects/low_level_alloc_unittest/low_level_alloc_unittest.vcxproj.filters

commit 46d9a6293a39654ae123f3c46cc4c76c5fc4d09f
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon May 6 16:28:52 2024 -0400

    introduce tcmalloc::kInvalidTLSKey

    The intention is to initialize tls-key variable with this invalid
    value. This will help us avoid separate "tls ready" flag and possible
    memory ordering issues around distinct tls key and tls-ready
    variables.

    On windows we use TLS_OUT_OF_INDEXES values which is properly
    "impossible" tls index value. On POSIX systems we add theoretically
    unportable, but practically portable assumption that tls keys are
    integers. And we make value of -1 be that invalid key.

M	src/base/threading.h

commit 65ce9e899eee3fbba4cf379bd5b9bb1a1a8cc7eb
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun May 12 15:47:02 2024 -0400

    better abort in internal_logging.cc:Log

    We use __builtin_trap (which compiles to explicitly undefined
    instruction or "int 3" on x64-en), when available, to make those
    crashing Log invokations a little nicer to debug.

M	src/internal_logging.cc

commit a6864ae2330007bd95d5e77657440fcb5d15bad8
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun May 12 21:09:05 2024 -0400

    clean up FLAGS_tcmalloc_heap_limit_mb value in page heap tests

    This will not only make things right w.r.t. possible order of test
    runs, but it also unbreaks test failures on windows (where gtest ends
    up doing some malloc after test completion, hits the limit and dies).

M	src/tests/page_heap_test.cc

commit de12f89d2a5b88a0ebf88c0700981751afaf90c7
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Apr 30 23:11:26 2024 -0400

    expand emergency malloc test coverage

    We add coverage of calloc and we also cover no-hooks case.

M	src/tests/tcmalloc_unittest.cc

commit 77ba2cf133ab7d19fb14181d520f18d3b693fe7a
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Apr 30 20:09:50 2024 -0400

    don't include malloc_extension.h in page_heap.h

M	src/page_heap.h

commit d63b2fad17057feec2e692332889d679fccf56ea
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Apr 22 19:55:03 2024 -0400

    introduce thread::SelfThreadId

    Sadly, certain/many implementations of std::this_thread::id invoke
    malloc. So we need something more robust. On Unix systems we use
    address of errno as thread identifier. Sadly, this doesn't cover
    windows where MS's C runtime facility will occasionally malloc when
    errno location is grabbed (with some special trickery for when malloc
    itself needs to set errno to ENOMEM!). So on windows, we do
    GetCurrentThreadId which appears to be roughly as efficient as
    "normal" system's __errno_location implementation.

M	src/base/threading.h
M	src/debugallocation.cc
M	src/memory_region_map.cc
M	src/memory_region_map.h
M	src/thread_cache_ptr.cc

commit 13aecbe19769e8da8ae22067aa2b82df8a22fcdb
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Apr 26 19:51:24 2024 -0400

    make debugallocation calloc hook invocation order consistent

    I.e. we normally call new hook just before returning. In calloc's case
    this means after zeroing allocated memory.

M	src/debugallocation.cc

commit bc2aac871a40d2aefd6a243f28bb2c3d864e9b15
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Apr 28 17:32:19 2024 -0400

    re-introduce missing initial-exec attribute for per-thread data

M	src/thread_cache_ptr.h

commit 786ecdfbc8378f6559f28ea0e610c3ade90a9b2c
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Apr 28 14:42:30 2024 -0400

    handle re-entrancy in check-address facility

    We use mmap when we initialize it, which could via heap checker
    recurse back into backtracing and check-address. So before we do mmap
    and rest of initialization, we now set check-address implementation
    to conservative two-syscalls version.

M	src/check_address-inl.h

commit a038c8c23f4fe509604269f790e2bb684f1f583b
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Apr 30 23:11:05 2024 -0400

    unbreak cmake build around HAVE_SBRK check

M	src/mmap_hook.cc

commit 1bdabc0e377ed6a41392e88a36cd3095641c5d90
Author: leap <1546711908@qq.com>
Date:	Wed Apr 10 16:40:08 2024 +0800

    Unbreak proc_maps_iterator.cc compilation on QNX

    We had duplicate definition of flags_tmp variable.

    Signed-off-by: Aliaksey Kandratsenka <alkondratenko@gmail.com>
    [alkondratenko@gmail.com] updated commit message

M	src/base/proc_maps_iterator.cc

commit 7c0cbb3a0c4a79c267eeb59deb2c657e91ae8ad1
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Apr 3 15:41:42 2024 -0400

    avoid depending on {s,}brk on FreeBSD systems without it

    Apparently some recent FreeBSDs occasionally lack brk. So our code
    which previously hard-coded that this OS has brk (which we use to
    implement hooked sbrk) fails to compile.

    Our configure scripts already detects sbrk, so we simply need to pay
    attention. Fixes github issue #1499

M	src/mmap_hook.cc

commit 8dde01b4de48f6c9f56016e1cdad63f10607fa96
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Mar 27 18:33:44 2024 -0400

    unbreak emergency malloc tests on systems without "good" TLS

    Our implementation of emergency malloc slow-path actually depends on
    good TLS implementation. So on systems without good TLS (i.e. OSX), we
    lied to ourselves that emergency malloc is available, but then failed
    tests.

M	src/tcmalloc.cc

commit 4cbd8ad2456a4d2945f5a61ea5e043496bbbfc2e
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Mar 27 17:35:39 2024 -0400

    refactor and simplify LowLevelAlloc

    We don't expose DefaultArena anymore. Simply passing nullptr implies
    default arena.

    We also streamline default arena initialization (we
    previously relied on combination of lazy initialazation in ArenaInit
    and constexpr construction).

    There is also no need to have elaborate ArenaLock thingy. We use plain
    SpinLockHolder instead.

M	src/base/low_level_alloc.cc
M	src/base/low_level_alloc.h
M	src/emergency_malloc.cc
M	src/heap-checker.cc
M	src/heap-profiler.cc
M	src/memory_region_map.cc
M	src/tests/low_level_alloc_unittest.cc

commit 2cd876cdfd8d94c0ea283de7f136645be7ebb67b
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Mar 27 17:10:47 2024 -0400

    amputate unused LowLevelAlloc flags

M	src/base/low_level_alloc.cc
M	src/base/low_level_alloc.h
M	src/emergency_malloc.cc
M	src/heap-checker.cc
M	src/heap-profiler.cc
M	src/memory_region_map.cc
M	src/tests/low_level_alloc_unittest.cc

commit 6babeb1a127f961a3de8e09b26885c82ee85780d
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Mar 27 15:40:36 2024 -0400

    apply StaticStorage to windows/system-alloc.cc

M	src/windows/system-alloc.cc

commit fa3753dc8664e5e9d75264a08d26cd1c19fb21d3
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Mar 27 14:53:34 2024 -0400

    apply StaticStorage across the source code

M	src/base/low_level_alloc.cc
M	src/debugallocation.cc
M	src/memfs_malloc.cc
M	src/memory_region_map.cc
M	src/memory_region_map.h
M	src/static_vars.cc
M	src/static_vars.h
M	src/system-alloc.cc
M	src/tcmalloc.cc
M	src/tests/tcmalloc_unittest.cc
M	src/thread_cache_ptr.cc

commit ee123a1a0d17b5eec95fb39f9568dadf647bd4d9
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Mar 27 14:02:38 2024 -0400

    apply StaticStorage to TrivialOnce

M	src/base/spinlock.h

commit 86606eef40e4e97f6c497792456c78d5189a87c5
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Mar 27 13:53:53 2024 -0400

    introduce tcmalloc::StaticStorage

    We have a number of things that are explicitly constructed in some
    statically allocated space, so lets finally have a helper for that.

A	src/base/static_storage.h
M	src/emergency_malloc.cc

commit 7cbbbdd099572767177ccf2c542cd56011d3e97d
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Mar 27 13:54:18 2024 -0400

    use DirectAnonMMap in emergency allocator

    It is just more straightforward and cleaner than going via
    LowLevelAllocators "default" pages allocator, which does direct mmap
    thingy anyways.

M	src/emergency_malloc.cc

commit 6785aeb0275c2316e025c81e8014009a08f632e9
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Mar 27 15:33:49 2024 -0400

    add test coverage of emergency malloc

M	src/tcmalloc.cc
M	src/testing_portal.h
M	src/tests/tcmalloc_unittest.cc

commit 703dc970fc1f29423d5b4c233a8af000b566656e
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Mar 27 14:53:31 2024 -0400

    add missing override declarations to TestingPortalImpl

M	src/tcmalloc.cc

commit e80e863e37c3ebf283c2d7a217b040eac5d2bb22
Author: hmihaylov-sc <164002496+hmihaylov-sc@users.noreply.github.com>
Date:	Tue Mar 26 14:52:06 2024 +0100

    remove deprecated `register` storage class

M	src/tests/heap-checker_unittest.cc

commit c71e51266434e7de2212059e960ec265e21985b9
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Mar 20 19:35:01 2024 -0400

    implement support for hidden visibility

    This is off by default for now. And autotools-only. But after
    significant preparatory work, we're now able to do it cleanly. Stuff
    that was previously exported just for tests (like page heap stuff or
    flags) is now unexported.

    Just like on windows all symbols explicitly exported by
    PERFTOOLS_DLL_DECL are visible and exported and rest are hidden. Those
    include all the malloc/new APIs of course, and all the other symbols
    we advertise in our headers (e.g. MallocExtension, MallocHook).

    Updates issue #600

M	configure.ac

commit 38d741710b02e744b46fb9417bfcde29ab565b70
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Mar 21 17:03:15 2024 -0400

    drop unused pwd.h/grp.h checks

M	CMakeLists.txt
M	cmake/config.h.in
M	configure.ac
M	vsprojects/include/config.h

commit 02f10c15a51c460516075eca4219b93a7cee830c
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Mar 20 19:34:13 2024 -0400

    update heap-checker_unittest to reach into malloc guts via
    TestingPortal

M	Makefile.am
M	src/tests/heap-checker_unittest.cc

commit d5bd0087c1ff51a73faa6cc03ad726ace2eedcf7
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Mar 20 19:37:31 2024 -0400

    avoid VLOG dependency in heap-profiler test

    This makes the test compatible with -fvisibility=hidden

M	src/tests/heap-profiler_unittest.cc

commit c23bbdb4c7fa15a58ec379b024f2ed2ab83a9dda
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Mar 20 19:32:02 2024 -0400

    don't dllexport Log and HookList

M	src/internal_logging.h
M	src/malloc_hook-inl.h

commit ea4fceb796b57696a0e1b6a6dff1aa13e0f42a9d
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Mar 20 19:31:05 2024 -0400

    don't dllexport flags

M	src/base/commandlineflags.h

commit 274038486b4acacf4165d90b40292e595359694c
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Mar 20 20:39:30 2024 -0400

    ensure dllexport/public visibility of all aliases we generate

M	src/libc_override_gcc_and_weak.h
M	src/libc_override_glibc.h

commit 32796c754e5f27053504a2400914607e172d0756
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Mar 20 20:38:54 2024 -0400

    export all mmap and sbrk replacement functions

M	src/mmap_hook.cc

commit 5cba04ead2250582d44cf900b0652b701a092d0f
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Mar 20 19:31:28 2024 -0400

    export IsHeapProfilerRunning symbol

    It is part of our API and ABI, so it needs to public visibility
    declaration, like rest of functions declared in the same public
    header.

M	src/gperftools/heap-profiler.h

commit 2436c80d6ce3eaafe97b5e8bc4ad26d81c05da9f
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Mar 20 20:38:30 2024 -0400

    ensure that malloc_extension_c_test includes config.h first

    Like we do everywhere.

M	src/tests/malloc_extension_c_test.cc

commit 701777bbeed26c69f649783acd40037cbae2e448
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Mar 21 18:04:39 2024 -0400

    dont define unused HAVE_MEMORY_H in windows config.h

M	vsprojects/include/config.h

commit 6038a09c76de21a1fefec098c4e2e18df8e1ba8f
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Mar 21 17:03:29 2024 -0400

    simplify vdso_support.h/elf_mem_image.h integration

    This is only used by Linux/PPC, so lets make it simpler and
    clearer (e.g. no need to do __GLIBC__ test).

M	src/base/elf_mem_image.h
M	src/base/vdso_support.h

commit ae31e6afa392c6d39070aaebc4eb3745c6fbd4f1
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Mar 21 17:02:52 2024 -0400

    drop unused LT_OBJDIR from cmake config.h template

M	cmake/config.h.in
M	vsprojects/include/config.h

commit e867bb7818a3dce925f2ecacc6783e9845cb7f9c
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Mar 21 17:01:28 2024 -0400

    amputate unused Elf32_Versym check

M	CMakeLists.txt
M	configure.ac
M	vsprojects/include/config.h

commit b65b9e3e614a65080b69e0594cb709fbf7a10571
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Mar 21 16:59:51 2024 -0400

    amputate unused AC_INSTALL_PREFIX

M	cmake/config.h.in
M	configure.ac
D	m4/install_prefix.m4
M	vsprojects/include/config.h

commit fc496c87c4ebde04c25e6725e0a5a1af92751dc4
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Mar 17 15:09:57 2024 -0400

    liberate our tests from makefile setting TCMALLOC_SAMPLE_PARAMETER

M	CMakeLists.txt
M	Makefile.am
M	src/tests/heap-profiler_unittest.cc

commit abc0ac61477377a548228e8d6b6dfa595bb600f6
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Mar 17 13:21:15 2024 -0400

    drop legacy_assertions.h

D	src/tests/legacy_assertions.h

commit 8cb41da4f9568b8fd958a5fe6ad887352a47aa9d
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Mar 14 12:39:19 2024 -0400

    gtestify debugallocation_test

    As part of that we eliminate use of shell script and rely on gtest's
    death testing facility instead (which this test was originally using).

M	CMakeLists.txt
M	Makefile.am
M	src/tests/debugallocation_test.cc
D	src/tests/debugallocation_test.sh

commit 14598dd4ac84401166d398db9257376a05856189
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Mar 11 12:50:25 2024 -0400

    gtestify and refactor tcmalloc_unittest

    While it still needs more work to be up to highest standards of
    cleanness and clarity, we made it better.

    One big part of this change is we're now liberated from
    tcmalloc_unittest.sh. We now arrange testing of various environment
    variable tweaks in C++ by self-execing with updated environment at the
    end of tests.

M	CMakeLists.txt
M	Makefile.am
M	src/tests/tcmalloc_unittest.cc
D	src/tests/tcmalloc_unittest.sh
M
vsprojects/tcmalloc_minimal_unittest/tcmalloc_minimal_unittest.vcxproj

commit 93380fc7545e55f69265ea2bb93f7cc7a2fbde50
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Mar 11 12:19:06 2024 -0400

    drop dependency on sys/resource.h

    Biggest part of it is removal of SetTestResourceLimit. The reasoning
    behind it is, we don't do it on windows. Tests pass just fine. So,
    there is no reason to bother.

M	CMakeLists.txt
M	cmake/config.h.in
M	configure.ac
M	src/tests/frag_unittest.cc
M	src/tests/tcmalloc_unittest.cc
M	src/tests/testutil.cc
M	src/tests/testutil.h
M	vsprojects/include/config.h

commit a4fe2d7cd0dfe5202d42492598381b8210544bf9
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Mar 17 15:09:01 2024 -0400

    liberate sampling test from use of shell script

    As part of that we do somewhat tighter job with temp files.

M	CMakeLists.txt
M	Makefile.am
M	src/tests/sampling_test.cc
D	src/tests/sampling_test.sh

commit c3e9ad95f124360ff5785517118f79514f261583
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Mar 17 15:08:13 2024 -0400

    minor cleanup of thread_dealloc_unittest

M	src/tests/thread_dealloc_unittest.cc

commit 6b53b1a4c1efbae15ba65b2eb28cc5df37163ad9
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Mar 17 15:35:09 2024 -0400

    gtestify and cleanup system-alloc_unittest

M	CMakeLists.txt
M	Makefile.am
M	src/tests/system-alloc_unittest.cc
M	vsprojects/system-alloc_unittest/system-alloc_unittest.vcxproj

commit f7c8b45dcdb9d21e1a43e5631603d22684fa52e6
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Mar 17 13:38:14 2024 -0400

    gtestify realloc_unittest

M	CMakeLists.txt
M	Makefile.am
M	src/tests/realloc_unittest.cc
M	vsprojects/realloc_unittest/realloc_unittest.vcxproj

commit 0dddc476b35d6155f89c98b446fc9c1a10a53784
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Mar 17 12:39:57 2024 -0400

    gtestify malloc_extension_c_test

M	CMakeLists.txt
M	Makefile.am
M	src/tests/malloc_extension_c_test.cc

commit 3cda0c4185c864c7689355c53c4cd8ef6d9d55e9
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Mar 17 12:32:53 2024 -0400

    gtestify malloc_extension_test

M	CMakeLists.txt
M	Makefile.am
M	src/tests/malloc_extension_test.cc
M	vsprojects/malloc_extension_test/malloc_extension_test.vcxproj

commit 2de5f833fb677c0ab57b419465a652e973e78deb
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Mar 19 23:37:39 2024 -0400

    page_heap_test: test that more OS-es can release memory

    I just dealt with somewhat curious failure in page heap test and the
    change was due to breakage of HaveSystemRelease on OSX. And since OSX
    can truly release memory and Windows too, lets assert this.

M	src/tests/page_heap_test.cc

commit 159c9e5c53a71532b3a19f0e847709ca993e08df
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Mar 20 00:27:10 2024 -0400

    clean up and gtest-ify large_heap_fragmentation_unittest

M	CMakeLists.txt
M	Makefile.am
M	src/tests/large_heap_fragmentation_unittest.cc

commit 27a57a1b30f892bab48c8599d5c230b648b4f82a
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Mar 19 18:45:06 2024 -0400

    MmapSysAllocator: try to extend previous mapping

    This improves fragmentation in some use-cases when mmap sys allocator
    is used. In specific terms, it unbreaks
    tcmalloc_large_heap_fragmentation_unittest on OSX. They have sbrk that
    seemingly always fails (fair game). And this test aggressive
    fragmentation use-case pretty much requires tcmalloc to allocate
    memory "linearly". Which sbrk does.

    Previously, our mmap sys allocator didn't pass any start address hint,
    so it caused the test to fail. Now we remember end of previous mmap
    allocation into hint_ member variable and try to pass it as address
    hint to next mmap.

    Note, it doesn't help TCMALLOC_SKIP_SBRK=t to pass this test on Linux,
    as Linux tends to pick initial mmap chunk "backwards" and too close to
    library allocations. So it leaves not enough address space to extend
    into. We may address this use-case some other time.

M	src/system-alloc.cc

commit 641cef6b4c0b24f7fb9843add13e3309cd4770e2
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Mar 17 19:29:58 2024 -0400

    unbreak early use of MallocExtension and simpify it some

    On OSX and Windows we could end up with "default" and no-op
    MallocExtension to be used if MallocExtension::instance() is used
    before tcmalloc is fully initialized. It was nearly intended after my
    recent change. But thinking about this more, even in use-cases where
    we don't replace systems malloc APIs, we want MallocExtension to
    reflect tcmalloc's state. So we now truly force tcmalloc
    initialization on first MallocExtension::instance() use and
    MallocExtension is now abstract class.

M	src/gperftools/malloc_extension.h
M	src/malloc_extension.cc

commit 02adc8ceab39bbeac1f65e10bde577e1753094fa
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Mar 7 13:16:23 2024 -0500

    also disable _TIME_BITS in mmap_hook.cc

    Otherwise when _TIME_BITS are set, glibc complains that it seems
    _TIME_BITS=64 without seeing _FILE_OFFSET_BITS=64. Thankfully, none of
    the code in mmap_hook.cc depends on time_t.

M	src/mmap_hook.cc

commit 198b3dd2d0b4d83c873b2ce480837edacc0f35ab
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Mar 1 16:25:11 2024 -0500

    disable _FILE_OFFSET_BITS in mmap_hook.cc

    Debian is doing massive rebuild of everything with 64-bit off_t (and
    time_t), but on those systems where it matters, glibc still has mmap
    with 32-bit off_t argument and mmap64 with 64-bit off_t. Since we're
    aiming to match glibc's ABI, we need to see system's native off_t
    width.

M	src/mmap_hook.cc

commit 37b59a206e36b405dcb2ac09d502875dd629a80b
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Feb 26 13:21:14 2024 -0500

    gtestify current_allocated_bytes_test

M	Makefile.am
M	src/tests/current_allocated_bytes_test.cc
M
vsprojects/current_allocated_bytes_test/current_allocated_bytes_test.vcxproj

commit f9e6c517b84bbedc89740e6633ec0145abd20bab
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Feb 25 20:39:53 2024 -0500

    gtestify markidle_unittest

M	Makefile.am
M	src/tests/markidle_unittest.cc
M	vsprojects/markidle_unittest/markidle_unittest.vcxproj

commit 3b12487a83b05dc850ff8af3abc40477fd07ecfa
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Feb 25 17:52:51 2024 -0500

    gtestify memalign_unittest

M	CMakeLists.txt
M	Makefile.am
M	src/tests/memalign_unittest.cc

commit 9cb7f7040e0321e8c7178477827ab56331a10457
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Feb 25 15:01:45 2024 -0500

    gtestify frag_unittest

M	Makefile.am
M	src/tests/frag_unittest.cc
M	vsprojects/frag_unittest/frag_unittest.vcxproj

commit 80a02ea645128cac41ed62e0a4a7b597b743aa04
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Feb 24 16:35:30 2024 -0500

    update {tcmalloc_unit,debugallocation_}test to use TestingPortal

    So that they're not reaching into guts of
    libtcmalloc{,_debug}{,_minimal} anymore.

M	src/config_for_unittests.h
M	src/tests/debugallocation_test.cc
M	src/tests/tcmalloc_unittest.cc

commit ddc162f1d1b2e47d493ea7377db1e9b90936099a
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Feb 24 16:35:25 2024 -0500

    implement TestingPortal

    Some our tests are intended to test behavior of external APIs (like
    operator new etc), but they do need occasional ability to peek into
    the guts of tcmalloc. We want to make our .so libraries to be built
    with -fvisibility=hidden, so we'll loose this ability.

    In order to have this limited ability for tests to get into the guts
    of tcmalloc, we introduce TestingPortal exactly for that. It uses
    carefuly designed and thouroughly undocumented GetNumericProperty
    extension to grab pointer to TestingPortal. Then through calling
    member functions of this instance, we're able to do the right thing.

M	src/debugallocation.cc
M	src/heap-checker.cc
M	src/tcmalloc.cc
A	src/testing_portal.h

commit 66bdf24061a26e5c0f0c18619b06338b6925a1bb
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Feb 22 18:16:54 2024 -0500

    initialize correct MallocExtension instance early

    Previous implementation only had tcmalloc.cc's TCMallocGuard to
    register correct MallocExtension instance. Which is occasionally too
    late.

    This original design (as well as it's ancestor in abseil tcmalloc)
    allows malloc_extension.cc to be built and linked separately from
    tcmalloc. So that software that uses extended features can be linked
    with non-tcmalloc malloc (or, for example, asan).

    In our case, we don't offer such flexibility. But we choose to keep
    ability to (re)enable it.

    New implementation makes sure to register malloc extension on first
    call to memory allocation. Which typically happens super-early.

    In case malloc/operator new aren't called early enough, we make sure
    that first call to MallocExtension::instance invokes malloc as part of
    creating it's 'empty' malloc extension, and thus provoking
    tcmalloc (or any other malloc that chose to implement our malloc
    extension interface) to register it's proper MallocExtension instance.

M	src/debugallocation.cc
M	src/malloc_extension.cc
M	src/tcmalloc.cc
M	src/tcmalloc_internal.h
M	src/thread_cache.cc

commit 9dfab2cdce5ec1ebb36e2a20e5031ef49cbe8087
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Feb 26 16:40:11 2024 -0500

    cmake: refactor CMakeLists.txt

    It is still somewhat broken and somewhat of a mess, but it is much
    lesser mess now.

    As part of this change I also amputated a number of unnecessary or too
    complicated bits. Like attempt to build both static and shared
    versions of tcmalloc libraries at the same time. We stick to cmake's
    "common" (seemingly) behavior of defaulting to something (in our case
    shared library) and letting users override BUILD_SHARED_LIBS.

    All the "install" bits are amputated as well, they're not ready.

M	CMakeLists.txt
M	cmake/config.h.in
M	src/windows/CMakeLists.txt

commit 5fabaea30d782260fb3c83317a6127eefde63bd0
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Feb 22 18:12:42 2024 -0500

    link page_heap_test with entirety of tcmalloc_minimal

    This makes page_heap_test a bit more uniform with rest of things and
    prevents any future missing symbols issues.

M	Makefile.am
M	src/page_heap.h
M	vsprojects/page_heap_test/page_heap_test.vcxproj
M	vsprojects/page_heap_test/page_heap_test.vcxproj.filters

commit 5f9eb911290fbe457cf590bb9416e3cbad6b2199
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Feb 25 17:53:30 2024 -0500

    cleanup and untangle sampling-test from tcmalloc guts

M	src/tests/sampling_test.cc

commit 9381dd0b190c2603b1ed5d963946948ec38f38f8
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Feb 22 18:10:10 2024 -0500

    tcmalloc_unittest: wrap calloc reference with noopt

    It is not clear why we didn't hit this before, but in some cases we
    see calloc being optimized away (just like we had with
    new/malloc). And noopt is how we deal with it.

M	src/tests/tcmalloc_unittest.cc

commit de3066fb1f876f768f88646eefb97e3557d5e2e1
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Feb 23 13:12:13 2024 -0500

    unbreak unnecessary slowness of addressmap_unittest

M	src/tests/addressmap_unittest.cc

commit 2940450c7a4c8f2e6c4cd7d3d2ebd87dec10d2c1
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Feb 24 21:04:15 2024 -0500

    gtestify profiledata_unittest

M	CMakeLists.txt
M	Makefile.am
M	src/tests/profiledata_unittest.cc

commit bbae941492982598a501fa75210140441e05a3bd
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Feb 24 20:43:34 2024 -0500

    gtestify profile-handler_unittest

M	CMakeLists.txt
M	Makefile.am
M	src/tests/profile-handler_unittest.cc

commit a4d9540d8be2bfe504adb370aa17bfb6652915ed
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Feb 25 18:09:28 2024 -0500

    unbreak cmake for packed-cache_test

M	CMakeLists.txt

commit 9bebef9ff3376e8ea78faa52871c0356fe7f9cb9
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Feb 26 13:16:34 2024 -0500

    bump WIN32_WINNT request to windows 8

    We already require it for spinlock futex-like waiting stuff, so lets
    make it more official to enable newer APIs in other places too.

M	src/windows/port.h

commit 7d664c702a408fa1966bbacbe38eabaad171713f
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Feb 26 12:20:55 2024 -0500

    reimplement windows GetenvBeforeMain to avoid memory allocation

    Previous implementation used GetEnvironmentVariableA which appears to
    be calling into Heap{Alloc,Free}, so in some cases may recurse into
    tcmalloc. So we use 'wide' character version and perform trivial
    conversion to/from 7-bit ASCII.

M	src/base/sysinfo.cc

commit f2f301df7a3524a0a39b65f3b7bd6ac790f2e006
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Feb 27 12:50:19 2024 -0500

    gitignore build/

    This is a common directory used by out-of-tree cmake builds.

M	.gitignore

commit b81d639793aa3c808be60f1b1a71f29aaac1d02d
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Feb 22 17:53:52 2024 -0500

    ignore googletest .dirstamp

M	.gitignore

commit 896804dcb2cbda5282e20934ca1fd163e81d1cf5
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Feb 22 17:39:00 2024 -0500

    delete accidentally added .dirstamp file

D	vendor/googletest/googletest/src/.dirstamp

commit f8da1590136cc3f41ddf2a3f13a1a96697bbc66f
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Feb 21 21:56:45 2024 -0500

    add function_ref_test

M	.gitignore
M	CMakeLists.txt
M	Makefile.am
A	src/tests/function_ref_test.cc

commit bfbfa333eb52e176fea5688367bccaa0f414cf9b
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Feb 21 17:53:45 2024 -0500

    add cleanup_test

    This also let us spot and fix missing include in the header.

M	.gitignore
M	CMakeLists.txt
M	Makefile.am
M	src/base/cleanup.h
C056	src/base/cleanup.h	src/tests/cleanup_test.cc

commit 61b1e05848b9f4722227c07594415f6a2f212610
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Feb 21 13:32:29 2024 -0500

    unbreak make dist

    In 57d6ecc4aedeb62b1b59c0ba502137e94d8bef4f I removed obsolete
    src/windows/TODO but failed to remove it from Makefile.am

    I also previously failed to arrange distribution of vendored
    googletest. And we also failed to distribute headers in src/tests/

    This is all fixed now.

M	Makefile.am

commit 0906dacc486ba61a214644b84b4314a4b7c3826c
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Feb 17 21:22:11 2024 -0500

    gtestify more tests

    Those are malloc_hook_test, mmap_hook_test, page_heap_test,
    sampler_test, stack_trace_table_test.

M	CMakeLists.txt
M	Makefile.am
M	src/tests/malloc_hook_test.cc
M	src/tests/mmap_hook_test.cc
M	src/tests/page_heap_test.cc
M	src/tests/sampler_test.cc
M	src/tests/stack_trace_table_test.cc
M	vsprojects/malloc_hook_test/malloc_hook_test.vcxproj
M	vsprojects/page_heap_test/page_heap_test.vcxproj
M	vsprojects/sampler_test/sampler_test.vcxproj
M	vsprojects/stack_trace_table_test/stack_trace_table_test.vcxproj

commit bfa30bf7df014e17370a0777aa33a3e3a5214785
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Feb 17 21:17:37 2024 -0500

    gtestify 3 simpler tests

    Those are packed-cache_test, pagemap_unittest, safe_strerror_test

M	CMakeLists.txt
M	Makefile.am
M	src/tests/packed-cache_test.cc
M	src/tests/pagemap_unittest.cc
M	src/tests/safe_strerror_test.cc
M	vsprojects/packed-cache_test/packed-cache_test.vcxproj
M	vsprojects/pagemap_unittest/pagemap_unittest.vcxproj

commit ff2dce5e67b3e94f26e70a400acc148fe36038ed
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Feb 17 21:23:54 2024 -0500

    gtestify addressmap_unittest

M	CMakeLists.txt
M	Makefile.am
M	src/tests/addressmap_unittest.cc
M	vsprojects/addressmap_unittest/addressmap_unittest.vcxproj

commit c1799405ae3ff0350eacfb1f0888915b87feda28
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Feb 17 21:21:13 2024 -0500

    gtestify check_address_test

M	.gitignore
M	CMakeLists.txt
M	Makefile.am
M	src/tests/check_address_test.cc

commit a46a391b14b170456ac053ffc69911e353051f3b
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Feb 17 21:19:12 2024 -0500

    gtestify low_level_alloc_unittest

M	CMakeLists.txt
M	Makefile.am
M	src/tests/low_level_alloc_unittest.cc
M
vsprojects/low_level_alloc_unittest/low_level_alloc_unittest.vcxproj

commit 6c24a59682247afed04b8b42851ae8c47a3fe315
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Feb 11 18:59:55 2024 -0500

    introduce vendor copy of googletest

M	.gitignore
M	CMakeLists.txt
M	Makefile.am
M	gperftools.sln
M	src/tests/generic_writer_test.cc
M	src/tests/proc_maps_iterator_test.cc
M	src/tests/unique_path_unittest.cc
A	vendor/README.vendor
A	vendor/googletest/.clang-format
A	vendor/googletest/.github/ISSUE_TEMPLATE/00-bug_report.yml
A	vendor/googletest/.github/ISSUE_TEMPLATE/10-feature_request.yml
A	vendor/googletest/.github/ISSUE_TEMPLATE/config.yml
A	vendor/googletest/.github/workflows/gtest-ci.yml
A	vendor/googletest/.gitignore
A	vendor/googletest/BUILD.bazel
A	vendor/googletest/CMakeLists.txt
A	vendor/googletest/CONTRIBUTING.md
A	vendor/googletest/CONTRIBUTORS
A	vendor/googletest/LICENSE
A	vendor/googletest/MODULE.bazel
A	vendor/googletest/README.md
A	vendor/googletest/WORKSPACE
A	vendor/googletest/WORKSPACE.bzlmod
A	vendor/googletest/ci/linux-presubmit.sh
A	vendor/googletest/ci/macos-presubmit.sh
A	vendor/googletest/ci/windows-presubmit.bat
A	vendor/googletest/docs/_config.yml
A	vendor/googletest/docs/_data/navigation.yml
A	vendor/googletest/docs/_layouts/default.html
A	vendor/googletest/docs/_sass/main.scss
A	vendor/googletest/docs/advanced.md
A	vendor/googletest/docs/assets/css/style.scss
A	vendor/googletest/docs/community_created_documentation.md
A	vendor/googletest/docs/faq.md
A	vendor/googletest/docs/gmock_cheat_sheet.md
A	vendor/googletest/docs/gmock_cook_book.md
A	vendor/googletest/docs/gmock_faq.md
A	vendor/googletest/docs/gmock_for_dummies.md
A	vendor/googletest/docs/index.md
A	vendor/googletest/docs/pkgconfig.md
A	vendor/googletest/docs/platforms.md
A	vendor/googletest/docs/primer.md
A	vendor/googletest/docs/quickstart-bazel.md
A	vendor/googletest/docs/quickstart-cmake.md
A	vendor/googletest/docs/reference/actions.md
A	vendor/googletest/docs/reference/assertions.md
A	vendor/googletest/docs/reference/matchers.md
A	vendor/googletest/docs/reference/mocking.md
A	vendor/googletest/docs/reference/testing.md
A	vendor/googletest/docs/samples.md
A	vendor/googletest/googlemock/CMakeLists.txt
A	vendor/googletest/googlemock/README.md
A	vendor/googletest/googlemock/cmake/gmock.pc.in
A	vendor/googletest/googlemock/cmake/gmock_main.pc.in
A	vendor/googletest/googlemock/docs/README.md
A	vendor/googletest/googlemock/include/gmock/gmock-actions.h
A	vendor/googletest/googlemock/include/gmock/gmock-cardinalities.h
A	vendor/googletest/googlemock/include/gmock/gmock-function-mocker.h
A	vendor/googletest/googlemock/include/gmock/gmock-matchers.h
A	vendor/googletest/googlemock/include/gmock/gmock-more-actions.h
A	vendor/googletest/googlemock/include/gmock/gmock-more-matchers.h
A	vendor/googletest/googlemock/include/gmock/gmock-nice-strict.h
A	vendor/googletest/googlemock/include/gmock/gmock-spec-builders.h
A	vendor/googletest/googlemock/include/gmock/gmock.h
A
vendor/googletest/googlemock/include/gmock/internal/custom/README.md
A
vendor/googletest/googlemock/include/gmock/internal/custom/gmock-generated-actions.h
A
vendor/googletest/googlemock/include/gmock/internal/custom/gmock-matchers.h
A
vendor/googletest/googlemock/include/gmock/internal/custom/gmock-port.h
A
vendor/googletest/googlemock/include/gmock/internal/gmock-internal-utils.h
A	vendor/googletest/googlemock/include/gmock/internal/gmock-port.h
A	vendor/googletest/googlemock/include/gmock/internal/gmock-pp.h
A	vendor/googletest/googlemock/src/gmock-all.cc
A	vendor/googletest/googlemock/src/gmock-cardinalities.cc
A	vendor/googletest/googlemock/src/gmock-internal-utils.cc
A	vendor/googletest/googlemock/src/gmock-matchers.cc
A	vendor/googletest/googlemock/src/gmock-spec-builders.cc
A	vendor/googletest/googlemock/src/gmock.cc
A	vendor/googletest/googlemock/src/gmock_main.cc
A	vendor/googletest/googlemock/test/BUILD.bazel
A	vendor/googletest/googlemock/test/gmock-actions_test.cc
A	vendor/googletest/googlemock/test/gmock-cardinalities_test.cc
A	vendor/googletest/googlemock/test/gmock-function-mocker_test.cc
A	vendor/googletest/googlemock/test/gmock-internal-utils_test.cc
A
vendor/googletest/googlemock/test/gmock-matchers-arithmetic_test.cc
A
vendor/googletest/googlemock/test/gmock-matchers-comparisons_test.cc
A
vendor/googletest/googlemock/test/gmock-matchers-containers_test.cc
A	vendor/googletest/googlemock/test/gmock-matchers-misc_test.cc
A	vendor/googletest/googlemock/test/gmock-matchers_test.h
A	vendor/googletest/googlemock/test/gmock-more-actions_test.cc
A	vendor/googletest/googlemock/test/gmock-nice-strict_test.cc
A	vendor/googletest/googlemock/test/gmock-port_test.cc
A	vendor/googletest/googlemock/test/gmock-pp-string_test.cc
A	vendor/googletest/googlemock/test/gmock-pp_test.cc
A	vendor/googletest/googlemock/test/gmock-spec-builders_test.cc
A	vendor/googletest/googlemock/test/gmock_all_test.cc
A	vendor/googletest/googlemock/test/gmock_ex_test.cc
A	vendor/googletest/googlemock/test/gmock_leak_test.py
A	vendor/googletest/googlemock/test/gmock_leak_test_.cc
A	vendor/googletest/googlemock/test/gmock_link2_test.cc
A	vendor/googletest/googlemock/test/gmock_link_test.cc
A	vendor/googletest/googlemock/test/gmock_link_test.h
A	vendor/googletest/googlemock/test/gmock_output_test.py
A	vendor/googletest/googlemock/test/gmock_output_test_.cc
A	vendor/googletest/googlemock/test/gmock_output_test_golden.txt
A	vendor/googletest/googlemock/test/gmock_stress_test.cc
A	vendor/googletest/googlemock/test/gmock_test.cc
A	vendor/googletest/googlemock/test/gmock_test_utils.py
A	vendor/googletest/googletest/CMakeLists.txt
A	vendor/googletest/googletest/README.md
A	vendor/googletest/googletest/cmake/Config.cmake.in
A	vendor/googletest/googletest/cmake/gtest.pc.in
A	vendor/googletest/googletest/cmake/gtest_main.pc.in
A	vendor/googletest/googletest/cmake/internal_utils.cmake
A	vendor/googletest/googletest/cmake/libgtest.la.in
A	vendor/googletest/googletest/docs/README.md
A
vendor/googletest/googletest/include/gtest/gtest-assertion-result.h
A	vendor/googletest/googletest/include/gtest/gtest-death-test.h
A	vendor/googletest/googletest/include/gtest/gtest-matchers.h
A	vendor/googletest/googletest/include/gtest/gtest-message.h
A	vendor/googletest/googletest/include/gtest/gtest-param-test.h
A	vendor/googletest/googletest/include/gtest/gtest-printers.h
A	vendor/googletest/googletest/include/gtest/gtest-spi.h
A	vendor/googletest/googletest/include/gtest/gtest-test-part.h
A	vendor/googletest/googletest/include/gtest/gtest-typed-test.h
A	vendor/googletest/googletest/include/gtest/gtest.h
A	vendor/googletest/googletest/include/gtest/gtest_pred_impl.h
A	vendor/googletest/googletest/include/gtest/gtest_prod.h
A
vendor/googletest/googletest/include/gtest/internal/custom/README.md
A
vendor/googletest/googletest/include/gtest/internal/custom/gtest-port.h
A
vendor/googletest/googletest/include/gtest/internal/custom/gtest-printers.h
A	vendor/googletest/googletest/include/gtest/internal/custom/gtest.h
A
vendor/googletest/googletest/include/gtest/internal/gtest-death-test-internal.h
A
vendor/googletest/googletest/include/gtest/internal/gtest-filepath.h
A
vendor/googletest/googletest/include/gtest/internal/gtest-internal.h
A
vendor/googletest/googletest/include/gtest/internal/gtest-param-util.h
A
vendor/googletest/googletest/include/gtest/internal/gtest-port-arch.h
A	vendor/googletest/googletest/include/gtest/internal/gtest-port.h
A	vendor/googletest/googletest/include/gtest/internal/gtest-string.h
A
vendor/googletest/googletest/include/gtest/internal/gtest-type-util.h
A	vendor/googletest/googletest/samples/prime_tables.h
A	vendor/googletest/googletest/samples/sample1.cc
A	vendor/googletest/googletest/samples/sample1.h
A	vendor/googletest/googletest/samples/sample10_unittest.cc
A	vendor/googletest/googletest/samples/sample1_unittest.cc
A	vendor/googletest/googletest/samples/sample2.cc
A	vendor/googletest/googletest/samples/sample2.h
A	vendor/googletest/googletest/samples/sample2_unittest.cc
A	vendor/googletest/googletest/samples/sample3-inl.h
A	vendor/googletest/googletest/samples/sample3_unittest.cc
A	vendor/googletest/googletest/samples/sample4.cc
A	vendor/googletest/googletest/samples/sample4.h
A	vendor/googletest/googletest/samples/sample4_unittest.cc
A	vendor/googletest/googletest/samples/sample5_unittest.cc
A	vendor/googletest/googletest/samples/sample6_unittest.cc
A	vendor/googletest/googletest/samples/sample7_unittest.cc
A	vendor/googletest/googletest/samples/sample8_unittest.cc
A	vendor/googletest/googletest/samples/sample9_unittest.cc
A	vendor/googletest/googletest/src/.dirstamp
A	vendor/googletest/googletest/src/gtest-all.cc
A	vendor/googletest/googletest/src/gtest-assertion-result.cc
A	vendor/googletest/googletest/src/gtest-death-test.cc
A	vendor/googletest/googletest/src/gtest-filepath.cc
A	vendor/googletest/googletest/src/gtest-internal-inl.h
A	vendor/googletest/googletest/src/gtest-matchers.cc
A	vendor/googletest/googletest/src/gtest-port.cc
A	vendor/googletest/googletest/src/gtest-printers.cc
A	vendor/googletest/googletest/src/gtest-test-part.cc
A	vendor/googletest/googletest/src/gtest-typed-test.cc
A	vendor/googletest/googletest/src/gtest.cc
A	vendor/googletest/googletest/src/gtest_main.cc
A	vendor/googletest/googletest/test/BUILD.bazel
A
vendor/googletest/googletest/test/googletest-break-on-failure-unittest.py
A
vendor/googletest/googletest/test/googletest-break-on-failure-unittest_.cc
A
vendor/googletest/googletest/test/googletest-catch-exceptions-test.py
A
vendor/googletest/googletest/test/googletest-catch-exceptions-test_.cc
A	vendor/googletest/googletest/test/googletest-color-test.py
A	vendor/googletest/googletest/test/googletest-color-test_.cc
A	vendor/googletest/googletest/test/googletest-death-test-test.cc
A	vendor/googletest/googletest/test/googletest-death-test_ex_test.cc
A	vendor/googletest/googletest/test/googletest-env-var-test.py
A	vendor/googletest/googletest/test/googletest-env-var-test_.cc
A	vendor/googletest/googletest/test/googletest-failfast-unittest.py
A	vendor/googletest/googletest/test/googletest-failfast-unittest_.cc
A	vendor/googletest/googletest/test/googletest-filepath-test.cc
A	vendor/googletest/googletest/test/googletest-filter-unittest.py
A	vendor/googletest/googletest/test/googletest-filter-unittest_.cc
A
vendor/googletest/googletest/test/googletest-global-environment-unittest.py
A
vendor/googletest/googletest/test/googletest-global-environment-unittest_.cc
A	vendor/googletest/googletest/test/googletest-json-outfiles-test.py
A
vendor/googletest/googletest/test/googletest-json-output-unittest.py
A
vendor/googletest/googletest/test/googletest-list-tests-unittest.py
A
vendor/googletest/googletest/test/googletest-list-tests-unittest_.cc
A	vendor/googletest/googletest/test/googletest-listener-test.cc
A	vendor/googletest/googletest/test/googletest-message-test.cc
A	vendor/googletest/googletest/test/googletest-options-test.cc
A
vendor/googletest/googletest/test/googletest-output-test-golden-lin.txt
A	vendor/googletest/googletest/test/googletest-output-test.py
A	vendor/googletest/googletest/test/googletest-output-test_.cc
A
vendor/googletest/googletest/test/googletest-param-test-invalid-name1-test.py
A
vendor/googletest/googletest/test/googletest-param-test-invalid-name1-test_.cc
A
vendor/googletest/googletest/test/googletest-param-test-invalid-name2-test.py
A
vendor/googletest/googletest/test/googletest-param-test-invalid-name2-test_.cc
A	vendor/googletest/googletest/test/googletest-param-test-test.cc
A	vendor/googletest/googletest/test/googletest-param-test-test.h
A	vendor/googletest/googletest/test/googletest-param-test2-test.cc
A	vendor/googletest/googletest/test/googletest-port-test.cc
A	vendor/googletest/googletest/test/googletest-printers-test.cc
A
vendor/googletest/googletest/test/googletest-setuptestsuite-test.py
A
vendor/googletest/googletest/test/googletest-setuptestsuite-test_.cc
A	vendor/googletest/googletest/test/googletest-shuffle-test.py
A	vendor/googletest/googletest/test/googletest-shuffle-test_.cc
A	vendor/googletest/googletest/test/googletest-test-part-test.cc
A
vendor/googletest/googletest/test/googletest-throw-on-failure-test.py
A
vendor/googletest/googletest/test/googletest-throw-on-failure-test_.cc
A	vendor/googletest/googletest/test/googletest-uninitialized-test.py
A
vendor/googletest/googletest/test/googletest-uninitialized-test_.cc
A	vendor/googletest/googletest/test/gtest-typed-test2_test.cc
A	vendor/googletest/googletest/test/gtest-typed-test_test.cc
A	vendor/googletest/googletest/test/gtest-typed-test_test.h
A	vendor/googletest/googletest/test/gtest-unittest-api_test.cc
A	vendor/googletest/googletest/test/gtest_all_test.cc
A
vendor/googletest/googletest/test/gtest_assert_by_exception_test.cc
A	vendor/googletest/googletest/test/gtest_dirs_test.cc
A	vendor/googletest/googletest/test/gtest_environment_test.cc
A	vendor/googletest/googletest/test/gtest_help_test.py
A	vendor/googletest/googletest/test/gtest_help_test_.cc
A	vendor/googletest/googletest/test/gtest_json_test_utils.py
A	vendor/googletest/googletest/test/gtest_list_output_unittest.py
A	vendor/googletest/googletest/test/gtest_list_output_unittest_.cc
A	vendor/googletest/googletest/test/gtest_main_unittest.cc
A	vendor/googletest/googletest/test/gtest_no_test_unittest.cc
A	vendor/googletest/googletest/test/gtest_pred_impl_unittest.cc
A	vendor/googletest/googletest/test/gtest_premature_exit_test.cc
A	vendor/googletest/googletest/test/gtest_prod_test.cc
A	vendor/googletest/googletest/test/gtest_repeat_test.cc
A	vendor/googletest/googletest/test/gtest_skip_check_output_test.py
A
vendor/googletest/googletest/test/gtest_skip_environment_check_output_test.py
A
vendor/googletest/googletest/test/gtest_skip_in_environment_setup_test.cc
A	vendor/googletest/googletest/test/gtest_skip_test.cc
A	vendor/googletest/googletest/test/gtest_sole_header_test.cc
A	vendor/googletest/googletest/test/gtest_stress_test.cc
A
vendor/googletest/googletest/test/gtest_test_macro_stack_footprint_test.cc
A	vendor/googletest/googletest/test/gtest_test_utils.py
A	vendor/googletest/googletest/test/gtest_testbridge_test.py
A	vendor/googletest/googletest/test/gtest_testbridge_test_.cc
A
vendor/googletest/googletest/test/gtest_throw_on_failure_ex_test.cc
A	vendor/googletest/googletest/test/gtest_unittest.cc
A	vendor/googletest/googletest/test/gtest_xml_outfile1_test_.cc
A	vendor/googletest/googletest/test/gtest_xml_outfile2_test_.cc
A	vendor/googletest/googletest/test/gtest_xml_outfiles_test.py
A	vendor/googletest/googletest/test/gtest_xml_output_unittest.py
A	vendor/googletest/googletest/test/gtest_xml_output_unittest_.cc
A	vendor/googletest/googletest/test/gtest_xml_test_utils.py
A	vendor/googletest/googletest/test/production.cc
A	vendor/googletest/googletest/test/production.h
A	vendor/googletest/googletest_deps.bzl
A	vsprojects/gtest/gtest.vcxproj
A	vsprojects/gtest/gtest.vcxproj.filters

commit ad6e29e7c93e47a3caad35869ef22518fb085b29
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Feb 19 13:12:25 2024 -0500

    move gtest-like asserts into legacy_assertions.h

M	src/base/logging.h
M	src/tests/debugallocation_test.cc
A	src/tests/legacy_assertions.h
M	src/tests/malloc_extension_test.cc
M	src/tests/malloc_hook_test.cc
M	src/tests/page_heap_test.cc
M	src/tests/profile-handler_unittest.cc
M	src/tests/profiledata_unittest.cc
M	src/tests/tcmalloc_unittest.cc
M	src/tests/unique_path_unittest.cc

commit 8318e08962713645e007690310b8d46c33de2e67
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Feb 20 12:03:39 2024 -0500

    fix missing AM_CXXFLAGS introduced in recent automake refactoring

M	Makefile.am

commit b02d36d2eb879934f93048f05c8eb5d95513082a
Author: oPiZiL <highouse1990@gmail.com>
Date:	Mon Feb 19 18:56:56 2024 +0800

    fix compile error with gcc 7.5

    In file included from /home/louwei/arcs/gperftools/src/span.cc:41:0:
    /home/louwei/arcs/gperftools/src/static_vars.h:125:37: error:
    ‘byte’ in namespace ‘std’ does not name a type
	 alignas(alignof(PageHeap)) std::byte memory[sizeof(PageHeap)];
					 ^~~~
    /home/louwei/arcs/gperftools/src/static_vars.h: In
    static member function ‘static tcmalloc::PageHeap*
    tcmalloc::Static::pageheap()’:
    /home/louwei/arcs/gperftools/src/static_vars.h:76:80: error: ‘struct
    tcmalloc::Static::<unnamed>’ has no member named ‘memory’
       static PageHeap* pageheap() { return reinterpret_cast<PageHeap
       *>(&pageheap_.memory); }
										    ^~~~~~

M	src/static_vars.h

commit 3d155f662473ff617455bb337ad328154ccc8728
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Feb 17 19:49:30 2024 -0500

    apply tcmalloc::FunctionRef in AddressMap

M	src/addressmap-inl.h
M	src/debugallocation.cc
M	src/heap-profile-table.cc
M	src/heap-profile-table.h
M	src/tests/addressmap_unittest.cc

commit 8c1a7ef17ff03386e2becb68b3c581ad57743b8f
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Feb 17 19:17:37 2024 -0500

    implement tcmalloc::FunctionRef

A	src/base/function_ref.h
M	src/tests/tcmalloc_unittest.cc

commit 5f92c0616a5bbda70c4c310de2ad75a0274940ab
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Feb 17 14:20:04 2024 -0500

    implement tcmalloc::Cleanup

    This is similar, but slightly less featureful than
    absl::{Make,}Cleanup.

A	src/base/cleanup.h
M	src/base/linuxthreads.cc
M	src/tests/tcmalloc_unittest.cc

commit dec85dcc0323782ea01860962eda9ca6cced7640
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Feb 17 18:05:07 2024 -0500

    avoid undefined behavior when parsing proc maps

    Clang's undefined behavior sanitized correctly pointed out that
    memmove requires non-nil args, so lets initialize sbuf to something.

M	src/base/proc_maps_iterator.cc

commit 9b5838f0849bb76d38f6857b6aa0e87b826f63e5
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Feb 17 18:04:18 2024 -0500

    modernize overalignment testing bits

M	src/tests/tcmalloc_unittest.cc

commit 3a2a7e05f676be45f403b0c9032b9ec4018a5f86
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Feb 17 18:01:12 2024 -0500

    add missing internal_logging.cc to packed_cache_test

    It wasn't caught before because when optimization is enabled ASSERT-s
    inside packed-cache-inl get optimized away (because checks are
    tautological).

M	Makefile.am

commit 57d6ecc4aedeb62b1b59c0ba502137e94d8bef4f
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Feb 8 09:41:21 2024 -0500

    drop obsolete src/windows/TODO

D	src/windows/TODO

commit 8a147b4833da6b5e8c9618cad96ffa058ba7199c
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Feb 7 18:27:30 2024 -0500

    untangle a number of unittests from libtcmalloc_minimal.so

M	Makefile.am
M	src/pagemap.h
M	src/stack_trace_table.cc
M	src/stack_trace_table.h
M	src/tcmalloc.cc
M	src/tests/malloc_hook_test.cc
M	src/tests/page_heap_test.cc
M	src/tests/pagemap_unittest.cc
M	src/tests/stack_trace_table_test.cc
M	vsprojects/malloc_hook_test/malloc_hook_test.vcxproj
M	vsprojects/malloc_hook_test/malloc_hook_test.vcxproj.filters
M	vsprojects/packed-cache_test/packed-cache_test.vcxproj
M	vsprojects/packed-cache_test/packed-cache_test.vcxproj.filters
M	vsprojects/page_heap_test/page_heap_test.vcxproj
M	vsprojects/pagemap_unittest/pagemap_unittest.vcxproj
M	vsprojects/pagemap_unittest/pagemap_unittest.vcxproj.filters
M	vsprojects/sampler_test/sampler_test.vcxproj
M	vsprojects/stack_trace_table_test/stack_trace_table_test.vcxproj
M
vsprojects/stack_trace_table_test/stack_trace_table_test.vcxproj.filters

commit cad457ad23a14a3f4bf4a04b5d015e9bef3db812
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Feb 7 20:24:10 2024 -0500

    actualize .gitignore

M	.gitignore

commit b0e2928343c01a2fd2aedec88f461e00f939b563
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Feb 7 20:17:16 2024 -0500

    mingw: don't add patch_functions.cc in libcommon.la

M	Makefile.am

commit e544d402f76c704bc0ecf38c8cee6b97a75d92a8
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Feb 5 22:40:27 2024 -0500

    amputate unused log_message_write

M	src/internal_logging.cc
M	src/internal_logging.h

commit b6798a513029c88781d889d30017d9c069be117c
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Feb 5 22:31:58 2024 -0500

    amputate unused kCrashWithStats

M	src/internal_logging.cc
M	src/internal_logging.h
M	src/tcmalloc.cc

commit 45a4ad8b709638bb52d5c81b1985496bf6ad387c
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Feb 7 19:20:05 2024 -0500

    mmap_hook_test: don't printf early

    The test includes override of
    MallocHook_InitAtFirstAllocation_HeapLeakChecker which runs early
    enough to trigger FreeBSD bug of not having nearly anything working
    early.

M	src/tests/mmap_hook_test.cc

commit e7f576d9f1aac6ab5e3d25902de6e9390b852365
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Feb 7 19:34:16 2024 -0500

    generic_writer_test: crash with message if tmpfile fails

M	src/tests/generic_writer_test.cc

commit 7756b4cc61b914eb280da2f536ac7a7f3d797a71
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Feb 7 19:32:45 2024 -0500

    don't force TMPDIR on all unittests

    Turns out at least on FreeBSD tmpfile will fail if TMPDIR points to
    non-existant directory. This also has nice property of leaving it down
    to users to set up TMPDIR the way they want.

M	Makefile.am

commit c52c321bdd11b169dec556a8969071e5c55e0202
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Feb 7 14:59:06 2024 -0500

    replace raw printer with usage of generic writer facility

M	.gitignore
M	CMakeLists.txt
M	Makefile.am
M	src/heap-profile-table.cc
D	src/raw_printer.cc
D	src/raw_printer.h
D	src/tests/raw_printer_test.cc
M	vsprojects/libtcmalloc_minimal/libtcmalloc_minimal.vcxproj
M	vsprojects/libtcmalloc_minimal/libtcmalloc_minimal.vcxproj.filters
M	vsprojects/page_heap_test/page_heap_test.vcxproj
M	vsprojects/page_heap_test/page_heap_test.vcxproj.filters

commit 88adbbdb959787036d32177a333ceddae289f203
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Feb 7 14:29:29 2024 -0500

    generalize FileGenericWriter

    There is now WriteFnWriter which allows us to use lambdas for a
    function that saves accumulated bytes.

M	src/base/generic_writer.h
M	src/base/proc_maps_iterator.cc
M	src/heap-profile-table.cc
M	src/heap-profiler.cc
M	src/tests/generic_writer_test.cc

commit 59f0247033af1c123fe6613fb404f8ce86c536ee
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Feb 7 12:27:30 2024 -0500

    liberate sampler_test from linking to libtcmalloc

    This test is exercising purely sampling interval logic.

M	Makefile.am
M	src/sampler.cc
M	src/sampler.h
M	src/thread_cache.h
M	vsprojects/sampler_test/sampler_test.vcxproj
M	vsprojects/sampler_test/sampler_test.vcxproj.filters

commit a02ac30bbfb698992c2d0e9cd4edd5f7bd2de053
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Feb 5 17:03:28 2024 -0500

    rework and optimize structure of Makefile.am

    There were far too many intermediate libraries, references to obsolete
    libtool bugs and whatnot.

    We now have libcommon.la as a convenience archive that contains
    spinlock, logging and misc stuff. A number of unit tests that need
    those facilities are being linked to this.

    Then we have libstacktrace.la convenience archive, since it is used by
    libtcmalloc.la and libprofiler.la.

    And after that we're simply directly creating our main library
    products: libtcmalloc_minimal{,_debug}.la, libtcmalloc_{,debug}.la,
    libprofiler.la etc.

M	Makefile.am

commit 771a01ed2888f01f1dfe41a23ea2139ca8e0fdfa
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Feb 5 10:30:22 2024 -0500

    rework and simplify emergency malloc integration

    We now wrap StackTraceScope thingy in tcmalloc-specific parts, instead
    of automagically inside every stacktrace.cc function. TCMalloc bits
    all need to grab stacktraces via newly introduced
    tcmalloc::GrabBacktrace (which handles emergency malloc wrapping).

    New approach eliminates the need for doing fake stacktrace scope. CPU
    profiler, being distinct .so library couldn't take advantage of
    emergency malloc anyways.

    This simplifies the build further and eliminates another potential
    point of runtime divergence when stacktrace is linked to both
    libprofiler and libtcmalloc.

M	CMakeLists.txt
M	Makefile.am
M	src/debugallocation.cc
M	src/emergency_malloc.cc
M	src/emergency_malloc.h
D	src/emergency_malloc_for_stacktrace.cc
D	src/fake_stacktrace_scope.cc
M	src/malloc_hook.cc
M	src/maybe_emergency_malloc.h
M	src/page_heap.cc
M	src/page_heap.h
M	src/stacktrace.cc
M	src/tcmalloc.cc
M	vsprojects/libtcmalloc_minimal/libtcmalloc_minimal.vcxproj
M	vsprojects/libtcmalloc_minimal/libtcmalloc_minimal.vcxproj.filters
M
vsprojects/low_level_alloc_unittest/low_level_alloc_unittest.vcxproj
M
vsprojects/low_level_alloc_unittest/low_level_alloc_unittest.vcxproj.filters
M	vsprojects/page_heap_test/page_heap_test.vcxproj
M	vsprojects/page_heap_test/page_heap_test.vcxproj.filters

commit 4be76ab7072aebc9224f78f5f402c52744ef4441
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Feb 5 00:00:00 2024 -0500

    drop symbols weakening step

    It has questionable value and most importantly, it was broken lots of
    years without anyone complaining. So lets get things simpler.

M	Makefile.am
M	configure.ac

commit ca50448a1eca63b63c4364546dfed3d9ed51b533
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Feb 4 23:56:08 2024 -0500

    drop export-symbols-regex stuff for libstacktrace.la

    It has no effect, because libstacktrace.la is convenience archive, not
    a library we install.

M	Makefile.am

commit ba3d7908551183edb390a7e98c958af3d56c64ac
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Feb 4 23:46:39 2024 -0500

    drop running pprof -test as part of make check

    Not needed anymore.

M	Makefile.am

commit 144c118f92e4fa4aeb677f1af970630306a8329d
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Feb 4 23:42:58 2024 -0500

    drop outdated comment in Makefile.am

M	Makefile.am

commit e262ebc741cdb0768c6d028395eae2c4490cd59f
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Feb 4 22:31:07 2024 -0500

    ship everything under vsprojects/ in make dist

    We also drop all those WINDOWS_PROJECTS amends and simplify makefile.

M	Makefile.am

commit b49920ea642acabeed40c252e2ade61abdfd87d1
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Feb 4 22:00:42 2024 -0500

    don't bother listing every header in Makefile.am

    For compiling things automake never needs to be given a full set of
    headers. Usually headers are specified so that make dist includes them
    into archive, but we can achieve this goal easier.

    This reduces size and complexity of our Makefile.am stuff.

M	Makefile.am

commit 1331c0e0d17c9b1f2b4d3b3251aeb5f9cd2305c6
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Feb 4 21:49:19 2024 -0500

    drop long deprecated google/ headers

M	.gitignore
M	CMakeLists.txt
M	Makefile.am
D	src/google/heap-checker.h
D	src/google/heap-profiler.h
D	src/google/malloc_extension.h
D	src/google/malloc_extension_c.h
D	src/google/malloc_hook.h
D	src/google/malloc_hook_c.h
D	src/google/profiler.h
D	src/google/stacktrace.h
D	src/google/tcmalloc.h
D	src/tests/simple_compat_test.cc

commit a05bab586a69f0de5ad4f6206ab682df0ed65d62
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Feb 4 19:33:12 2024 -0500

    align CentralFreeList on cache line size instead of just 64

    We had hardcoded size alignment on 64 bytes, seemingly to avoid
    cacheline contention when taking per-size-class central free list
    locks. But it makes more sense to do platform specific alignment.

    I did consider std::hardware_constructive_interference_size, but
    practical values seem to differ from what we have configured at least
    on some platforms.

M	src/central_freelist.h
M	src/static_vars.cc

commit 353816fd9db94897e2608b64f1c1871846ceee40
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Feb 4 18:30:16 2024 -0500

    drop LINKER_INITIALIZED in favor of constexpr constructors

M	src/base/basictypes.h
M	src/base/low_level_alloc.cc
M	src/base/spinlock.cc
M	src/base/spinlock.h
M	src/central_freelist.h
M	src/common.cc
M	src/debugallocation.cc
M	src/emergency_malloc.cc
M	src/heap-checker.cc
M	src/heap-profiler.cc
M	src/internal_logging.cc
M	src/malloc_hook.cc
M	src/memory_region_map.cc
M	src/mmap_hook.cc
M	src/page_heap_allocator.h
M	src/span.cc
M	src/span.h
M	src/static_vars.cc
M	src/static_vars.h
M	src/system-alloc.cc
M	src/tcmalloc.cc
M	src/tests/heap-checker_unittest.cc
M	src/thread_cache.cc
M	src/thread_cache_ptr.cc
M	src/windows/patch_functions.cc
M	src/windows/system-alloc.cc

commit 247b7f3370fb96c81d63fd8065bde1a09b57db54
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Feb 4 16:39:02 2024 -0500

    use std::thread when spawning threads in tests

M	src/tests/malloc_hook_test.cc
M	src/tests/tcmalloc_unittest.cc
M	src/tests/testutil.cc
M	src/tests/testutil.h

commit 2e5ecb4de6cdfad9e43f8d496591153a341f44b3
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Feb 4 21:07:17 2024 +0000

    amputate src/base/simple_mutex.h

    Use standard mutex instead

M	CMakeLists.txt
M	Makefile.am
D	src/base/simple_mutex.h
M	src/tests/malloc_hook_test.cc
M	src/tests/profile-handler_unittest.cc
M	src/tests/profiler_unittest.cc
M	src/tests/tcmalloc_unittest.cc
M	vsprojects/libtcmalloc_minimal/libtcmalloc_minimal.vcxproj
M	vsprojects/libtcmalloc_minimal/libtcmalloc_minimal.vcxproj.filters

commit 885dd867bc987fc52e93c49a2ccd55b50088e5ed
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Feb 4 15:37:20 2024 -0500

    liberate code base from legacy fixed size int types

    I.e. all those int32 etc type (without _t at the end). We stick to
    standard. Google/Abseil code base has long been liberated as well.

M	src/addressmap-inl.h
M	src/base/basictypes.h
M	src/base/commandlineflags.h
M	src/base/low_level_alloc.cc
M	src/base/low_level_alloc.h
M	src/base/proc_maps_iterator.cc
M	src/base/spinlock_internal.cc
M	src/base/spinlock_internal.h
M	src/base/spinlock_linux-inl.h
M	src/base/spinlock_posix-inl.h
M	src/base/spinlock_win32-inl.h
M	src/central_freelist.h
M	src/common.cc
M	src/common.h
M	src/debugallocation.cc
M	src/emergency_malloc.cc
M	src/heap-checker.cc
M	src/heap-profiler.cc
M	src/malloc_extension.cc
M	src/memfs_malloc.cc
M	src/memory_region_map.cc
M	src/memory_region_map.h
M	src/packed-cache-inl.h
M	src/page_heap.cc
M	src/page_heap.h
M	src/profile-handler.cc
M	src/profile-handler.h
M	src/tcmalloc.cc
M	src/tests/frag_unittest.cc
M	src/tests/heap-checker_unittest.cc
M	src/tests/low_level_alloc_unittest.cc
M	src/tests/packed-cache_test.cc
M	src/tests/profile-handler_unittest.cc
M	src/tests/sampler_test.cc
M	src/tests/tcmalloc_unittest.cc
M	src/thread_cache.cc
M	src/thread_cache.h

commit de22f024fb4e65697bd3560cf24a51ae1f27a784
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Feb 4 15:05:45 2024 -0500

    globally replace COMPILE_ASSERT with static_assert

M	src/base/basictypes.h
M	src/base/simple_mutex.h
M	src/base/spinlock.h
M	src/base/vdso_support.cc
M	src/packed-cache-inl.h
M	src/page_heap.cc
M	src/system-alloc.cc

commit c56764c3e67c3f5dad7cc465c613374f66e55be1
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Feb 4 14:22:33 2024 -0500

    tcmalloc_unittest: do 64-bit shift when computing alignment

    Thanks goes to MSVC for warning about this.

M	src/tests/tcmalloc_unittest.cc

commit 329e9adfa6d784d70559135cd420d81cc81af19b
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Feb 4 13:48:53 2024 -0500

    fix MSVC warning on flexible data member extension

M	src/base/generic_writer.cc

commit f910729012119b437f438d69bf45b43c42cdf452
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Feb 4 14:13:56 2024 -0500

    turn inline ATTRIBUTE_ALWAYS_INLINE -> ALWAYS_INLINE

    gcc needs both inline and __attribute__((always_inline)), while MSVC
    only needs __forceinline. So relevant correct combination is now just
    ALWAYS_INLINE macro.

M	src/base/basictypes.h
M	src/common.h
M	src/debugallocation.cc
M	src/mmap_hook.cc
M	src/page_heap.h
M	src/pagemap.h
M	src/tcmalloc.cc
M	src/thread_cache.h

commit 57660e6a544ca786a993530581cbf1e06ec951c1
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Feb 4 14:05:26 2024 -0500

    fix MSVC warning on thread annotations

M	src/base/thread_annotations.h

commit 5ec6f60bd738b5d6a24abd40ece3214453dddfd3
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Feb 4 13:38:32 2024 -0500

    suppress thread-safety warning for ThreadCachePtr

    It is slightly less great that we have to disable thread-safety
    analysis, but they explicitly say that optional locking is not
    supported. And ours is very explicitly optional locking. I.e. we only
    let ourselves resort to slow locking very early during process
    startup, when TLS isn't 100% ready and safe to use yet.

M	src/thread_cache_ptr.cc

commit 78e7b959a74366b7023293fa3a3746907b1f1443
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Feb 4 13:38:57 2024 -0500

    fix clang warning for CreateBadTLSCache

M	src/thread_cache_ptr.cc

commit 21e66f807cc0b502522f67c8cce61b8381241c0a
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Feb 4 13:37:53 2024 -0500

    enable -Wthread-safety for clang

M	Makefile.am
M	configure.ac

commit 2d35232cfa20ae1d87f58af4d88b2b5e3dae36f2
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Feb 4 13:23:16 2024 -0500

    avoid unused variable warning for bucket_count

M	src/heap-profile-table.cc

commit c59b431b2830ebc2d3a02c95638c7268efac9983
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Feb 3 15:54:12 2024 -0500

    use std::get_new_handler when handling OOM

    Previously when dealing with OOM condition we couldn't use
    std::get_new_handler (it didn't exist until c++ 11). Now we can and it
    simplifies logic a bit.

    We also detect -fno-exceptions case via standard __cpp_exceptions
    define. Also I've rearranged the logic and even found and fixed one
    bug in -fno-exceptions case.

M	src/tcmalloc.cc
M	src/tests/tcmalloc_unittest.cc

commit 04a8a4bae62cda4b1d209f81f8562b787d9d0bd1
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Feb 1 22:14:55 2024 -0500

    actually verify that we're deallocating thread caches

M	src/tcmalloc.cc
M	src/tests/thread_dealloc_unittest.cc
M	src/thread_cache.h

commit 6691226953abde99d5884b5962da09c47f407bf2
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jan 31 22:10:21 2024 -0500

    split and rewrite TLS access for thread caches

    Logic was removed from thread_cache.{h,cc} into
    thread_cache_ptr.{h,cc}.

    Separation will help possible future evolution, and we already changed
    the logic quite a bit:

    * early access (when TLS isn't initialized yet) now uses global
    ThreadCache instance. We therefore have ThreadCachePtr instances
    managing required locking. This eliminates unnecessary complication of
    PTHREADS_CRASHES_IF_RUN_TOO_EARLY logic, and any other danger of
    touching TLS too early. BTW previous implementation actually leaked
    initial early-initialized ThreadCache instance(!)

    * old configure-time HAVE_TLS logic is amputated. Config-time part of
    it made little sense as C++ 17 guarantees availability of
    thread_local, but we have manually curated deny-list of "bad" OSes,
    that we tested (via compile checks!) at configure time. Now this
    is all compile time. There is now compile-time kHaveGoodTLS variable
    and we're using it mostly via if constexpr.

    * kHaveGoodTLS case of creating thread cache is simplified and made
    more straightforward (no need to have in_setspecific logic).

    * !kHaveGoodTLS case if fixed and improved too. We avoid
    std::thread::get_id, as it deadlocks on mingw. We use errno address as
    a portable and (usually) async-signal safe 'my thread' identifier. We
    also eliminate linear searching of thread's cache and replace it with
    straightforward hash table lookup.

M	CMakeLists.txt
M	Makefile.am
M	cmake/config.h.in
M	configure.ac
M	src/base/basictypes.h
M	src/base/spinlock.h
M	src/debugallocation.cc
M	src/emergency_malloc_for_stacktrace.cc
M	src/heap-checker.cc
M	src/stacktrace.cc
M	src/static_vars.cc
M	src/tcmalloc.cc
M	src/thread_cache.cc
M	src/thread_cache.h
A	src/thread_cache_ptr.cc
A	src/thread_cache_ptr.h
M	vsprojects/include/config.h
M	vsprojects/libtcmalloc_minimal/libtcmalloc_minimal.vcxproj
M	vsprojects/libtcmalloc_minimal/libtcmalloc_minimal.vcxproj.filters
M	vsprojects/page_heap_test/page_heap_test.vcxproj
M	vsprojects/page_heap_test/page_heap_test.vcxproj.filters

commit 104e2dd2283f9f87d415ae79dafa7b8d14321621
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Feb 2 15:31:34 2024 -0500

    improve page_allocator debug diagnostics

    Lets clear objects that we're freeing. Helps catch use-after free for
    our internal memory allocations.

M	src/page_heap_allocator.h

commit d0b0134c4516356fca27d496873ed1ac33b26b05
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Jan 30 17:18:12 2024 -0500

    drop perftools_vsnprintf wrapper

    Because everyone now has functional and standards compiliant
    vsnprintf.

M	src/base/logging.h
M	src/internal_logging.cc
M	src/raw_printer.cc
M	src/tests/sampler_test.cc
M	src/windows/port.h

commit 51d3340b3908b24faaa67def6b8269fe180c303a
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Jan 30 16:02:26 2024 -0500

    avoid -Wunused-results warnings from read/write

    glibc with _FORTIFY_SOURCE sets those up to give warnings on unused
    results. We used to disable this warning globally, but lets do better.

M	CMakeLists.txt
M	Makefile.am
M	configure.ac
M	src/base/linuxthreads.cc
M	src/debugallocation.cc
M	src/internal_logging.cc
M	src/symbolize.cc
M	src/tcmalloc.cc

commit 1eb2d1a604402a94f094b9a0acb01ce16357ccbc
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Jan 30 15:17:01 2024 -0500

    bump msvc projects to VS2019 and c++ 17

M	vsprojects/addr2line-pdb/addr2line-pdb.vcxproj
M	vsprojects/addressmap_unittest/addressmap_unittest.vcxproj
M
vsprojects/current_allocated_bytes_test/current_allocated_bytes_test.vcxproj
M	vsprojects/frag_unittest/frag_unittest.vcxproj
M	vsprojects/libtcmalloc_minimal/libtcmalloc_minimal.vcxproj
M
vsprojects/low_level_alloc_unittest/low_level_alloc_unittest.vcxproj
M	vsprojects/malloc_extension_test/malloc_extension_test.vcxproj
M	vsprojects/malloc_hook_test/malloc_hook_test.vcxproj
M	vsprojects/markidle_unittest/markidle_unittest.vcxproj
M	vsprojects/nm-pdb/nm-pdb.vcxproj
M	vsprojects/packed-cache_test/packed-cache_test.vcxproj
M	vsprojects/page_heap_test/page_heap_test.vcxproj
M	vsprojects/pagemap_unittest/pagemap_unittest.vcxproj
M	vsprojects/preamble_patcher_test/preamble_patcher_test.vcxproj
M	vsprojects/realloc_unittest/realloc_unittest.vcxproj
M	vsprojects/sampler_test/sampler_test.vcxproj
M	vsprojects/stack_trace_table_test/stack_trace_table_test.vcxproj
M	vsprojects/system-alloc_unittest/system-alloc_unittest.vcxproj
M
vsprojects/tcmalloc_minimal_large/tcmalloc_minimal_large_unittest.vcxproj
M
vsprojects/tcmalloc_minimal_unittest/tcmalloc_minimal_unittest.vcxproj
M	vsprojects/thread_dealloc_unittest/thread_dealloc_unittest.vcxproj

commit 82a36a6fcdd5de8128d2f2b99a560691d067ea1e
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Jan 30 14:44:06 2024 -0500

    bump required c++ standard to c++-17

M	CMakeLists.txt
M	Makefile.am
M	cmake/tcmalloc.h.in
M	configure.ac
M	src/debugallocation.cc
M	src/gperftools/tcmalloc.h.in
M	src/libc_override_gcc_and_weak.h
M	src/libc_override_redefine.h
M	src/tcmalloc.cc
M	src/tests/tcmalloc_unittest.cc
M	vsprojects/include/gperftools/tcmalloc.h

commit faf96cd81ed97e55c6a9b062c2fa56911745400a
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Jan 30 15:53:33 2024 -0500

    reflect renaming src/tcmalloc{,_internal}.h in MSVC projects

M	vsprojects/libtcmalloc_minimal/libtcmalloc_minimal.vcxproj
M	vsprojects/libtcmalloc_minimal/libtcmalloc_minimal.vcxproj.filters

commit 71b3a0c6c4f20dd5a3b59db4b3b417a4ee04a261
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Jan 30 15:49:21 2024 -0500

    unreak gperftools/tcmalloc.h inclusion in MSVC projects

M	configure.ac
R100	vsprojects/gperftools/tcmalloc.h
vsprojects/include/gperftools/tcmalloc.h

commit 5db2adc4e71f600f8f2890b191d9a7acccf4f48e
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Jan 28 22:01:01 2024 -0500

    drop stale workaround for ancient solaris issue

M	CMakeLists.txt
M	Makefile.am
M	configure.ac
D	src/solaris/libstdc++.la

commit 5ce342e1c8628c0e433f2c33a440a4a2ce986b77
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Jan 28 21:40:39 2024 -0500

    fix generic_writer_test and proc_maps_iterator_test on cmake+msvc

M	CMakeLists.txt

commit 468ccf3d0dda369b1f6f06303f99e24ce00454a9
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Jan 28 20:34:36 2024 -0500

    refactor and cleanup proc_maps_iterator.cc

    We don't need messed up ProcMapsIterator class. Since our API has been
    simplified we simply have one "for-each" function for each
    implementation.

M	src/base/proc_maps_iterator.cc

commit a3080fa8d617b5c77738653d46e4f865a10f03ee
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Jan 27 19:05:38 2024 -0500

    extract proc-maps iteration into own file and cover it by tests

    This allows us, later, to avoid building this stuff in configurations
    that don't use it. I have also reduced API and ABI surface to enable
    further refactorings.

M	.gitignore
M	CMakeLists.txt
M	Makefile.am
C060	src/base/sysinfo.cc	src/base/proc_maps_iterator.cc
A	src/base/proc_maps_iterator.h
M	src/base/sysinfo.cc
M	src/base/sysinfo.h
M	src/heap-checker.cc
M	src/heap-profile-table.cc
M	src/malloc_extension.cc
M	src/profiledata.cc
M	src/symbolize.cc
A	src/tests/proc_maps_iterator_test.cc
M	vsprojects/libtcmalloc_minimal/libtcmalloc_minimal.vcxproj
M	vsprojects/libtcmalloc_minimal/libtcmalloc_minimal.vcxproj.filters
M
vsprojects/low_level_alloc_unittest/low_level_alloc_unittest.vcxproj
M
vsprojects/low_level_alloc_unittest/low_level_alloc_unittest.vcxproj.filters
M	vsprojects/page_heap_test/page_heap_test.vcxproj
M	vsprojects/page_heap_test/page_heap_test.vcxproj.filters

commit fa5c61f52eb4c2a05b45178b06f294a4a7844d6e
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Jan 28 20:25:15 2024 -0500

    stop trying to declare madvise on solaris

    It isn't needed on modern opensolaris. And in fact it breaks the
    build. And I am not entirely sure how to accomodate both old and new
    behavior. So lets keep things simple and assume that old
    behavior (where madvise needs to be declared) is ancient enough.

M	src/system-alloc.cc

commit f22f5b2a63a6f255110f2d31d8d1768c39e2408f
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Jan 28 20:24:42 2024 -0500

    workaround broken mmap allocator on solaris

M	src/system-alloc.cc

commit 7d37882df059b50ecf9a90a2b215004a3527708a
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Jan 28 20:19:18 2024 -0500

    implement GetProgramInvocationName for solaris

M	src/symbolize.cc

commit 689752dc38345cbd14c6fdfa63cbfe3960181458
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jan 29 20:54:47 2024 -0500

    generate vsprojects/gperftools/tcmalloc.h from our main tcmalloc.h

    This will save me from risk of forgetting to update this file manually
    when bumping package version.

M	configure.ac
M	src/gperftools/tcmalloc.h.in
M	vsprojects/gperftools/tcmalloc.h

commit d6728a0b4c57c245b866942fc9c4be837aaa263f
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jan 29 20:31:21 2024 -0500

    drop unused PACKAGE_XYZ defines from {cmake/vsproject}/config.h

    Automake or autoconf adds them automagically, but we don't really need
    them. Main effect of this change is that MSVC version of config.h
    doesn't duplicate package version.

M	cmake/config.h.in
M	vsprojects/include/config.h

commit 1eeea50f8988b7c3d3918d6a92db740fc58dd51a
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jan 29 20:22:31 2024 -0500

    don't use config.h PACKAGE_{VERSION,STRING} in tcmalloc_unittest

    It makes a lot more sense to test our public API which is
    TC_VERSION_STRING.

M	src/tests/tcmalloc_unittest.cc

commit 3e328e405859b1b7c3821cc5d8cabc943f269a5a
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jan 29 20:00:40 2024 -0500

    unbreak make dist

M	Makefile.am

commit 9a6848de8af67b55204887520bce34e41cdb6796
Author: lennoxho <lennoxhoe@gmail.com>
Date:	Sat Jan 27 06:28:45 2024 -0500

    A number of cleanups
    * Remove build dependency on HAVE_PTHREAD
    * Remove build dependency on HAVE_STD_ALIGNED_VAL_T and
    ENABLE_ALIGNED_NEW_DELETE
    * Remove redundant tcmalloc.h files & ensure there are no
    cross-build-tool references
    * Adopt automake commit 26927d1 in the CMake build

M	CMakeLists.txt
M	Makefile.am
M	cmake/config.h.in
M	cmake/tcmalloc.h.in
M	configure.ac
M	src/base/simple_mutex.h
M	src/base/threading.h
M	src/debugallocation.cc
M	src/gperftools/tcmalloc.h.in
M	src/libc_override_gcc_and_weak.h
M	src/libc_override_redefine.h
M	src/static_vars.cc
M	src/tcmalloc.cc
R100	src/tcmalloc.h	src/tcmalloc_internal.h
M	src/tests/memalign_unittest.cc
M	src/tests/tcmalloc_unittest.cc
M	src/tests/testutil.cc
D	src/windows/google/tcmalloc.h
D	src/windows/gperftools/tcmalloc.h.in
M	vsprojects/common.vcxproj.props
R096	src/windows/gperftools/tcmalloc.h
vsprojects/gperftools/tcmalloc.h
R097	vsprojects/config.h	vsprojects/include/config.h

commit 8b34e9425cc04c6de7fd44b50bba18d396f10805
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Jan 26 17:03:20 2024 -0500

    unbreak freebsd build

M	src/base/sysinfo.cc
M	src/thread_cache.cc

commit 96f34120fead4a16f4aa672f2266a3977b6a7253
Author: lennoxho <lennoxhoe@gmail.com>
Date:	Fri Jan 26 15:12:43 2024 -0500

    Several build fixes and cleanups
    - Fix CMake builds for MinGW and MSVC
    - Ensure the Autotools, CMake and VSProj builds do not reference
    each others' config.h
    - Use std::thread::id instead of our own thread ID wrappers
    - Moved explicit TLS wrapper functions into the tcmalloc:: namespace
    and change their visibility to hidden
    Resolves #1486

M	CMakeLists.txt
M	Makefile.am
M	cmake/config.h.in
M	configure.ac
M	src/base/threading.h
M	src/debugallocation.cc
M	src/getpc.h
M	src/heap-checker.cc
M	src/memory_region_map.cc
M	src/memory_region_map.h
M	src/profile-handler.cc
M	src/tcmalloc.cc
M	src/tests/debugallocation_test.cc
M	src/tests/malloc_hook_test.cc
M	src/tests/stack_trace_table_test.cc
M	src/thread_cache.cc
M	src/thread_cache.h
D	src/windows/mingw.h
M	src/windows/port.cc
M	src/windows/port.h
M	vsprojects/addr2line-pdb/addr2line-pdb.vcxproj
M	vsprojects/addressmap_unittest/addressmap_unittest.vcxproj
M	vsprojects/addressmap_unittest/addressmap_unittest.vcxproj.filters
A	vsprojects/common.vcxproj.props
R085	src/windows/config.h	vsprojects/config.h
M
vsprojects/current_allocated_bytes_test/current_allocated_bytes_test.vcxproj
M
vsprojects/current_allocated_bytes_test/current_allocated_bytes_test.vcxproj.filters
M	vsprojects/frag_unittest/frag_unittest.vcxproj
M	vsprojects/frag_unittest/frag_unittest.vcxproj.filters
M	vsprojects/libtcmalloc_minimal/libtcmalloc_minimal.vcxproj
M	vsprojects/libtcmalloc_minimal/libtcmalloc_minimal.vcxproj.filters
M
vsprojects/low_level_alloc_unittest/low_level_alloc_unittest.vcxproj
M
vsprojects/low_level_alloc_unittest/low_level_alloc_unittest.vcxproj.filters
M	vsprojects/malloc_extension_test/malloc_extension_test.vcxproj
M
vsprojects/malloc_extension_test/malloc_extension_test.vcxproj.filters
M	vsprojects/malloc_hook_test/malloc_hook_test.vcxproj
M	vsprojects/malloc_hook_test/malloc_hook_test.vcxproj.filters
M	vsprojects/markidle_unittest/markidle_unittest.vcxproj
M	vsprojects/markidle_unittest/markidle_unittest.vcxproj.filters
M	vsprojects/nm-pdb/nm-pdb.vcxproj
M	vsprojects/packed-cache_test/packed-cache_test.vcxproj
M	vsprojects/packed-cache_test/packed-cache_test.vcxproj.filters
M	vsprojects/page_heap_test/page_heap_test.vcxproj
M	vsprojects/page_heap_test/page_heap_test.vcxproj.filters
M	vsprojects/pagemap_unittest/pagemap_unittest.vcxproj
M	vsprojects/pagemap_unittest/pagemap_unittest.vcxproj.filters
M	vsprojects/preamble_patcher_test/preamble_patcher_test.vcxproj
M
vsprojects/preamble_patcher_test/preamble_patcher_test.vcxproj.filters
M	vsprojects/realloc_unittest/realloc_unittest.vcxproj
M	vsprojects/realloc_unittest/realloc_unittest.vcxproj.filters
M	vsprojects/sampler_test/sampler_test.vcxproj
M	vsprojects/sampler_test/sampler_test.vcxproj.filters
M	vsprojects/stack_trace_table_test/stack_trace_table_test.vcxproj
M
vsprojects/stack_trace_table_test/stack_trace_table_test.vcxproj.filters
M	vsprojects/system-alloc_unittest/system-alloc_unittest.vcxproj
M
vsprojects/system-alloc_unittest/system-alloc_unittest.vcxproj.filters
M
vsprojects/tcmalloc_minimal_large/tcmalloc_minimal_large_unittest.vcxproj
M
vsprojects/tcmalloc_minimal_large/tcmalloc_minimal_large_unittest.vcxproj.filters
M
vsprojects/tcmalloc_minimal_unittest/tcmalloc_minimal_unittest.vcxproj
M
vsprojects/tcmalloc_minimal_unittest/tcmalloc_minimal_unittest.vcxproj.filters
M	vsprojects/thread_dealloc_unittest/thread_dealloc_unittest.vcxproj
M
vsprojects/thread_dealloc_unittest/thread_dealloc_unittest.vcxproj.filters

commit ec4aa0367c888d4e8a19d3939405416e27018007
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Jan 26 16:55:51 2024 -0500

    support %zx format in TracePrintf

M	src/debugallocation.cc

commit d7dd9ea824e8d8b8395c8376f72e5a02fe80570f
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Jan 26 16:51:40 2024 -0500

    added missing include in generic_writer.cc

    We use std::min which require <algorithm> to be included.

M	src/base/generic_writer.cc

commit 79b6ad2ab594876b205ca9b5dee3661df32a3279
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Jan 25 16:10:30 2024 -0500

    amputate HAVE_FORK checking

    Pretty much everything has fork, except windows. Which is much simpler
    to test at compile time, then duplicating and complicating the test at
    configure time.

M	CMakeLists.txt
M	cmake/config.h.in
M	src/static_vars.cc
M	src/windows/config.h
M	src/windows/mingw.h

commit 8cc2d93055b58302e5deba0797669e1380983acd
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Jan 25 16:02:27 2024 -0500

    drop unnecessary pid_t/getpid dependencies

    It simplifies our windows story because pids stuff is different
    there. And we're not really using it anyways.

M	src/base/sysinfo.cc
M	src/windows/mingw.h
M	src/windows/port.h

commit 789fadc763c072616a1aeed7205e62a8eeb788df
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Jan 25 15:42:33 2024 -0500

    drop pid_t dependency in ProcMapsIterator and simplify it

    Original code was lifted from google-internal bits and perhaps those
    needed that feature (dumping other process-es proc-maps files). But
    our usage which is long-forked from theirs has always been to dump our
    own maps. So this complexity was never useful for us.

M	src/base/sysinfo.cc
M	src/base/sysinfo.h
M	src/heap-checker.cc

commit 913f70b66e1fb29682ae6491811a4d5c7871c1af
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Jan 25 15:41:04 2024 -0500

    drop disabled chunk of tcmalloc_unittest.cc

M	src/tests/tcmalloc_unittest.cc

commit 678b9e54dd0f3d901dbd2d040f4e56834c286314
Author: Lennox Ho <lennoxhoe@gmail.com>
Date:	Thu Jan 25 13:24:47 2024 -0500

    Work around malloc/HeapFree mismatch in early versions of Win11's
    shell32.dll

M	src/windows/patch_functions.cc

commit 5cab8f3f77016468c08f7cd60ee186fa5a5a5cad
Author: lennoxho <lennoxhoe@gmail.com>
Date:	Wed Jan 24 21:47:06 2024 -0500

    Convert MinGW builds to always use WinAPI based threading
    facilities. See ##1483

M	CMakeLists.txt
M	Makefile.am
M	cmake/config.h.in
M	src/base/basictypes.h
A	src/base/threading.h
M	src/debugallocation.cc
M	src/heap-checker.cc
M	src/memory_region_map.cc
M	src/memory_region_map.h
M	src/profile-handler.cc
M	src/tcmalloc.cc
M	src/tests/generic_writer_test.cc
M	src/tests/malloc_hook_test.cc
M	src/thread_cache.cc
M	src/thread_cache.h
M	src/windows/config.h
M	src/windows/mingw.h
M	src/windows/port.cc
M	src/windows/port.h

commit e3b3a7772782b3f77b2f13e83d6288e57046ccd8
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Jan 23 16:56:10 2024 -0500

    use generic writer when producing heap profiles

    This removes somewhat controversial intermediate step of sorting heap
    profile buckets and fixes issue where heap profiles could get
    truncated sometimes. See github issue #1450.

M	src/base/sysinfo.cc
M	src/base/sysinfo.h
M	src/heap-profile-table.cc
M	src/heap-profile-table.h
M	src/heap-profiler.cc
M	src/malloc_extension.cc
M	src/memory_region_map.h
M	src/profiledata.cc
M	src/symbolize.cc

commit cc2a1a14018a21146f449827626f7161b4bda69a
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Jan 23 17:03:36 2024 -0500

    amputate unused HeapProfileTable::IterateOrderedAllocContexts

M	src/heap-profile-table.cc
M	src/heap-profile-table.h

commit 7b41de4f4b6569fc19afbfd23d5b2e4914d02054
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Jan 23 16:53:51 2024 -0500

    allow AddressMap::Iterate via lambda

M	src/addressmap-inl.h

commit 24774ebb38bf5306d53a1baa05e0c17189c34a6d
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Jan 23 16:53:17 2024 -0500

    introduce generic_writer facility

M	.gitignore
M	CMakeLists.txt
M	Makefile.am
A	src/base/generic_writer.cc
A	src/base/generic_writer.h
A	src/tests/generic_writer_test.cc
M	vsprojects/addressmap_unittest/addressmap_unittest.vcxproj
M	vsprojects/addressmap_unittest/addressmap_unittest.vcxproj.filters
M	vsprojects/libtcmalloc_minimal/libtcmalloc_minimal.vcxproj
M	vsprojects/libtcmalloc_minimal/libtcmalloc_minimal.vcxproj.filters
M
vsprojects/low_level_alloc_unittest/low_level_alloc_unittest.vcxproj
M
vsprojects/low_level_alloc_unittest/low_level_alloc_unittest.vcxproj.filters
M	vsprojects/page_heap_test/page_heap_test.vcxproj
M	vsprojects/page_heap_test/page_heap_test.vcxproj.filters

commit 510006081fe88ec2f5cebb7a65daf1810a2901aa
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Jan 21 23:02:42 2024 -0500

    drop unused HasPosixThreads declaration

M	src/base/sysinfo.h

commit 61c064fdb57c379df4cd198d05a262b4f4d121f8
Author: barracuda156 <vital.had@gmail.com>
Date:	Tue Jan 9 23:51:06 2024 +0800

    check_address_test.cc: missed MAP_ANON fix

M	src/tests/check_address_test.cc

commit 365060c4213a48adb27f63d5dfad41b3dfbdd62e
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Jan 5 12:23:30 2024 -0500

    bump version to 2.15

M	CMakeLists.txt
M	NEWS
M	configure.ac
M	src/windows/config.h
M	src/windows/gperftools/tcmalloc.h

commit 5abc5721300463b7f05a34b4c95cf45664103b50
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Jan 4 19:33:18 2024 -0500

    move dynamic_annotations.cc under libsysinfo.la

    See github issue #1474 for immediate reason.

    Note, this entire idea of number of convenience libraries is likely
    simply artifact of Google's codebase past. We don't really need this
    complexity. But I am holding big reorganization of this for after API
    and ABI work. For now, simply moving dynamic_annotations.cc into
    libsysinfo fixes things. Most of the code links both anyways. So lets
    just do it.

M	Makefile.am

commit d5c1edf4f5fe901f40d96f4a9d4914f651742c88
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jan 3 16:06:39 2024 -0500

    [cmake] explicitly link more libraries for threading

    See discussion on https://github.com/gperftools/gperftools/pull/1473

M	CMakeLists.txt

commit 9430287d15a5c3dd7de9c1b205c6c034c82f35a1
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jan 1 12:38:26 2024 -0500

    few editorial fixes to NEWS for 2.14 release

M	NEWS

commit dcf01310551c91d83aeb9bcc8edcb4072d697bd7
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jan 1 01:02:20 2024 -0500

    correct NEWS entry about QNX (it supports heap profiler)

M	NEWS

commit e49b36f7d678443859f977bb9a2a3bada1f96ffc
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Dec 31 22:30:20 2023 -0500

    bump version to 2.14

M	CMakeLists.txt
M	NEWS
M	configure.ac
M	src/windows/config.h
M	src/windows/gperftools/tcmalloc.h

commit f17d54df5c41a9880c87e623bbf354bc773f440c
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Dec 31 23:12:09 2023 -0500

    add recently added getpc-inl.h to a set of headers to package

M	Makefile.am

commit fae6421668dd640afc4c7fb08134e53c240b4235
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Dec 31 23:16:00 2023 -0500

    avoid unused variable warning for TCMallocImplementation space

M	src/tcmalloc.cc

commit 1ba9f605798a4040c3de306f641899dc53cfa5ec
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Dec 31 21:59:53 2023 -0500

    construct malloc extension instances in static spaces

    So that malloc hooks can call into
    MallocExtension::instance()->GetAllocatedSize() and avoid recursion
    from new MallocExtension call inside that call.

    This was proposed by github user poljak181 at issue #1472

M	src/malloc_extension.cc
M	src/tcmalloc.cc

commit a0880d78f3bb996790075b986c0fa3c81624aacf
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Dec 31 21:33:30 2023 -0500

    Revert "[osx] implement native c++ allocation operators on osx"

    This reverts commit 6683e4f6eeebc52c0704500ef9f461454434578c.

M	src/libc_override_osx.h

commit 6299ae9869db5084bcab917627497da397386216
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Dec 31 21:23:25 2023 -0500

    test PREFER_LIBGCC_UNWINDER via defined()

    Our newly updated cmake bits now define it to empty, when it is
    enabled, so we want to test it right. Autoconf stuff behaves the same
    as before.

M	src/stacktrace.cc

commit bbc03edc4ddbcce216bd5fa490fd9383bea26a84
Author: Mateusz Jakub Fila <mateusz.jakub.fila@cern.ch>
Date:	Mon Dec 25 02:10:00 2023 +0100

    added missing aggressive decommit option in cmake

M	CMakeLists.txt

commit 9c2028ae5073b688da89b4866af8739a951f2fe3
Author: Mateusz Jakub Fila <mateusz.jakub.fila@cern.ch>
Date:	Mon Dec 25 02:04:33 2023 +0100

    added missing large alloc report option in cmake

M	CMakeLists.txt

commit eeb25dd2a50d63363adc6fe07e0eeea625f9b6ea
Author: Mateusz Jakub Fila <mateusz.jakub.fila@cern.ch>
Date:	Mon Dec 25 01:46:40 2023 +0100

    added missing finding asm/ptrace.h in cmake

M	CMakeLists.txt

commit 4e9fd729d2e7a5907fe118ff57b5218c27d5e824
Author: Mateusz Jakub Fila <mateusz.jakub.fila@cern.ch>
Date:	Mon Dec 25 01:38:09 2023 +0100

    added missing finding `HAVE___ATTRIBUTE__ALIGNED_FN` in cmake

M	CMakeLists.txt

commit ad4a6ff8de1c04bf5b55dc87057ad84aeeb2836f
Author: Mateusz Jakub Fila <mateusz.jakub.fila@cern.ch>
Date:	Sun Dec 24 02:38:59 2023 +0100

    added missing gcc unwinder preference option in cmake

M	CMakeLists.txt
M	cmake/config.h.in

commit 8987d08f792c1c694849a6e779735bfcf50ac8a4
Author: Mateusz Jakub Fila <mateusz.jakub.fila@cern.ch>
Date:	Sun Dec 24 01:51:00 2023 +0100

    fixed setting pagesize and pageshift in cmake

M	CMakeLists.txt
M	cmake/config.h.in

commit e9a2d3c46f58581b9c4198b11fc55ac88d9cc6f1
Author: barracuda156 <vital.had@gmail.com>
Date:	Sat Dec 16 09:53:35 2023 +0800

    mmap_hook.cc: use MAP_ANON when MAP_ANONYMOUS is not defined

M	src/mmap_hook.cc

commit 85048430ac587190b83973c86ceeb16c72bce9f2
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Dec 7 15:01:27 2023 -0500

    consolidate do_mallinfo{,2}

    We had 2 nearly identical implementations. Thankfully C++ templates
    facility lets us produce 2 different runtime functions (for different
    type widths) without duplicating source.

    Amend github issue #1414

M	src/debugallocation.cc
M	src/tcmalloc.cc

commit b8e75ae6fe7659ac98d488de3c138f7c9dcacd46
Author: Mateusz Jakub Fila <mateusz.jakub.fila@cern.ch>
Date:	Thu Dec 7 14:10:51 2023 +0100

    Add mallinfo2 function

M	CMakeLists.txt
M	Makefile.am
M	cmake/config.h.in
M	cmake/tcmalloc.h.in
M	configure.ac
M	src/debugallocation.cc
M	src/gperftools/tcmalloc.h.in
M	src/libc_override_aix.h
M	src/libc_override_gcc_and_weak.h
M	src/libc_override_redefine.h
M	src/tcmalloc.cc
M	src/windows/config.h

commit a9b734e3fa697aba64ec4ef3ef228ee532f23430
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Nov 26 23:43:24 2023 -0500

    perform ucontext->pc variants testing in compile-time

    As part of cpu profiler we're extracting current PC (program counter)
    of out signal's ucontext. Different OS and hardware combinations have
    different ways for that. We had a list of variants that we tested at
    compile time and populated PC_FROM_UCONTEXT macro into config.h. It
    caused duplication and occasional mismatches between our autoconf and
    cmake bits.

    So this commit changes testing to be compile-time. We remove
    complexity from build system and add some to C++ source.

    We use SFINAE to find which of those variants compile (and we silently
    assume that 'compiles' implies 'works'; this is what config-time
    testing did too). Occasionally we'll face situations where several
    variants compile. And we couldn't handle this case in pure C++. So we
    have a small Ruby program that generates chain of inheritance among
    SFINAE-specialized class templates. This handles prioritization among
    variants.

    List of ucontext->pc extraction variants is mostly same. We dropped
    super-obsolete (circa Linux kernel 2.0) arm variant. And NetBSD case
    is now improved. We now use their nice architecture-independent macro
    instead of x86-specific access.

M	CMakeLists.txt
D	cmake/PCFromUContext.cmake
M	cmake/config.h.in
M	configure.ac
D	m4/pc_from_ucontext.m4
A	src/gen_getpc.rb
A	src/getpc-inl.h
M	src/getpc.h
M	src/stacktrace_generic_fp-inl.h
M	src/tests/getpc_test.cc
M	src/windows/config.h

commit 8edeea4e838573b689d621425044d4efc6ed7f54
Author: Sergey Fedorov <vital.had@gmail.com>
Date:	Sat Nov 25 15:37:06 2023 +0800

    DefineTargetVariables.cmake: fix for macOS

M	cmake/DefineTargetVariables.cmake

commit 68db54545ee0be0967ae5ed0e54358e8fef04b9e
Author: Sergey Fedorov <vital.had@gmail.com>
Date:	Sat Nov 25 15:44:16 2023 +0800

    Minor fix-ups for PowerPC defines

M	src/base/basictypes.h
M	src/stacktrace_powerpc-inl.h

commit c815c760dab64a977c2c6f5d3a2a2a4bc9d10189
Author: Sergey Fedorov <vital.had@gmail.com>
Date:	Sat Nov 25 15:39:35 2023 +0800

    CMakeLists.txt: disable libunwind for ppc

M	CMakeLists.txt

commit 0ae8fe965081740547619d3d5b7f1fca1af4e0ce
Author: Sergey Fedorov <vital.had@gmail.com>
Date:	Sat Nov 25 15:27:20 2023 +0800

    PCFromUContext.cmake: fix macOS uc_mcontext

M	cmake/PCFromUContext.cmake

commit 36fa5ee9ef55103d9edc0a206270f487f2539465
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Nov 6 13:19:17 2023 -0500

    patch libtool.m4 for compiler_lib_search_path fix for qnx

    Amend github issue #1429

M	autogen.sh
A	m4/libtool.patch

commit 000af9a1646ebc8c2b8120b60a2946d9718a3072
Author: Julian Schroeder <jumaco@amazon.com>
Date:	Mon Oct 30 11:43:42 2023 -0600

    [stacktrace_generic_fp] clear aarch64 pointer auth bits

    AARCH64 >= armv8.3-a supports pointer authentication. If this
    feature is
    enabled it modifies the previously unused upper address bits in
    apointer.
    The affected bits need to be cleared in order for stacktrace to work.

    Signed-off-by: Aliaksey Kandratsenka <alkondratenko@gmail.com>
    [alkondratenko@gmail.com: added succinct subject line]

M	src/stacktrace_generic_fp-inl.h

commit d1a0cbe1bfd8bfaa6223fb9913fa872a760e536e
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Oct 30 19:47:02 2023 -0400

    [qnx] handle broken cfree and mallopt

M	configure.ac
M	src/libc_override_gcc_and_weak.h

commit 717bf724a5468fe7125d6eab0c292ca8ec33340b
Author: Xiang.Lin <myd.xia@gmail.com>
Date:	Thu Sep 21 15:42:33 2023 +0800

    Add heap profiler support for QNX

M	benchmark/unwind_bench.cc
M	configure.ac
M	src/base/basictypes.h
M	src/base/sysinfo.cc

commit adf24f9962c104f463966d0580540818fa723c44
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Oct 27 20:53:21 2023 -0400

    stacktrace_unittest: add simple way to skip ucontext testing

M	src/tests/stacktrace_unittest.cc

commit 4d1a9e92266f2109d9f535ad65434924765a2456
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Oct 23 10:14:16 2023 -0400

    stacktrace_unittest: test all stacktrace capturing methods

M	CMakeLists.txt
M	Makefile.am
M	src/stacktrace.cc
M	src/tests/stacktrace_unittest.cc

commit 4dc313870c7a91050e0ac12e411c52c68e761ba7
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Oct 24 16:21:15 2023 -0400

    add cmake warning that our support is incomplete

M	CMakeLists.txt

commit 96f4f075252a946e9e538fe104621e720f359105
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Oct 24 15:49:03 2023 -0400

    avoid unused variable warning in stacktrace_libunwind

M	src/stacktrace_libunwind-inl.h

commit db4eacc5d9faeef5e4d0277a45d23664aafdf81a
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Oct 23 11:46:02 2023 -0400

    avoid runtime initialization of null stacktrace implementation

    As we recently found out, initializing static struct fields or
    variables with lambdas, sets up runtime initialization instead of
    static initialization as we assumed. So lets avoid this too for null
    stacktrace implementation.

M	src/stacktrace.cc

commit 5ba86d37a3a88060c93e350209a9365ef3afaeb3
Author: Yikai Zhao <yikai@z1k.dev>
Date:	Fri Oct 13 13:04:35 2023 +0800

    update stacktrace_unittest to test overflow issue

    Signed-off-by: Aliaksey Kandratsenka <alkondratenko@gmail.com>
    [alkondratenko@gmail.com: squashed log update commit here]

M	src/tests/stacktrace_unittest.cc

commit dad9e8ceb943c108cf0687d6de273dfec3970df6
Author: Yikai Zhao <yikai@z1k.dev>
Date:	Wed Oct 11 19:43:28 2023 +0800

    Fix result overflow in generic_fp stacktrace

    In the 'with ucontext' case, the `skip_count` would be reset to 0, and
    `max_depth` should not be modified. Otherwise the result array
    would overflow.

M	src/stacktrace_generic_fp-inl.h

commit c48d4f1407d3b496eab531f6f0e5184049fe3d9e
Author: Romain Geissler <romain.geissler@amadeus.com>
Date:	Tue Oct 17 17:48:33 2023 +0000

    Avoid initilizing CheckAddress with a lambda, so that it also works
    with gcc 6.

M	src/check_address-inl.h

commit d48bf6b3adad65756ed79b843b85409aa34459f8
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Sep 27 21:37:30 2023 -0400

    force inline do_mmap_with_hooks

    Otherwise mmap calling to do_mmap_with_hooks might tail-call (instead
    of inlining), which will then break GetCallerStackTrace
    facility (since only mmap is placed into special malloc_hook section).

    This unbreaks heap checker on gcc 5, but is in general right thing to
    do.

M	src/mmap_hook.cc

commit 9a123db7b441072a1892e0bab6a101763743aa1c
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Sep 27 21:35:29 2023 -0400

    work around tuple construction miscompilation on gcc 5

    This fixes github issue #1432

M	src/base/sysinfo.cc

commit d152d76cd14c9e439aa3d9c8a720b7601a66df97
Author: Yikai Zhao <yikai@z1k.dev>
Date:	Mon Sep 25 19:04:23 2023 +0800

    generic_fp stacktrace: check frame size threshold for initial frame

M	src/stacktrace_generic_fp-inl.h

commit 64d64bee40811ae19cb119414bdd5e078094d8a7
Author: Lennox Ho <lennoxhoe@gmail.com>
Date:	Thu Sep 21 10:31:29 2023 +0800

    Fix C++ aligned allocation detected in the CMake build

M	CMakeLists.txt

commit 589d416977977f32fde82cd623a7a876ab1d397c
Author: Lennox Ho <lennoxhoe@gmail.com>
Date:	Tue Sep 19 14:53:16 2023 +0800

    Add a more performant SpinLockDelay implementation for Windows based
    on WaitOnAddress and friends

M	CMakeLists.txt
M	Makefile.am
M	src/base/spinlock_win32-inl.h

commit fd0fabe1831be3a3344048436f0a4ec89bf96466
Author: Lennox Ho <lennoxhoe@gmail.com>
Date:	Tue Sep 19 14:47:46 2023 +0800

    Fix Windows CMake build by linking page_heap_test and mmap_hook_test
    to the entire library

M	CMakeLists.txt

commit 17f23e8d1ef3832663c019e2420307c7068a5543
Author: Lennox Ho <lennoxhoe@gmail.com>
Date:	Mon Sep 18 06:37:58 2023 +0800

    Add the ability to disable TCMalloc replacement on Windows via
    environment variable TCMALLOC_DISABLE_REPLACEMENT=1

M	src/windows/patch_functions.cc

commit df006e880e1ca6fa3a3ccc3a44a65a9e8bec298c
Author: Lennox Ho <lennoxhoe@gmail.com>
Date:	Sun Sep 17 07:59:40 2023 +0800

    Also expose SetMemoryReleaseRate and GetMemoryReleaseRate as C shims

M	src/gperftools/malloc_extension_c.h
M	src/malloc_extension.cc

commit d3602c0672daebe2edd533fda968a1f36233d706
Author: Lennox Ho <lennoxhoe@gmail.com>
Date:	Sun Sep 17 07:49:38 2023 +0800

    Account for Windows while performing implicit TLS detection in
    CMakeLists.txt

M	CMakeLists.txt

commit dffb4a2f284700b814e2c3aa1f9263fd14e836f8
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Sep 11 16:11:27 2023 -0400

    bump version to 2.13

M	CMakeLists.txt
M	NEWS
M	configure.ac
M	src/windows/config.h
M	src/windows/gperftools/tcmalloc.h

commit 4ec8c9dbb25e2844f98f7acc848aa3b190349d70
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Sep 10 22:18:51 2023 -0400

    reduce set of nallocx size testing points

    Testing every 7th size is a bit slow on slower machines. No need to be
    as thorough. We now bump by about 1/128th each step which is still
    more steps than size classes we have.

M	src/tests/tcmalloc_unittest.cc

commit e4e7ba93a03e469e1d11153bf724e422509ebab7
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Sep 10 21:06:02 2023 -0400

    unbreak unnecessary dependency on 64-bit atomics

    This unbreaks builds on 32-bit arms and mipsen.

M	src/tests/profile-handler_unittest.cc

commit 523b72f754246d4c3736c82ba7fa0576b672497e
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Sep 10 18:12:45 2023 -0400

    make sampling_debug_test actually test debug malloc

    We do shell wrapper for actual test run, so we can inspect output of
    pprof. But when we set up sampling_debug_test.sh we simply copied
    regular sampling_test.sh, which ran same non-debug test binary. Now we
    sed-replace contents of shell program when copying, so we test right
    binary.

    Another thing we fix here is our (still hardcoded) test output path is
    now different between sampling{,_debug}_test.sh. So this fixes main
    cause of flakiness of our unit tests.

M	Makefile.am

commit 2748dd56803d61b8aee8fbb8bbdf9bc6d2913529
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Sep 8 19:47:17 2023 -0400

    unbreak address access "probing" for generic_fp backtracing

    We used msync to verify that address is readable. But msync gives
    false positives for PROT_NONE mappings. And we recently got bug report
    from user hitting this exact condition.

    For correct access check, we steal idea from Abseil and do sigprocmask
    with address used as new signal mask and with invalid HOW
    argument. This works in today's Linux kernels and is among fastest
    methods available. But is brittle w.r.t. possible kernel changes. So
    we supply fallback method that does 2 syscalls.

    For non-Linux systems we implement usual "write to pipe" trick. Which
    also has decent performance, but requires occasional pipe draining and
    uses fds which could occasionally be damaged by some forking codes.

    We also finally cover all new code with unit test.

    Fixes github issue #1426

M	.gitignore
M	CMakeLists.txt
M	Makefile.am
A	src/check_address-inl.h
M	src/stacktrace_generic_fp-inl.h
A	src/tests/check_address_test.cc

commit 7ad1dc7693b7b04199681df474122248634a9808
Author: Ivan Dlugos <dlugos.ivan@gmail.com>
Date:	Mon Sep 4 14:40:27 2023 +0200

    fix: cmake config.h defines declaration

M	.gitignore
M	cmake/config.h.in
M	src/base/logging.h
M	src/base/sysinfo.cc
M	src/getpc.h
M	src/malloc_hook.cc
M	src/profile-handler.cc
M	src/profiler.cc
M	src/stacktrace_generic_fp-inl.h
M	src/stacktrace_powerpc-linux-inl.h

commit f7172839a1a3ca99309ab322d8ea085967ecaf4d
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Sep 8 14:22:46 2023 -0400

    turn tcmalloc::TrivialOnce into POD

    As we see in github issue #1428, msvc arranges full "init on first
    use" initialization for local static usage of TrivialOnce even if that
    initialization is completely empty. Fair game, even if stupid.

    POD with no initialization should be safely zero-initialized with no
    games or tricks from the compilers.

    We could have and perhaps at some point should do constexpr for
    TrivialOnce and SpinLock (abseil has been liberated from
    LinkerInitialized for perphaps well over decade now, including their
    fork of SpinLock, of course). But C++ legalese rules are complex
    enough and bugs happened in past, so I don't want to be in the tough
    business of interpreting standard. So at least for now we keep
    things simple.

M	src/base/spinlock.h
M	src/debugallocation.cc
M	src/heap-checker.cc
M	src/malloc_hook.cc
M	src/profile-handler.cc

commit 539ed9ca40f4d3806e7a2b79b5aa02b9a45083d3
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Aug 24 15:03:47 2023 -0400

    bump version 2.12

M	CMakeLists.txt
M	NEWS
M	configure.ac
M	src/windows/config.h
M	src/windows/gperftools/tcmalloc.h

commit 8d634c1f56d282b55ad414a0d8b3bba5cad9bb93
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Aug 24 14:06:25 2023 -0400

    don't build mmap_hook when --enable-minimal is given to configure

    Refers to github issue #1418

M	Makefile.am

commit b4ad04982d4710f7dccae6c4d348df224cc94dad
Author: Brett T. Warden <brett.t.warden@intel.com>
Date:	Tue Aug 15 16:21:47 2023 -0700

    Set Description field in generated pkg-config files (instead of
    Summary)

    Fixes #1416

M	Makefile.am

commit 0a3ca5b43d7358c901d78cefef593ad8a7a96ab3
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Aug 14 22:47:56 2023 -0400

    bump version to 2.11

M	CMakeLists.txt
M	NEWS
M	configure.ac
M	src/windows/config.h
M	src/windows/gperftools/tcmalloc.h

commit 83fccceffaa3e526d2612b34400c772745e8441c
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Aug 14 10:12:11 2023 -0400

    bump README freshness a bit

M	README

commit c41eb9e8b594a3a6ccd973f38edb80554c1e31e1
Author: Ken Raffenetti <raffenet@mcs.anl.gov>
Date:	Fri Aug 11 10:23:37 2023 -0500

    Add MPICH HPC environment detection

    Default MPICH builds use the Hydra process manager (mpiexec)
    which sets
    PMI_RANK in the application environment. Update GetUniquePathFromEnv()
    test accordingly.

    Signed-off-by: Ken Raffenetti <raffenet@mcs.anl.gov>

M	src/base/sysinfo.cc
M	src/tests/unique_path_unittest.cc

commit 1d2654f3a0e5da3f51da5245edb24489efd51773
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Aug 10 00:22:45 2023 -0400

    heap-checker: unbreak PTRACE_GETREGS detection on older Linux-es

    This unbreaks RHEL6.

M	src/heap-checker.cc

commit dbd10716809320c7fb89dd43d1e6b913ed1378c3
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Aug 9 22:11:41 2023 -0400

    link libprofiler with pthread

    This unbreaks building on older Linux distros. We missed this at
    46d3315ad7901099bd414740dbfbe6d27f33da9a when dropped maybe_thread
    stuff, since libprofiler indeed uses pthread, and because on newer
    libc-s pthread stuff is now part of regular libc.so.

    I am also dropping bogus LIBPROFILER stuff referring to some rpath
    badness. Unsure what it was, maybe way back we did libstacktrace as a
    proper libtool library, so maybe something was needed. But it is just
    a convenience archive this days, so we don't really need to add it
    everywhere libprofiler.la is linked.

M	Makefile.am

commit 729383b486b3e26626e1dd354c8b5098d104f19f
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Aug 9 23:29:00 2023 -0400

    make sure that ListerThread runs on properly aligned stack

    Without this fix we're failing unit tests on ubuntu 18.04 and centos 7
    and 6. It looks like clone() in old glibc-s doesn't align stack, so
    lets handle it ourselves. How we didn't hit this much earlier (before
    massive thread listing refactoring), I am not sure. Most likely pure
    luck(?)

M	src/base/linuxthreads.cc

commit 51c5e2bec7a53a7f1e5e44c866239fedb8ecd590
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Aug 9 13:18:59 2023 -0400

    massage latest GetUniquePathFromEnv changes

    This fixes a number of minor bits (like build details) as well as
    making overall code style similar to what we're doing elsewhere.

M	.gitignore
M	CMakeLists.txt
M	Makefile.am
M	src/base/sysinfo.cc
M	src/base/sysinfo.h
M	src/tests/unique_path_unittest.cc

commit 86450ad99fc9708ac5f1b79d5c7f089d50821a42
Author: Artem Polyakov <artpol84@gmail.com>
Date:	Thu Jul 13 17:43:29 2023 -0700

    Add unit test for GetUniquePathFromEnv()

    Signed-off-by: Artem Polyakov <artpol84@gmail.com>

M	Makefile.am
A	src/tests/unique_path_unittest.cc

commit 881b754da0c9c8b5e711113aecfad5f7f8ef95f2
Author: Artem Y. Polyakov <artpol84@gmail.com>
Date:	Thu Apr 1 15:27:22 2021 -0700

    Advanced UniquePathFromEnv generation

    * Add support for known HPC environments (TODO: needs to be extended
    with more nevironments)
    * Added the "CPUPROFILE_USE_PID" environment variable to force
    appending
    PID for the non-covered environments
    * Preserve the old way of handling the Child-Parent case

    Signed-off-by: Artem Polyakov <artpol84@gmail.com>

M	src/base/sysinfo.cc
M	src/base/sysinfo.h

commit 57512e9c3dec5de857c856d4e7783a69ea3cd872
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Aug 6 19:24:17 2023 -0400

    unbreak -Wthread-safety

    It actually found real (but arguably minor) issue with memory region
    map locking.

    As part of that we're replacing PageHeap::DeleteAndUnlock that had
    somewhat ambitious 'move' of SpinLockHolder, with more straightforward
    PageHeap::PrepareAndDelete. Doesn't look like we can support move
    thingy with thread annotations.

M	src/base/spinlock.h
M	src/heap-profile-table.cc
M	src/memory_region_map.cc
M	src/memory_region_map.h
M	src/page_heap.cc
M	src/page_heap.h
M	src/tcmalloc.cc
M	src/tests/page_heap_test.cc

commit 862039c1850d56c64f482909d615ffcffbfcdfc0
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Aug 6 14:44:05 2023 -0400

    don't -momit-leaf-frame-pointer when asked for full frame pointers

M	Makefile.am

commit dc25c1fd4c4b9de71f91013a8c0b811164494eed
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jul 31 20:04:39 2023 -0400

    bump version to 2.11rc

M	CMakeLists.txt
M	NEWS
M	configure.ac
M	src/windows/config.h
M	src/windows/gperftools/tcmalloc.h

commit 909fa3e649c659bbb055f97cc9277080a1725ea8
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jul 31 16:27:33 2023 -0400

    unbreak MallocExtension::GetAllocatedSize() for debug allocator

    Some years back we fixed memalign vs realloc bug, but we preserved
    'wrong' malloc_size/GetAllocatedSize implementation for debug
    allocator.

    This commit refactors old code making sure we always use right
    data_size and it fixes GetAllocatedSize. We update our unittest
    accordingly.

    Closes #738

M	src/debugallocation.cc
M	src/tests/debugallocation_test.cc

commit a51e08b06a4318a201547b7458f6483e830d86e5
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jul 31 15:40:13 2023 -0400

    drop obsolete TODO file

M	Makefile.am
D	TODO

commit a1c7ce779317adc3d4128daa37523b3ba935a34e
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jul 31 15:16:14 2023 -0400

    refresh README-s

M	README
M	README_windows.txt

commit bef6592746445db220fc29a8ed9dc0123e628221
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jul 31 15:10:56 2023 -0400

    refresh INSTALL

M	INSTALL

commit e3de2e3242fc33aecc7b7f7519aac783bfd15b4f
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jul 31 14:28:58 2023 -0400

    remove obsolete references to code.google.com

    I.e. somehow we managed to still point to (very) old gperftools
    hosting location, so lets fix it at last.

M	CMakeLists.txt
M	INSTALL
M	configure.ac
M	src/debugallocation.cc
M	src/heap-checker.cc
M	src/page_heap.cc
M	src/stacktrace_win32-inl.h
M	src/tests/large_heap_fragmentation_unittest.cc

commit 1ff09a680e6239675bbc03ab385872276409558b
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jul 31 14:28:40 2023 -0400

    drop obsolete deb/rpm packaging stuff

M	Makefile.am
D	packages/deb.sh
D	packages/deb/README
D	packages/deb/changelog
D	packages/deb/compat
D	packages/deb/control
D	packages/deb/copyright
D	packages/deb/docs
D	packages/deb/libgperftools-dev.dirs
D	packages/deb/libgperftools-dev.install
D	packages/deb/libgperftools0.dirs
D	packages/deb/libgperftools0.install
D	packages/deb/libgperftools0.manpages
D	packages/deb/rules
D	packages/rpm.sh
D	packages/rpm/rpm.spec

commit 8b3f0d61451e891e1ca91a4887e472b80e9ff351
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jul 31 14:04:32 2023 -0400

    undo MarkThreadTemporarilyIdle and make it same as MarkThreadIdle

    As noted on github issue #880 'temporarily' thing saves us not just on
    freeing thread cache, but also returning thread's share of thread
    cache (max_size_) into common pool. And the later has caused trouble
    to mongo folk who originally proposed 'temporarily' thing. They claim
    they don't use it anymore.

    And thus with no users and no clear benefit, it makes no sense for us
    to keep this API. For API and ABI compat sake we keep it, but it is
    now identical to regular MarkThreadIdle.

    Fixes issue #880

M	src/gperftools/malloc_extension.h
M	src/tcmalloc.cc
M	src/thread_cache.cc
M	src/thread_cache.h

commit c3059a56be3f1f1581c06d77ef04b0b7ecc8cc6f
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jul 31 12:26:21 2023 -0400

    dont workaround unknown problem in thread_dealloc_unittest

    We had some sleep added at the end up thread dealloc unittest claiming
    some race trouble with glibc. Which is likely years or even decades
    irrelevant.

M	src/tests/thread_dealloc_unittest.cc

commit 9b91ce917ad54fab8dd658daeed32bababd367bb
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Jul 27 19:08:54 2023 -0400

    [win32:patching] define single empty __expand replacement

    This unbreaks some cases where patching complains about too short
    functions to patch.

    What happens is we first locate one of CRT-s (like ucrt or msvcrt) and
    patch __expand there, redirecting to our implementation. Then "static"
    __expand replacement is patched, but it is usually imported from that
    same C runtime DLL. And through several jmp redirections we end up at
    our own __expand from libc<1>. Patching that (and other cases) is
    wrong, but I am unsure how to fix it properly. So we do most simple
    workaround. I found that when it not fails is either in debug builds
    where empty expand is not too short or when MSVC deduplicates multiple
    identical __expand implementations into single function, or when
    64-bit patching has to do extra trampoline thingy. And then our
    patching code checks if we're trying to replace some function with
    itself. So we "just" take advantage of that and get immediate issue
    fixed, while punting on more general "duplicate" patching for later.

    Update github issue #667

M	src/windows/patch_functions.cc

commit b6cdd8f510d9b8af03cb2c115f87c4b46257ec75
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Jul 27 19:23:15 2023 -0400

    [mingw] dont add libstacktrace to libtcmalloc_minimal

    There was this piece of makefile with indention to add stack tracing
    functionality (for stuff like growthz, GetCallerStackTrace and
    probably heap sampling) to work even in minimal configuration on
    mingw.

    What is odd is we fail to actually define libstacktrace.la target on
    mingw, since libstacktrace.la requires WITH_STACK_TRACE automake
    conditional which we don't enable on this platform. And yet somehow it
    doesn't fail. It produces empty libstacktrace.la, so build kinda
    works. Except at least on my machine it produces racy makefiles. So
    lets not pretend and stop breaking our parallel builds.

M	Makefile.am

commit a5cfd38884a34d374919eee22626c70cabd21a72
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Jul 25 15:58:02 2023 -0400

    [win32] amend and unbreak previous NOMINMAX fix

M	src/windows/config.h

commit d2c89ba53433f8f0940e8bf086436895e46436a6
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jul 24 18:57:52 2023 -0400

    don't return raw span when sampling and stacktrace oomed

    This is nearly impossible in practice, but still. Somehow we missed
    this logic that DoSampledAllocation always returns actual object, but
    in that condition where stacktrace_allocator failed to get us
    StackTrace object we ended up returning span instead of it's object.

M	src/tcmalloc.cc

commit 59464404d1e900e9664a22960e75659eed04d8e8
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Dec 30 14:21:00 2021 -0800

    capture growthz backtraces outside of pageheap_lock

    Actual growthz list is now lockless since we never delete anything
    from it. And we now pass special 'locking context' object down page
    heap allocation path, both as a documentation that it is under lock
    and for tracking whether we needed to grow heap and by how much. Then
    whenever lock is released in RAII fashion, we're able to trigger
    growthz recording outside of lock.

    Closes #1159

M	src/page_heap.cc
M	src/page_heap.h
M	src/static_vars.cc
M	src/static_vars.h

commit 0d42a48699059826b99dd5d1a1bb99c5669f089b
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Dec 27 17:35:53 2021 -0800

    move page heap locking under PageHeap

    While there is still plenty of code that takes pageheap_lock outside
    of page_heap module for all kinds of reasons, at least
    bread-and-butter logic of allocating/deallocating larger chunks of
    memory is now handling page heap locking inside PageHeap itself. This
    gives us flexibility.

    Update issue #1159

M	src/base/spinlock.h
M	src/central_freelist.cc
M	src/page_heap.cc
M	src/page_heap.h
M	src/static_vars.cc
M	src/static_vars.h
M	src/tcmalloc.cc
M	src/tests/page_heap_test.cc

commit a3e1080c2e7038a4205168f1f9e086b530743272
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Dec 27 21:26:18 2021 -0800

    handle large alloc reporting locklessly

    Which simplifies codes a bit.

    Update issue #1159

M	src/tcmalloc.cc

commit f1eb3c82c6b55d99bc657435b3fc42dae613440f
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Dec 27 14:45:56 2021 -0800

    correctly release memory when system's pagesize is >kPageSize

    I.e. this covers case of arms that by default compile tcmalloc for 8k
    logical pages (assuming 4k system pages), but can actually run on
    systems with 64k pages.

    Closes #1135

M	src/common.cc
M	src/common.h
M	src/page_heap.cc
M	src/page_heap.h
M	src/static_vars.cc
M	src/tcmalloc.cc
M	src/tests/page_heap_test.cc
M	src/tests/tcmalloc_unittest.cc

commit d521e3b30e208af635e9812fe9bff635bbafcb1d
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Dec 27 14:41:42 2021 -0800

    move page heap allocations with alignment into page heap

M	src/page_heap.cc
M	src/page_heap.h
M	src/tcmalloc.cc
M	src/tests/page_heap_test.cc

commit ad0ca2b83ba6743afcb8038788e9195bbd1514d1
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jul 24 18:07:25 2023 -0400

    unbreak large heap fragmentation unittest

    Smart compilers again (and lack of -fno-builtin-malloc which we
    dropped because of clang).

M	src/tests/large_heap_fragmentation_unittest.cc

commit bd3bf9abd7b42acdec38a98ceabc659adf8a9225
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jul 24 19:40:49 2023 -0400

    define NOMINMAX on windows

    Otherwise we cannot use some std bits, like numeric_limits.

M	src/windows/config.h
M	src/windows/port.cc

commit 814f340eede8c991885f10deca929031fe2531bb
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Jul 22 20:45:52 2023 -0400

    add --enable-libgcc-unwinder-by-default for configure

    We want distros to ship gperftools with this options, now that they
    have _Unwind_Backtrace that is powered by dl_find_object.

M	configure.ac
M	src/stacktrace.cc

commit f06ccc6f799fa2fe550a8bee08314393586fb472
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Jul 22 14:21:47 2023 -0400

    dont test HAVE_{STDINT,INTTYPES}_H

    Those are fairly standard by now. We already require C++11 or later
    compiler.

M	CMakeLists.txt
M	cmake/config.h.in
M	src/addressmap-inl.h
M	src/base/basictypes.h
M	src/central_freelist.h
M	src/common.h
M	src/debugallocation.cc
M	src/heap-profile-table.cc
M	src/heap-profiler.cc
M	src/internal_logging.h
M	src/malloc_extension.cc
M	src/malloc_hook.cc
M	src/memfs_malloc.cc
M	src/memory_region_map.cc
M	src/packed-cache-inl.h
M	src/page_heap.cc
M	src/page_heap.h
M	src/pagemap.h
M	src/sampler.h
M	src/stack_trace_table.h
M	src/symbolize.h
M	src/system-alloc.cc
M	src/tcmalloc.cc
M	src/tests/heap-checker_unittest.cc
M	src/tests/memalign_unittest.cc
M	src/tests/pagemap_unittest.cc
M	src/tests/profiledata_unittest.cc
M	src/tests/sampler_test.cc
M	src/tests/system-alloc_unittest.cc
M	src/tests/tcmalloc_unittest.cc
M	src/tests/testutil.cc
M	src/thread_cache.h
M	src/windows/config.h
M	src/windows/port.h

commit 86867674f05a94d9e761310bb5c3e7b4b4534634
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Jul 22 14:03:49 2023 -0400

    don't do syscall on osx

    Their compiler barks and we only need this syscall business on
    FreeBSD.

M	src/base/logging.h

commit bdae3615ca51b5aa8e7075396dc0c53748c78076
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Jul 22 14:01:55 2023 -0400

    osx's dyld_present is always true

    As reported to us by their compiler's warning.

M	src/base/basictypes.h

commit 91b8024aa1e5cd8e6588df4e9c7a6280c8f03b3a
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Jul 22 14:00:32 2023 -0400

    drop unused ThreadCache::DropCacheWhichMustBePresent

M	src/thread_cache.h

commit 42dde1b883b29921ac89234369f88b133821690c
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sat Jul 22 00:08:38 2023 -0400

    heap-checker_unittest: run thread-unsafe libc calls less unsafely

    Comment there says race is fine, bit it isn't. Crashes under
    musl. Lets not crash.

M	src/tests/heap-checker_unittest.cc

commit 8be84e4a5c28c33bfdb7da3ee0c92d9620cd552f
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Jul 21 14:18:12 2023 -0400

    drop old mmap hooks and introduce internal & simpler mmap_hook.h

    Previous implementation wasn't entirely safe w.r.t. 32-bit off_t
    systems. Specifically around mmap replacement hook. Also, API was a
    lot more general and broad than we actually need.

    Sadly, old mmap hooks API was shipped with our public headers. But
    thankfully it appears to be unused externally (checked via github
    search). So we keep this old API and ABI for the sake of formal API
    and ABI compatibility. But this old API is now empty and always
    fails (some OS/hardware combinations didn't have functional
    implementations of those hooks anyways).

    New API is 64-bit clean and only provides us with what we need. Namely
    being able to react to virtual address space mapping changes for
    logging, heap profiling and heap leak checker. I.e. no pre hooks or
    mmap-replacement hooks. We also explicitly not ship this API
    externally to give us freedom to change it.

    New code is also hopefully tidier and slightly more portable. At least
    there are fewer arch-specific ifdef-s.

    Another somewhat notable change is, since mmap hook isn't needed in
    "minimal" configuration, we now don't override system's
    mmap/munmap/etc functions in this configuration. No big deal, but it
    reduces risk of damage if we somehow mess those up. I.e. musl's mmap
    does few things that our mmap replacement doesn't, such as very fancy
    vm_lock thingy. Which doesn't look critical, but is good thing for us
    not to interfere with when not necessary.

    Fixes issue #1406 and issue #1407. Lets also mention issue #1010 which
    is somewhat relevant.

M	.gitignore
M	CMakeLists.txt
M	Makefile.am
M	src/base/low_level_alloc.cc
M	src/base/spinlock.h
M	src/heap-checker.cc
M	src/heap-profiler.cc
M	src/malloc_hook-inl.h
M	src/malloc_hook.cc
D	src/malloc_hook_mmap_freebsd.h
D	src/malloc_hook_mmap_linux.h
M	src/memory_region_map.cc
M	src/memory_region_map.h
A	src/mmap_hook.cc
A	src/mmap_hook.h
M	src/tests/malloc_hook_test.cc
A	src/tests/mmap_hook_test.cc
M	src/tests/tcmalloc_unittest.cc
M	vsprojects/libtcmalloc_minimal/libtcmalloc_minimal.vcxproj
M	vsprojects/libtcmalloc_minimal/libtcmalloc_minimal.vcxproj.filters
M
vsprojects/low_level_alloc_unittest/low_level_alloc_unittest.vcxproj
M
vsprojects/low_level_alloc_unittest/low_level_alloc_unittest.vcxproj.filters
M	vsprojects/page_heap_test/page_heap_test.vcxproj
M	vsprojects/page_heap_test/page_heap_test.vcxproj.filters

commit 6b691cc019500dc4547822b1eed2fd53adc6b43c
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Jul 21 14:18:01 2023 -0400

    drop patching virtual alloc fns on windows

    It wasn't implemented exactly right and, most importantly, there is
    nothing on windows that uses those (now dead) mmap hooks.

M	src/windows/patch_functions.cc

commit fecaf37ae4f172c62ce4d1f42062b690cc96fabc
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Jul 21 13:51:36 2023 -0400

    drop DevMemSysAllocator

    It was never useful for anything.

M	src/system-alloc.cc

commit e53ec241b6f085a770b3f5e558dac8f85963a4d4
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Jul 20 21:53:54 2023 -0400

    unbreak __sbrk detection on cmake

M	CMakeLists.txt

commit d4f33620351f303e64d1a6dd3c4c79ad53532be6
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Jul 21 14:21:37 2023 -0400

    add missing .gitignore for safe_strerror_test.exe

M	.gitignore

commit e0f4c0e6fb402e56e82a82438561f413090f0ac8
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jul 17 19:31:06 2023 +0000

    manually inline MapObjectToSpan into ReleaseToSpans

    It was originally separated into own function due to some (now
    obsolete) compiler optimization bug. We stopped worked around that bug
    few commits ago. But as github user plopresti rightfully pointed
    out (much, much thanks!), we lost `static' on that function. But since
    it is trivial function and used exactly once, it is best to simply
    inline it's 2 lines of code back instead of returning static.

    Previous commit was: 68b442714a86060d1dd95de4c515cc7774e3751e

M	src/central_freelist.cc

commit 46d3315ad7901099bd414740dbfbe6d27f33da9a
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Jul 14 02:19:21 2023 -0400

    amputate maybe_threads

    This facility allowed us to build tcmalloc without linking in actual
    -lpthread. Via weak symbols we checked at runtime if pthread functions
    are available and if not, special single-threaded stubs were used
    instead. Not always brining in pthread dependency helped performance
    of some programs or libraries which depended at runtime on whether
    threads are linked or not. Most notable of those are libstdc++ which
    uses non-atomic refcounting on single threaded programs.

    But such optional dependency on pthreads caused complications for
    nearly no benefit. One trouble was reported in github issue #1110.

    This days glibc/libstdc++ combo actually depends on
    sys/single_threaded.h facility. So bringing pthread at runtime is
    fine. Also modern glibc ships pthread symbols inside libc anyways and
    libpthread is empty. I also found that for whatever reason on BSDs and
    osx we already pulled in proper pthreads too.

    So we loose nothing and we get issue #1110 fixed. And we simplify
    everything.

M	.gitignore
M	CMakeLists.txt
M	INSTALL
M	Makefile.am
M	configure.ac
M	src/heap-checker.cc
M	src/malloc_extension.cc
M	src/malloc_hook.cc
D	src/maybe_threads.cc
D	src/maybe_threads.h
M	src/profile-handler.cc
M	src/static_vars.cc
M	src/tests/low_level_alloc_unittest.cc
D	src/tests/maybe_threads_unittest.sh
M	src/thread_cache.cc
M	src/thread_cache.h
M	src/windows/port.h

commit 3cd265b05a1c951010ae352fe47bdab850d68357
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Jul 14 01:56:28 2023 -0400

    replace pthread_once usages with simple spinlock-backed flag

    Our perftools_pthread_once implementation has some ifdefs and what
    not. I.e. some OSes have complications around early usage and windows
    is windows. But in fact we can implement trivial spinlock-supported
    implementation and depend on nothing.

    Update issue #1110

M	src/base/spinlock.h
M	src/debugallocation.cc
M	src/malloc_hook.cc
M	src/maybe_threads.cc
M	src/maybe_threads.h
M	src/profile-handler.cc
M	src/windows/port.cc
M	src/windows/port.h

commit 215b2d939aebc572d4e44b97fa2b82b992e6fe0c
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Jul 14 01:00:32 2023 -0400

    drop disabled windows-specific spinlock code

M	src/windows/port.h

commit 37fd4adab461c2005b9855ad3d23945590155ae7
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Jul 13 20:54:38 2023 -0400

    use regular off_t on 64-bit linuxes

    off64_t is legacy of the past.

    Update github issue #1407

M	src/malloc_hook_mmap_linux.h

commit 4a923a6b36995adf633fda63d28be05979666920
Author: Gabriel Marin <gmx@chromium.org>
Date:	Thu Aug 23 18:31:16 2018 +0000

    tcmalloc: enable large object pointer offset check

    Original CL: https://chromiumcodereview.appspot.com/10391178

      1. Enable large object pointer offset check in release build.
      Following code will now cause a check error:
      char* p = reinterpret_cast<char*>(malloc(kMaxSize + 1));
      free(p + 1);

      2. Remove a duplicated error reporting function
      "DieFromBadFreePointer",
      can use "InvalidGetAllocatedSize".

    Reviewed-on: https://chromium-review.googlesource.com/1184335
    [alkondratenko@gmail.com] removed some unrelated formatting changes
    Signed-off-by: Aliaksey Kandratsenka <alkondratenko@gmail.com>

M	src/internal_logging.h
M	src/tcmalloc.cc

commit 4b3fc02082a1f89268f44ea2d470f14375bd981e
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Jul 13 18:56:19 2023 -0400

    fix clang barking at debugallocator's magic2_ field

    It barks because we access the field in a special way through address
    computation (see magic2_addr), so it is indeed not accessed
    directly. To emphasize that it comes directly after size2_ we simply
    converted size2 and magic2_ into explicit array size_and_magic2_.

M	src/debugallocation.cc

commit c29e3059dd506f48e15de8af446d2bd89b5867a9
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Jul 13 18:57:22 2023 -0400

    mark CheckCachedSizeClass as used

    It is only used from inside ASSERT and clang doesn't like it being
    declared but unused when NDEBUG is set.

M	src/tcmalloc.cc

commit f7c6835facf58026f6db493433a0837c9dca5b97
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Jul 13 18:21:24 2023 -0400

    drop unused linuxthreads.cc:local_itoa function

M	src/base/linuxthreads.cc

commit 5a3a324459558f793da77bc4c56eaeadedf9dca7
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Jul 13 18:15:25 2023 -0400

    try to avoid certain warnings in tests

    Our tests do explicitly trigger certain "bad" cases. And compilers are
    getting increasingly smarter, so they start giving us warnings. People
    dislike warnings, so lets try to disable them specifically for unit
    tests.

    Refers to issue #1401

M	src/config_for_unittests.h
M	src/tests/debugallocation_test.cc
M	src/tests/profile-handler_unittest.cc

commit e63d2f855de247f78ec11115767a33f689fb9542
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Jul 13 17:45:09 2023 -0400

    avoid semi-bogus use-after-free warning

    In heap checker we actually use test_str address after deletion, to
    verify at runtime that heap checker is indeed tracking deletions. But
    gcc barks. So lets hide allocation from it by calling
    tc_newarray/tc_deletearray.

    Refers to #1401

M	src/heap-checker.cc

commit 9d46f1e8904cfe38f45716ef65e36d611ce8fe21
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Jul 13 17:50:55 2023 -0400

    exercise ASSERTs as part of pagemap_unittest

    This fixes couple gcc warnings (array bounds) when accessing page map
    radix tree.

    Refers to #1401

M	src/tests/pagemap_unittest.cc

commit d2bacb8e36b42af8e889c6c191d7842e3dd8d569
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Jul 13 17:49:23 2023 -0400

    help compiler see that CHECK_CONDITION failures are fatal

    Some compiler warnings are caused by this lack of information to
    compiler.

    Refers to #1401

M	src/internal_logging.h

commit 2ffa4e0841a7eea2906be64a66f36f798559a7a0
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Jul 13 16:07:17 2023 -0400

    unbreak static initialization of initial malloc hooks

    g++ 13 somehow considers reinterpret_cast<uintptr_t>(InitialNewHook)
    as non-constexpr. It then generates runtime constructor for malloc
    hooks, which run too late. That broke heap checker and heap profiler.

    We fix by making array of hooks inside malloc to have proper function
    pointer type, which lets us avoid reinterpret_cast which makes
    construction compile-time again.

M	src/malloc_hook-inl.h
M	src/malloc_hook.cc
M	src/tests/malloc_hook_test.cc

commit 55d559f7c9ea1715db9f0422d589efd7bea6481a
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Jul 13 16:04:14 2023 -0400

    fix flakiness of profile-handler_unittest

    When checking if timer is enabled, we should look at
    it_interval.

M	src/tests/profile-handler_unittest.cc

commit 5ba98e397cc67a3539c40692dfa51ca26b20519c
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Thu Jul 13 16:03:43 2023 -0400

    when CHECK_OP fails print filename and line number

M	src/base/logging.h

commit 9d781627bb79dc164c338c40b8085db10326d9dc
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jul 10 01:58:42 2023 -0400

    avoid calling memory allocator under profile handler signal_lock_

    If we don't avoid there is possibility of deadlock. Like this:

    *) thread A runs malloc and happens to have some lock(s) there. It
    gets profiling signal.

    *) thread B runs ProfileHandler::UnregisterCallback or similar and has
    both control_lock_ and signal_lock_.

    *) thread B calls memory allocator (it used to delete token under
    lock) and hits the malloc lock, so waits

    *) thread A that has malloc lock wants to get signal_lock_ and waits
    too.

    Correct behavior is since we grab signal_lock_ from pretty much
    anywhere as part of signal handler, it then implies transitively that
    anything that grabs that lock cannot call into anything that grabs any
    other lock (e.g. including malloc). I.e. signal_lock_ "nests" under
    every other lock in the program.

    So we refector the code some. When removing callbacks we simply copy
    entire list with right token removed. Then grab signal_lock_ and only
    swap copy with old callback list. Then signal_lock_ lock is released
    and all the memory freeing operations are performed.

    When adding callback we utilize splice to also avoid anything "heavy"
    under signal_lock_.

    And as part of that change we're now able to have UpdateTimer method
    only needing control_lock_ instead of signal_lock_.

    We add somewhat elaborate unit test that was able to catch the issue
    without fix and now works fine.

    Closes github issue #412

M	src/profile-handler.cc
M	src/tests/profile-handler_unittest.cc

commit c44e44cecb64686e8157483b81b0dc29614c935d
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jul 10 00:20:13 2023 -0400

    prevent potential corruption of errno in thread lister

    See
    https://github.com/gperftools/gperftools/issues/500#issuecomment-133814659
    for explanations. We of course evolved quite a bit since that comment,
    but general issue still applies.

M	src/base/linuxthreads.cc

commit 2b5743ffa60affcdc796dcf4bf6c4f5fff14c4de
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Jul 9 18:05:01 2023 -0400

    amputate tcmalloc unittest trylock counting

    We had this logic to ensure that TesterThread succeeds at least 50% of
    times grabbing passed objects lock, apparently to ensure that multiple
    threads actually participate. But this check occasionally flakes. It
    is totally possible that lock owner gets preempted while holding lock
    and other threads accumulate gazillion of failed trylocks. So while it
    is nice to test this somehow, flakes are bad enough, so we drop this
    test.

M	src/tests/tcmalloc_unittest.cc

commit 2d70ea9ad2b90b85db81e78e3c4e0b9e16e7977b
Author: Chris Cambly <ccambly@ca.ibm.com>
Date:	Fri May 14 11:11:48 2021 -0400

    initial batch of changes to enable AIX in 32-bit and 64-bit

    - Some small automake changes. Add libc++ for AIX instead of libstdc++
    - Add the interface changes for AIX:User-defined malloc replacement
    - Add code to avoid use of pthreads library prior to its
    initialization
    - Some small changes to the unittest case
    - Update INSTALL for AIX

    [alkondratenko@gmail.com]: lower-case/de-trailing-dot for commit
    subject line
    [alkondratenko@gmail.com]: rebase
    [alkondratenko@gmail.com]: amputate unused AM_CONDITIONAL for AIX
    [alkondratenko@gmail.com]: explicitly mention libc_override_aix.h
    in Makefile.am

M	INSTALL
M	Makefile.am
M	configure.ac
A	src/libc_override_aix.h
M	src/libc_override_gcc_and_weak.h
M	src/maybe_threads.cc
M	src/stacktrace_powerpc-darwin-inl.h
M	src/static_vars.cc
M	src/tests/tcmalloc_unittest.cc

commit 26927d13334b7a06d3ec9810b7f68a9428c07223
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Jul 9 16:11:51 2023 -0400

    clean up unused link dependencies for malloc_extension_c_test

    We used to explicitly link to libstdc++, libm and even libpthread, but
    this should be handled by libtool since those are dependencies of
    libtcmalloc_minimal. What also helps is we now build everything with
    C++ compiler, not C. So libstdc++ or (libc++) dependency doesn't need
    to be added at all, even if libtool for some reason fails to handle
    it.

M	Makefile.am

commit ea47513a8f8b1b96e0c0e9d776503e2245e45efd
Author: zhangyiru <877061968@qq.com>
Date:	Fri Oct 15 18:21:36 2021 -0400

    avoid memleak exceed int range when using heap-checker

    [alkondratenko@gmail.com] format size_t with %zu
    Signed-off-by: Aliaksey Kandratsenka <alkondratenko@gmail.com>

M	src/heap-profile-table.cc

commit 4ac4d88a99c697fe24fd7b356fb57006c7aaeb57
Author: tigeran <tigeran@tencent.com>
Date:	Tue Jan 10 10:17:30 2023 +0800

    Remove unused using declaration

    std::sort in `heap-profiler.cc` is not in use, so remove it.

M	src/heap-profiler.cc

commit 4e24f4adaa1f0ad982daadb118a5dde321827ad3
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Jul 4 00:37:52 2023 -0400

    fix overflow in c-f-l populate when span address is close to top

    This fixes github issue #1323.

    When populating span with linked list of objects ptr + size <= limit
    condition could overflow before comparing to limit. So fixed code
    carefully tests limit. We also produce version with
    __builtin_add_overflow since this is semi-hot loop and we want it to
    be fast.

M	src/central_freelist.cc

commit f15425dc9916ea451a3915a8311c3bc248b225c0
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jul 3 17:36:47 2023 -0400

    implement SafeStrError and use it inside strerror

    This fixes issue #1371

    From time to time things file inside tcmalloc guts where calling to
    malloc is not safe. Regular strerror does locale bits, so will
    occasionally open files/malloc/etc. We avoid this by using our own
    "safe" variant that hardcodes names of all POSIX errno constants.

M	.gitignore
M	CMakeLists.txt
M	Makefile.am
M	src/debugallocation.cc
M	src/heap-checker.cc
M	src/memfs_malloc.cc
A	src/safe_strerror.cc
A	src/safe_strerror.h
A	src/tests/safe_strerror_test.cc

commit 88d0fd5a3bafb6f82e5786a9c70b4883f75882e7
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jul 3 17:29:13 2023 -0400

    remove dead remains of arm_instruction_set_select header

M	Makefile.am

commit d9cecd6e42d7503b9fe2592ab6d016d5d5832014
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jul 3 16:45:00 2023 -0400

    print errno whenever dumping heap profile fails for some reason

    Refers to issue #1116

M	src/heap-profiler.cc

commit fe5ba4b5242c143661989a15a981079957835c44
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jul 3 16:20:26 2023 -0400

    use sys/ptrace.h instead of linux/ptrace.h

    As was pointed out at
    https://github.com/gperftools/gperftools/pull/1329 there is no need
    for us to depend on linux-headers thingy. Libc headers should be
    enough.

M	src/heap-checker.cc

commit 55e798623fabbdaa67d68959008ba9fcd17ad024
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jul 3 15:31:21 2023 -0400

    unbreak compilation with --disable-cpu-profiler

M	src/stacktrace_generic_fp-inl.h

commit dd89dc7d01e20b83376e30aa0e52cb83c0a8e55e
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jul 3 15:29:56 2023 -0400

    install compat headers and .pc files only with matching libs

    Thix closes issue #1356

M	Makefile.am

commit a63ea13b20baee6df1468c6dfaf8b339471f461b
Author: Ali Saidi <alisaidi@amazon.com>
Date:	Fri Jul 30 12:19:02 2021 -0500

    Add an arm64 implementation for SpinlockPause()

    This patch adds an arm64 implementation of the SpinlockPause()
    function
    allowing the core to adaptively spin to acquire the lock and improving
    performance in multi-threaded environments where the locks can
    be contended.

    From experience with other projects, we've found a single isb is
    the closest
    corollary to the rep; nop timing or x86.

    Overall, across thirty runs, the binary_trees_shared benchmark
    improves 6% in
    average, median, and P90 runtime with this change.

M	src/base/spinlock.cc

commit 3c0738ac1cbe51da438ca01ba74eb751f7080372
Author: Sergey Fedorov <vital.had@gmail.com>
Date:	Mon Jul 3 14:40:59 2023 +0800

    libc_override_osx.h: a small fix for ppc

M	src/libc_override_osx.h

commit cc4e289a8360810a86efd10fc6df6463778a905a
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jul 3 13:02:59 2023 -0400

    drop weakening from cmake build

    Weakening is optional and in github issue #1392 we apparently tried to
    weaken on windows and failed. So lets not even try.

M	CMakeLists.txt
D	cmake/FindObjcopyWithWeaken.cmake

commit 44eb0ee83c3a485cf6af6366d06430fd162d0fa9
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jul 3 12:47:35 2023 -0400

    bump heap profiler stats fields to 64 bit

    People actually seen overflows there. Fixes github issue #1303

M	src/heap-checker.cc
M	src/heap-profile-stats.h
M	src/heap-profile-table.cc
M	src/heap-profiler.cc

commit 972c12f77dfe27253d966a1bb58d10efb79c34c8
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Jul 2 19:21:21 2023 -0400

    refactor stacktrace.cc and drop x86 backtracer

    We had plenty of old and mostly no more correct i386 cruft. Now that
    generic_fp backtracer covers i386 just fine, we can drop explicit x86
    backtracer.

    With that we refactored and simplified stacktrace.cc mostly around
    picking default implementation, but also adding few more minor
    cleanups.

M	CMakeLists.txt
M	Makefile.am
M	src/getpc.h
M	src/stacktrace.cc
M	src/stacktrace_impl_setup-inl.h
D	src/stacktrace_x86-inl.h
M	src/tests/stacktrace_unittest.cc

commit d9b178695f2a60f20fd2ebc6cc50c15e2b6a6a86
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Jul 2 19:43:44 2023 -0400

    support more OSes in generic-fp

    We're still x86+arm+riscv only, but netbsd and freebsd work too. OSX
    as well.

M	src/stacktrace.cc
M	src/stacktrace_generic_fp-inl.h

commit 4b78ffd03cb9a2c3bb7848f766afc964987a5c82
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Jul 2 19:35:46 2023 -0400

    try building with -fno-omit-frame-pointer -momit-leaf-frame-pointer

    The idea is -momit-leaf-frame-pointer gives us performance pretty much
    same as fully omitting frame pointers. And having frame pointers
    elsewhere allows us to support cases when user's code is built with
    frame pointers. We also pass all tests with
    TCMALLOC_STACKTRACE_METHOD=generic_fp (not just libunwind or libgcc).

M	CMakeLists.txt
M	Makefile.am
M	configure.ac
M	src/heap-checker.cc

commit e5ac219780ec940904bc0bafea4bdb59f9e0b650
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Jul 2 19:31:27 2023 -0400

    restore unwind-bench

    We previously deleted it, since it wasn't portable enough. But
    unportable bits are now ifdef-ed out, so we can return it.

M	.gitignore
M	Makefile.am
A	benchmark/unwind_bench.cc

commit cf046c84214cd9e21a836f840dad23a0f8b50665
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Jun 27 23:30:01 2023 -0400

    extend generic frame pointer backtracer to support x86-32 (aka x32)

M	src/stacktrace_generic_fp-inl.h

commit f56c27910a768a4c2b47026a13f507a89c94f491
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Jun 27 23:14:38 2023 -0400

    extend generic frame pointer backtracer to support i386

M	src/stacktrace.cc
M	src/stacktrace_generic_fp-inl.h

commit 58d6842576b35f4ce81d5d7dde389968924a590f
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Jun 27 21:43:43 2023 -0400

    more coverage for stacktrace_unittest

M	src/tests/stacktrace_unittest.cc

commit 25698cd1b811ff8dca54a236571e2a4adba2ed84
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Jun 27 16:37:59 2023 -0400

    improve diagnostics for stacktrace_unittest

M	Makefile.am
M	src/tests/stacktrace_unittest.cc

commit a25e7fa8b0564b17cd592a64b618ea451b990601
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Jul 2 18:11:51 2023 -0400

    cleanup cmake's config.h stuff

    Some header defines were not cmakedefine01.

M	cmake/config.h.in

commit 88d7e65cc2bb0c5e92892d41eec1e4ea9a7bd6fa
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Jun 27 14:08:14 2023 -0400

    drop unused libtool target in our Makefile.am

    Not sure what it was for, but it is not useful today.

M	Makefile.am

commit ae4aafa4689289e42bce4063720d4955b575c176
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jun 28 00:07:49 2023 -0400

    freebsd+x86-64 pc-from-ucontext is not untested

M	cmake/PCFromUContext.cmake
M	m4/pc_from_ucontext.m4

commit cddd759bd1b1ef63d51373afcda76b4cd1dd1a5c
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jun 26 20:33:30 2023 -0400

    disable libgcc stack trace capturing on freebsd

M	CMakeLists.txt
M	configure.ac

commit 4c72b14d35529e989f761050954dc6e4e6d1ca7f
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jun 26 17:37:19 2023 -0400

    support proc maps iterator on NetBSD

    Turns out it's procfs is available by default, and is fairly similar
    to Linux's. So we can just reuse our Linux codes. All tests now pass
    on NetBSD!

M	src/base/sysinfo.cc

commit 7ffd35a54b13238b408dc773282fe64adb30aeb8
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jun 26 19:57:48 2023 -0400

    correctly detect and link to backtrace_symbols

    BSDs need -lexecinfo

M	Makefile.am
M	configure.ac

commit 5b86aa0a51dfaa252c31f971cae487f2e0357955
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jun 26 18:01:58 2023 -0400

    reimplement GetProgramInvocationName via reading /proc/self/exe

    This enables us to support NetBSD, as it lacks
    program_invocation_name, but has fairly full-featured procfs.

M	src/symbolize.cc

commit 50b5219635dafe08e1170956fb025bf1bf1f958b
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jun 26 14:30:05 2023 -0400

    don't NO_INTR close

    This is wrong. See man 2 close.

M	src/base/logging.cc
M	src/base/sysinfo.cc
M	src/tests/profiledata_unittest.cc

commit 7dd1b823786f5953c65bdfb448c7b36447162ec9
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jun 26 14:28:02 2023 -0400

    simplify project by making it C++-only

    I.e. no need for any AC_LANG_PUSH stuff in configure. Most usefully,
    only CXXFLAGS needs to be set now when you need to tweak compile
    flags.

M	CMakeLists.txt
M	Makefile.am
R100	benchmark/run_benchmark.c	benchmark/run_benchmark.cc
M	configure.ac
R096	src/base/dynamic_annotations.c	src/base/dynamic_annotations.cc
R099	src/tests/malloc_extension_c_test.c
src/tests/malloc_extension_c_test.cc
M	vsprojects/addressmap_unittest/addressmap_unittest.vcxproj
M	vsprojects/addressmap_unittest/addressmap_unittest.vcxproj.filters
M	vsprojects/libtcmalloc_minimal/libtcmalloc_minimal.vcxproj
M	vsprojects/libtcmalloc_minimal/libtcmalloc_minimal.vcxproj.filters
M
vsprojects/low_level_alloc_unittest/low_level_alloc_unittest.vcxproj
M
vsprojects/low_level_alloc_unittest/low_level_alloc_unittest.vcxproj.filters
M	vsprojects/page_heap_test/page_heap_test.vcxproj
M	vsprojects/page_heap_test/page_heap_test.vcxproj.filters

commit cf28e0356782fab54f51e4a394e30642c7371bc5
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Jun 27 01:20:01 2023 -0400

    correctly order weakening step to avoid race

    Previously we allowed test programs to be linked at the same time as
    weakening is performed, rewriting the .a archives. So lets be more
    explicit. We weaken after all-am (which "runs" everything including
    libraries and programs), but before all target.

M	Makefile.am

commit a39073886a8e06f441a97b6f2cfb833157dac6c6
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon Jun 26 13:23:20 2023 -0400

    unbreak symbol weakening

    It is kinda minor feature, and apparently we never had it working. But
    is a nice to have. Allows our users to override malloc/free/etc while
    still being able to link to us (for tc_malloc for example). With
    broken weakening we had this use-case broken for static library
    case. And it should now work.

M	Makefile.am
M	cmake/FindObjcopyWithWeaken.cmake
M	configure.ac

commit 630dac81ea55a775044998de69b17a89fa75cacd
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Tue Jun 27 01:43:44 2023 -0400

    implement simpler ChangeLog generation for source tarballs

    We used ax_generate_changelog which works great. But it made our
    makefile require GNU make, which was causing annoyance on bsd systems.

D	ChangeLog
M	Makefile.am
M	configure.ac
D	m4/ax_generate_changelog.m4

commit b30b984281bae0b5a921938b885476e23796f377
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Jun 25 23:38:55 2023 -0400

    [osx] make profiler unittest pass

    somehow VerifyIdentical tests fail for some formatting details. But
    since it tests --raw feature of our deprecated perl pprof
    implementation, which we don't intend supporting anyways, we drop this
    test.

    There is some details about how wc -l returns stuff and how zsh uses
    it to compare to 3. So we now explicitly strip whitespace and it
    works.

M	src/tests/profiler_unittest.sh

commit 7437e0f612ff54bbf837ea3f7f9b366a60dba629
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Jun 25 23:38:44 2023 -0400

    [osx] make heap profiler unittest pass

    Apparently awk's comparison $2 > 90 doesn't work when $2 is 100.0. I
    frobbed it some and it works now.

M	src/tests/heap-profiler_unittest.sh

commit 6683e4f6eeebc52c0704500ef9f461454434578c
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Jun 25 23:37:44 2023 -0400

    [osx] implement native c++ allocation operators on osx

    OSX has really screwed performance for it's memory allocator due to
    their malloc zones stuff. We and our competitors hook into that
    facility instead directly overriding allocation functions. Which has
    massive performance overhead. This is, apparently, so that malloc is
    same as allocating from default zone.

    As a result, osx'es C++ operator new/delete performance is even worse.
    Because we call operator new, it calls malloc, which calls
    malloc_zone_malloc, which calls more stuff and eventually tc_malloc.

    Thankfully, for C++ API there is no need for such "integration"
    between 'stock' memory allocator and malloc zones stuff. So we can
    hook those APIs directly. This speeds up malloc_bench numbers on OSX
    about 3x.

    This change also unbreaks couple tests (e.g. heap profiler unittest)
    which depend on MallocHook_GetCallerStackTrace to return precisely
    stack trace up to memory allocator call.

    Performance-wise, OSX still lacks good TLS and there is still one jump
    indirection even for operator new/delete API due to lack support of
    aliases. So Linux or BSD, or even windows would still be significantly
    faster on malloc performance on same hardware.

M	src/libc_override_osx.h

commit 11d4253ead0f0db77aac0d6f5779416c7ab9efa2
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Jun 25 23:37:10 2023 -0400

    [osx] don't crash debugallocator on 0-sized allocations

    OSX's malloc zones facility is calling 'usable size' before each (!)
    free and uses size to choose between our allocator and something
    else. And returning 0 breaks this choice. Which happens if we got
    0-sized malloc request, which our tests exercise couple times. So we
    don't let debug allocator on OSX to have 0 sized chunks. This unbreaks
    debug allocation tests on OSX.

M	src/debugallocation.cc
M	src/tests/debugallocation_test.cc

commit b0c2ab298adf2be8d9fe23cd7f166cae875e9549
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Jun 25 23:36:08 2023 -0400

    [osx] place malloc-zone-related functions to google_malloc section

    On OSX we hook into "system's" malloc through this zones facility, so
    we need to place those those interface functions into google_malloc
    section. This largely unbreaks MallocHook_GetCallerStackTrace on OSX.

M	src/base/basictypes.h
M	src/libc_override_osx.h

commit 531ca4fdcaebd225b4616fe8a693d26a89019792
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Sun Jun 25 23:35:26 2023 -0400

    [osx] unbreak LowLevelAlloc

    For some reason clang shipped with osx miscompiles LowLevelAlloc when
    it tries to place Alloc methods into malloc_hooks section. But since
    we don't really need that placement on OSX, we can simply drop that
    section placement.

M	src/base/low_level_alloc.h

commit e78238d94d41764dc72edb37e3d6510255d3dcd4
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jun 21 10:39:38 2023 -0400

    reworked heap leak checker for more portability

    In most practical terms, this expands "official" heap leak checker
    support to Linux/arm64 and Linux/riscv (mips-en and legacy arm are
    likely to work & pass tests too now).

    The code is now explicitly Linux-only, without trying to pretend
    otherwise. Main goal of this change is to finally amputate
    linux_syscall_support.h, which we historically had trouble maintaining
    well. Biggest challenge was around thread listing facility which uses
    clone (ptrace explicitly fails between threads) and that causes
    difficulties around parent and child tasks sharing
    errno. linux_syscall_support stuff had special feature to "redirect"
    errno accesses. But it caused us for more trouble. We switched to
    regular syscalls, and errno stamping avoidance is now simply via
    careful programming.

    A number of other cleanups is made (such us thread finding codes in
    procfs which clearly was built for some ages old and odd kernels).

    sem_post/sem_wait synchronization was previously potentially prone to
    deadlock (if parent died at bad time). We now use pipe pair for this
    synchronization and it is fully robust.

M	CMakeLists.txt
M	Makefile.am
M	cmake/config.h.in
M	configure.ac
M	docs/heap_checker.html
D	src/base/elfcore.h
D	src/base/linux_syscall_support.h
M	src/base/linuxthreads.cc
M	src/base/linuxthreads.h
D	src/base/thread_lister.c
D	src/base/thread_lister.h
M	src/gperftools/heap-checker.h
M	src/heap-checker.cc
M	src/tests/heap-checker_unittest.cc
M	src/windows/config.h

commit 21869679878a3d578adb6bc4ed8eaacb9f86ac3c
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jun 21 10:39:35 2023 -0400

    fix heap checker unittest

    We had shell wrapper for heap checker unittest, but it failed to deal
    with heap-checker-debug variant. So we now posix_spawn from .cc test
    instead.

M	CMakeLists.txt
M	Makefile.am
M	src/tests/heap-checker_unittest.cc
D	src/tests/heap-checker_unittest.sh

commit 1c3f0dda1b3f4a5b6ce720604bcea1680e7cbb9a
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jun 21 10:39:31 2023 -0400

    ensure that heap checker initialization actually calls malloc

    I.e. all recent compilers (both gcc and clang) optimize out delete(new
    int) sequence to nothing. We call to tc_new and tc_delete directly to
    suppress this optimization.

M	src/heap-checker-bcad.cc

commit b96dc99dbf322195389bbb43b58941c43c744a49
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jun 21 10:39:28 2023 -0400

    one trivial config cleanup

M	configure.ac
M	src/profile-handler.h

commit b7e47a77c0382544eeef50e8e004932bbcae1c0e
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jun 21 10:39:25 2023 -0400

    simplify heap checker building default to be Linux-only

    This also fixes cmake and freebsd where previously check for freebsd
    wasn't working.

M	CMakeLists.txt
M	configure.ac

commit b58cbd2e23e582059d8d554354d30ef40a93724f
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jun 21 10:39:21 2023 -0400

    make preamble patcher build and run (win64 only)

    First, ml64 (amd64 version of masm) doesn't support /coff. Second, it
    also doesn't support (nor use) .model directive.

    Sadly, asm is inherently amd64-only, so this entire test won't build
    in i386 configuration.

M	src/windows/shortproc.asm
M	vsprojects/preamble_patcher_test/preamble_patcher_test.vcxproj

commit 54605b8a5807fe893a4b9ff8def982a264cdc6c9
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jun 21 10:39:18 2023 -0400

    amputate old atomic ops implementation

M	.gitignore
M	CMakeLists.txt
M	Makefile.am
M	cmake/config.h.in
M	configure.ac
D	src/base/arm_instruction_set_select.h
D	src/base/atomicops-internals-arm-generic.h
D	src/base/atomicops-internals-arm-v6plus.h
D	src/base/atomicops-internals-gcc.h
D	src/base/atomicops-internals-linuxppc.h
D	src/base/atomicops-internals-macosx.h
D	src/base/atomicops-internals-mips.h
D	src/base/atomicops-internals-windows.h
D	src/base/atomicops-internals-x86.cc
D	src/base/atomicops-internals-x86.h
D	src/base/atomicops.h
M	src/base/spinlock.h
M	src/base/spinlock_internal.cc
M	src/base/spinlock_internal.h
M	src/base/spinlock_posix-inl.h
M	src/base/vdso_support.cc
M	src/malloc_hook-inl.h
D	src/tests/atomicops_unittest.cc
M	src/windows/config.h
M	vsprojects/addressmap_unittest/addressmap_unittest.vcxproj
M	vsprojects/addressmap_unittest/addressmap_unittest.vcxproj.filters
M	vsprojects/libtcmalloc_minimal/libtcmalloc_minimal.vcxproj
M	vsprojects/libtcmalloc_minimal/libtcmalloc_minimal.vcxproj.filters
M
vsprojects/low_level_alloc_unittest/low_level_alloc_unittest.vcxproj
M
vsprojects/low_level_alloc_unittest/low_level_alloc_unittest.vcxproj.filters
M	vsprojects/packed-cache_test/packed-cache_test.vcxproj
M	vsprojects/packed-cache_test/packed-cache_test.vcxproj.filters

commit ea0988b02033627b03521435b689483b38600136
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jun 21 10:39:14 2023 -0400

    port spinlocks atomic ops usage to std::atomic

M	src/base/spinlock.cc
M	src/base/spinlock.h
M	src/base/spinlock_internal.h
M	src/base/spinlock_linux-inl.h
M	src/base/spinlock_win32-inl.h

commit 3494eb29d629363b84eb7fcd23f8fc1c049c403e
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jun 21 10:39:11 2023 -0400

    switch malloc hooks to std::atomic

    This makes our code one step closer to killing unportable custom
    atomics implementation. I did manually inspect generated code that
    fast-path is identical and slow path's changes of generated code are
    cosmetic.

M	src/malloc_hook-inl.h
M	src/malloc_hook.cc
M	src/tests/malloc_hook_test.cc

commit 0e21f36843279581e5fddda97fb797e93c1dc210
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jun 21 10:39:07 2023 -0400

    unbreak frame skipping in generic-fp backtrace method

M	src/stacktrace_generic_fp-inl.h
M	src/tests/stacktrace_unittest.cc

commit 6f3cacf698c1f3aaa5f21812c83541ee4d565147
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jun 21 10:39:04 2023 -0400

    stacktrace_unittest: test backtracing from signals more reliably

    Somehow I originally choose to segfault to test this, and it caused us
    to deal with 'skipping over' null pointer access. Which ended up not
    so easy to do semi-portably. But easier way is to do same
    itimer/sigprof thing that we do in actual profiler.

    We're still somewhat at the mercy of compiler placing code "normally",
    but this implementation seems more robust anyways.

M	src/tests/stacktrace_unittest.cc

commit 68b442714a86060d1dd95de4c515cc7774e3751e
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jun 21 10:39:00 2023 -0400

    stop working around obsolete compilation bug

    This was targeting (some obsure and perhaps even Google-internal
    version) of now-ancient compiler. No need to keep this anymore.

M	src/central_freelist.cc

commit 16889f6ddb51fdae833455ed9d000bc0951fd8d4
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jun 21 10:38:56 2023 -0400

    fix minor clang warning

M	src/central_freelist.cc

commit 246782e1d62d6c10343a955c102b48c3d507d4cb
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jun 21 10:38:52 2023 -0400

    use more noopt in various unit tests

    Many our unit tests require specific stack traces or that
    allocation/deallocation is not elimininated. As compilation gets more
    aggressive (such as when cross-object optimization is enabled during
    LTO), we break more of those cases.

    This commit extends noopt usage that disables inlining optimization in
    specific cases. This fixes github issue #1358.

M	src/tests/sampling_test.cc
M	src/tests/tcmalloc_large_unittest.cc
M	src/tests/tcmalloc_unittest.cc
M	src/tests/testutil.h

commit 6bdeec0ecb0ae49a5277897b60492d4f6d0acac4
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jun 21 10:38:44 2023 -0400

    mark stacktrace capturing functions as noinline

    It is required for LTO builds, specifically it fixes
    stacktrace_unittest. This is because API of stacktrace capturing
    functions implicitly assumes that those are not inlined.

    Refers to github issue #1358.

M	src/stacktrace.cc

commit 777182fbdf37f24627410389f829d3bf7d86367a
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jun 21 10:38:40 2023 -0400

    enable ATTRIBUTE_NOINLINE for MSVC

M	src/base/basictypes.h

commit 9bde8d837b8ed2a17ddd1206ae03e9b2265a85ee
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jun 21 10:38:35 2023 -0400

    unbreak building with visual studio clang platform toolset

M	src/windows/mini_disassembler_types.h
M	src/windows/patch_functions.cc

commit 0451d21e83483060d6c3e727ff2554692f5bc16e
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jun 21 10:38:31 2023 -0400

    use libunwind when it actually works

    Previously we blindly tried to use libunwind whenever header is
    detected. Even if actually working libunwind library is missing. This
    is now fixed, so we attempt to use libunwind when it actually works.

    Somehow recent freebsd ships libunwind.h (which seems to belong to
    llvm's implementation), but apparently without matching .so. So
    then building
    and linking failed.

M	CMakeLists.txt
M	cmake/config.h.in
M	configure.ac
M	src/stacktrace.cc

commit 90eff0637bf17a8df2665287fc0b523b48e5fa92
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jun 21 10:38:26 2023 -0400

    upgrade malloc bench away from std::random_shuffle

    C++17 dropped it, so we use C++11 and later std::shuffle
    instead. Fixes github issue #1378

M	benchmark/malloc_bench.cc

commit b501806f2af8be4b83527cbb7bd6afa040d818d5
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jun 21 23:08:25 2023 -0400

    fix malloc_bench on clang

    We got bitten again by compiler optimizing out free(malloc(sz))
    combination. We replace calls to malloc/free with calls to global
    function operator new/delete. Those are apparently forbidden by
    standard to be optimized out.

M	benchmark/malloc_bench.cc

commit ff68bcab609b1e99a7a0f3f73693b0873c4f3001
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jun 21 23:03:33 2023 -0400

    [benchmark] detect iterations overflow

    If for some reason benchmark function is too fast (like when it got
    optimized out to nothing), we'd previously hang in infinite loop. Now
    we'll catch this condition due to iterations count overflowing.

M	benchmark/run_benchmark.c

commit e003e91b742e5e65645d80c684d14eacaecdc0f1
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jun 21 10:38:22 2023 -0400

    drop dependency on PTHREAD_CREATE_JOINABLE

M	CMakeLists.txt
M	cmake/config.h.in
M	src/tests/profile-handler_unittest.cc
M	src/windows/config.h

commit 8fc84c29a34a5feaa928e5027a1c0ba028a57b15
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jun 21 10:38:15 2023 -0400

    mix thread stack address into sampler

    This fixes test failures on freebsd (assert that sampler is seeded
    with non-0 value).

M	src/thread_cache.cc

commit d9b14b9da1a3e0fc55286390aa2ab2490d7eee3d
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jun 21 10:38:03 2023 -0400

    actually test malloc/free from InitLateMaybeRecursive

    This days compilers ~always optimize out free(malloc(N)) to nothing.

M	src/static_vars.cc
M	src/thread_cache.cc

commit a80ce7b0e1510577c21a38dfb5596ddc27c59bdf
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jun 21 10:37:58 2023 -0400

    slow down profiler_unittest some more

    On modern machines xoring volatile int is fast enough to occasionally
    make specific test case's profiling results not stable enough. So we
    now force atomics into the picture which is slightly slower (could be
    lots on some platforms and/or optimizer flags).

M	src/tests/profiler_unittest.cc

commit c37f6c4c7c83027e920fa422b471203501be7a13
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jun 21 10:37:51 2023 -0400

    fix deprecated autoconf bits

    As part of that we also upgrade required autoconf version to 2.69
    which is what I see in rhel/centos 7 and ubuntu 14.04. Both are old
    enough. And, of course, .tar.gz releases still ship "packaged"
    configure,
    so will work on older distros.

    This fixes issue #1335.

M	cmake/config.h.in
M	configure.ac
M	m4/ac_have_attribute.m4
M	m4/acx_nanosleep.m4
D	m4/acx_pthread.m4
A	m4/ax_pthread.m4
M	m4/pc_from_ucontext.m4
M	m4/program_invocation_name.m4
M	src/windows/config.h

commit f06052d7362f5d71e8674d3cf46f761c793321e1
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Wed Jun 21 10:22:39 2023 -0400

    synchronize ucontext-from-pc tests autoconf -> cmake

    Refers to github issue #1398.

M	cmake/PCFromUContext.cmake

commit 5e923877aaee4ec4bece60148dadcba7ea1f86e6
Author: Henrik Reinstädtler <reinstaedtler@stud.uni-heidelberg.de>
Date:	Mon Jun 19 18:11:10 2023 +0200

    Fix uc_mcontext for apple silicon

M	cmake/PCFromUContext.cmake

commit bf8b714bf5075d0a6f2f28504b43095e2b1e11c5
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon May 30 21:21:21 2022 -0700

    bump version to 2.10

M	CMakeLists.txt
M	NEWS
M	configure.ac
M	src/windows/config.h
M	src/windows/gperftools/tcmalloc.h

commit 9d44463380716ebad2f8ba13ce8a737f22bb2602
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon May 30 20:33:18 2022 -0700

    Remove basic support for Elbrus 2000 (e2k)

    This reverts commit 3b1c60cc4ea737ff151977dbcd164c5e2eb859fb.

M	cmake/PCFromUContext.cmake
M	m4/pc_from_ucontext.m4
M	src/base/basictypes.h
M	src/malloc_hook_mmap_linux.h

commit 6c99def347460adbb9f17815feb641cf5474548e
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Mon May 30 19:50:19 2022 -0700

    avoid casting NULL to uinptr_t

    Which somehow fails to compile on musl. Fixes issue #1338.

M	src/heap-checker.cc

commit fe85bbdf4cb891a67a8e2109c1c22a33aa958c7e
Author: Jingyun Hua <huajingyun@loongson.cn>
Date:	Tue Feb 8 20:47:10 2022 +0800

    Add support for LoongArch.

    Only 64-bit is supported at the moment.

    Signed-off-by: Jingyun Hua <huajingyun@loongson.cn>

M	m4/pc_from_ucontext.m4
M	src/base/basictypes.h
M	src/base/linux_syscall_support.h
M	src/base/linuxthreads.h
M	src/malloc_hook_mmap_linux.h
M	src/stacktrace.cc
M	src/tcmalloc.cc

commit e80652b6279a22bd4a4264e4403cd1981293e82f
Author: Aliaksey Kandratsenka <alkondratenko@gmail.com>
Date:	Fri Jan 14 23:08:57 2022 -0800

    ship cmake bits with tar.gz distribution

    Fixes issue #1321.

M	Makefile.am

commit 003775aa816cb3fe01215455825245089d423a7c
Author: Volodymyr Nikolaichuk <nikolaychuk.volodymyr@gmail.com>
Date:	Wed Sep 15 01:17:51 2021 +0300

    free memory with mmap(PROT_NONE, MAP_FIXED)

M	src/system-alloc.cc

commit 852fb6df031560c5e353b497222b76394190e27d
Author: Natale Patriciello <natale.patriciello@vonage.com>
Date:	Thu Nov 18 18:16:40 2021 +0100

